#include "src/builtins/builtins-array-gen.h"
#include "src/builtins/builtins-bigint-gen.h"
#include "src/builtins/builtins-collections-gen.h"
#include "src/builtins/builtins-constructor-gen.h"
#include "src/builtins/builtins-data-view-gen.h"
#include "src/builtins/builtins-iterator-gen.h"
#include "src/builtins/builtins-promise-gen.h"
#include "src/builtins/builtins-promise.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-utils-gen.h"
#include "src/builtins/builtins.h"
#include "src/codegen/code-factory.h"
#include "src/heap/factory-inl.h"
#include "src/objects/arguments.h"
#include "src/objects/bigint.h"
#include "src/objects/elements-kind.h"
#include "src/objects/free-space.h"
#include "src/objects/js-break-iterator.h"
#include "src/objects/js-collator.h"
#include "src/objects/js-date-time-format.h"
#include "src/objects/js-display-names.h"
#include "src/objects/js-generator.h"
#include "src/objects/js-list-format.h"
#include "src/objects/js-locale.h"
#include "src/objects/js-number-format.h"
#include "src/objects/js-objects.h"
#include "src/objects/js-plural-rules.h"
#include "src/objects/js-promise.h"
#include "src/objects/js-regexp-string-iterator.h"
#include "src/objects/js-relative-time-format.h"
#include "src/objects/js-segment-iterator.h"
#include "src/objects/js-segmenter.h"
#include "src/objects/js-weak-refs.h"
#include "src/objects/objects.h"
#include "src/objects/ordered-hash-table.h"
#include "src/objects/property-array.h"
#include "src/objects/property-descriptor-object.h"
#include "src/objects/source-text-module.h"
#include "src/objects/stack-frame-info.h"
#include "src/objects/synthetic-module.h"
#include "src/objects/template-objects.h"
#include "src/torque/runtime-support.h"
#include "torque-generated/../../deps/v8/src/builtins/array-copywithin-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-from-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-isarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-join-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-lastindexof-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-map-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-right-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reverse-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-shift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-splice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-unshift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/base-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/bigint-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/boolean-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/builtins-string-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/collections-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/cast-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/convert-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/console-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/data-view-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/frames-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/frame-arguments-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/growable-fixed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/internal-coverage-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/math-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/number-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-fromentries-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/promise-abstract-operations-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/promise-all-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/promise-all-element-closure-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/promise-constructor-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/promise-finally-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/promise-misc-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/promise-race-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/promise-reaction-job-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/promise-resolve-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/promise-then-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/promise-jobs-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-constructor-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-delete-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-has-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-is-extensible-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-prevent-extensions-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revocable-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revoke-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/reflect-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-exec-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-all-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-replace-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-search-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-source-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-split-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-test-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-endswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-html-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-pad-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-repeat-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-replaceall-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-startswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-substring-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-substr-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/symbol-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/torque-internal-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-createtypedarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-from-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduceright-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-set-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-sort-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-subarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/ic/handler-configuration-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/allocation-site-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/api-callbacks-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/arguments-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/cell-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/code-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/contexts-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/data-handler-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/debug-objects-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/descriptor-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/embedder-data-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/feedback-cell-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/feedback-vector-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/fixed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/foreign-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/free-space-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/heap-number-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/heap-object-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/js-array-buffer-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/js-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/js-collection-iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/js-collection-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/js-generator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/js-objects-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/js-promise-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/js-proxy-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/js-regexp-string-iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/js-regexp-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/js-weak-refs-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/literal-objects-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/map-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/microtask-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/module-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/name-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/oddball-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/ordered-hash-table-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/primitive-heap-object-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/promise-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/property-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/property-cell-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/property-descriptor-object-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/prototype-info-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/regexp-match-info-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/scope-info-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/script-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/shared-function-info-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/source-text-module-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/stack-frame-info-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/string-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/struct-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/synthetic-module-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/template-objects-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/template-tq-csa.h"
#include "torque-generated/../../deps/v8/src/wasm/wasm-objects-tq-csa.h"
#include "torque-generated/../../deps/v8/test/torque/test-torque-tq-csa.h"
#include "torque-generated/../../deps/v8/third_party/v8/builtins/array-sort-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/intl-objects-tq-csa.h"

namespace v8 {
namespace internal {

TF_BUILTIN(ArrayFindIndexLoopEagerDeoptContinuation, CodeStubAssembler) {
  compiler::CodeAssemblerState* state_ = state();  compiler::CodeAssembler ca_(state());
  TNode<NativeContext> parameter0 = UncheckedCast<NativeContext>(Parameter(Descriptor::kContext));
  USE(parameter0);
  TNode<Object> parameter1 = UncheckedCast<Object>(Parameter(Descriptor::kReceiver));
USE(parameter1);
  TNode<Object> parameter2 = UncheckedCast<Object>(Parameter(Descriptor::kCallback));
  USE(parameter2);
  TNode<Object> parameter3 = UncheckedCast<Object>(Parameter(Descriptor::kThisArg));
  USE(parameter3);
  TNode<Object> parameter4 = UncheckedCast<Object>(Parameter(Descriptor::kInitialK));
  USE(parameter4);
  TNode<Object> parameter5 = UncheckedCast<Object>(Parameter(Descriptor::kLength));
  USE(parameter5);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Object, Object, Object, Object> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Object, Object, Object, Object, Object, NativeContext> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Object, Object, Object, Object, Object, NativeContext, JSReceiver> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Object, Object, Object, Object, JSReceiver, Object, NativeContext> block8(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Object, Object, Object, Object, JSReceiver, Object, NativeContext, JSReceiver> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Object, Object, Object, Object, JSReceiver, JSReceiver, Object> block12(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Object, Object, Object, Object, JSReceiver, JSReceiver, Object, Number> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Object, Object, Object, Object, JSReceiver, JSReceiver, Number, Object> block16(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Object, Object, Object, Object, JSReceiver, JSReceiver, Number, Object, Number> block15(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, parameter0, parameter1, parameter2, parameter3, parameter4, parameter5);

  if (block0.is_used()) {
    TNode<NativeContext> tmp0;
    TNode<Object> tmp1;
    TNode<Object> tmp2;
    TNode<Object> tmp3;
    TNode<Object> tmp4;
    TNode<Object> tmp5;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4, &tmp5);
    TNode<JSReceiver> tmp6;
    USE(tmp6);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp6 = Cast_JSReceiver_1(state_, TNode<Context>{tmp0}, TNode<Object>{tmp1}, &label0);
    ca_.Goto(&block3, tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp1, tmp0, tmp6);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block4, tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp1, tmp0);
    }
  }

  if (block4.is_used()) {
    TNode<NativeContext> tmp7;
    TNode<Object> tmp8;
    TNode<Object> tmp9;
    TNode<Object> tmp10;
    TNode<Object> tmp11;
    TNode<Object> tmp12;
    TNode<Object> tmp13;
    TNode<NativeContext> tmp14;
    ca_.Bind(&block4, &tmp7, &tmp8, &tmp9, &tmp10, &tmp11, &tmp12, &tmp13, &tmp14);
    CodeStubAssembler(state_).Unreachable();
  }

  if (block3.is_used()) {
    TNode<NativeContext> tmp15;
    TNode<Object> tmp16;
    TNode<Object> tmp17;
    TNode<Object> tmp18;
    TNode<Object> tmp19;
    TNode<Object> tmp20;
    TNode<Object> tmp21;
    TNode<NativeContext> tmp22;
    TNode<JSReceiver> tmp23;
    ca_.Bind(&block3, &tmp15, &tmp16, &tmp17, &tmp18, &tmp19, &tmp20, &tmp21, &tmp22, &tmp23);
    TNode<JSReceiver> tmp24;
    USE(tmp24);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp24 = Cast_Callable_1(state_, TNode<Context>{tmp15}, TNode<Object>{tmp17}, &label0);
    ca_.Goto(&block7, tmp15, tmp16, tmp17, tmp18, tmp19, tmp20, tmp23, tmp17, tmp15, tmp24);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block8, tmp15, tmp16, tmp17, tmp18, tmp19, tmp20, tmp23, tmp17, tmp15);
    }
  }

  if (block8.is_used()) {
    TNode<NativeContext> tmp25;
    TNode<Object> tmp26;
    TNode<Object> tmp27;
    TNode<Object> tmp28;
    TNode<Object> tmp29;
    TNode<Object> tmp30;
    TNode<JSReceiver> tmp31;
    TNode<Object> tmp32;
    TNode<NativeContext> tmp33;
    ca_.Bind(&block8, &tmp25, &tmp26, &tmp27, &tmp28, &tmp29, &tmp30, &tmp31, &tmp32, &tmp33);
    CodeStubAssembler(state_).Unreachable();
  }

  if (block7.is_used()) {
    TNode<NativeContext> tmp34;
    TNode<Object> tmp35;
    TNode<Object> tmp36;
    TNode<Object> tmp37;
    TNode<Object> tmp38;
    TNode<Object> tmp39;
    TNode<JSReceiver> tmp40;
    TNode<Object> tmp41;
    TNode<NativeContext> tmp42;
    TNode<JSReceiver> tmp43;
    ca_.Bind(&block7, &tmp34, &tmp35, &tmp36, &tmp37, &tmp38, &tmp39, &tmp40, &tmp41, &tmp42, &tmp43);
    TNode<Number> tmp44;
    USE(tmp44);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp44 = Cast_Number_0(state_, TNode<Object>{tmp38}, &label0);
    ca_.Goto(&block11, tmp34, tmp35, tmp36, tmp37, tmp38, tmp39, tmp40, tmp43, tmp38, tmp44);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block12, tmp34, tmp35, tmp36, tmp37, tmp38, tmp39, tmp40, tmp43, tmp38);
    }
  }

  if (block12.is_used()) {
    TNode<NativeContext> tmp45;
    TNode<Object> tmp46;
    TNode<Object> tmp47;
    TNode<Object> tmp48;
    TNode<Object> tmp49;
    TNode<Object> tmp50;
    TNode<JSReceiver> tmp51;
    TNode<JSReceiver> tmp52;
    TNode<Object> tmp53;
    ca_.Bind(&block12, &tmp45, &tmp46, &tmp47, &tmp48, &tmp49, &tmp50, &tmp51, &tmp52, &tmp53);
    CodeStubAssembler(state_).Unreachable();
  }

  if (block11.is_used()) {
    TNode<NativeContext> tmp54;
    TNode<Object> tmp55;
    TNode<Object> tmp56;
    TNode<Object> tmp57;
    TNode<Object> tmp58;
    TNode<Object> tmp59;
    TNode<JSReceiver> tmp60;
    TNode<JSReceiver> tmp61;
    TNode<Object> tmp62;
    TNode<Number> tmp63;
    ca_.Bind(&block11, &tmp54, &tmp55, &tmp56, &tmp57, &tmp58, &tmp59, &tmp60, &tmp61, &tmp62, &tmp63);
    TNode<Number> tmp64;
    USE(tmp64);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp64 = Cast_Number_0(state_, TNode<Object>{tmp59}, &label0);
    ca_.Goto(&block15, tmp54, tmp55, tmp56, tmp57, tmp58, tmp59, tmp60, tmp61, tmp63, tmp59, tmp64);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block16, tmp54, tmp55, tmp56, tmp57, tmp58, tmp59, tmp60, tmp61, tmp63, tmp59);
    }
  }

  if (block16.is_used()) {
    TNode<NativeContext> tmp65;
    TNode<Object> tmp66;
    TNode<Object> tmp67;
    TNode<Object> tmp68;
    TNode<Object> tmp69;
    TNode<Object> tmp70;
    TNode<JSReceiver> tmp71;
    TNode<JSReceiver> tmp72;
    TNode<Number> tmp73;
    TNode<Object> tmp74;
    ca_.Bind(&block16, &tmp65, &tmp66, &tmp67, &tmp68, &tmp69, &tmp70, &tmp71, &tmp72, &tmp73, &tmp74);
    CodeStubAssembler(state_).Unreachable();
  }

  if (block15.is_used()) {
    TNode<NativeContext> tmp75;
    TNode<Object> tmp76;
    TNode<Object> tmp77;
    TNode<Object> tmp78;
    TNode<Object> tmp79;
    TNode<Object> tmp80;
    TNode<JSReceiver> tmp81;
    TNode<JSReceiver> tmp82;
    TNode<Number> tmp83;
    TNode<Object> tmp84;
    TNode<Number> tmp85;
    ca_.Bind(&block15, &tmp75, &tmp76, &tmp77, &tmp78, &tmp79, &tmp80, &tmp81, &tmp82, &tmp83, &tmp84, &tmp85);
    TNode<Number> tmp86;
    tmp86 = TORQUE_CAST(CodeStubAssembler(state_).CallBuiltin(Builtins::kArrayFindIndexLoopContinuation, tmp75, tmp81, tmp82, tmp78, tmp81, tmp83, tmp85));
    USE(tmp86);
    CodeStubAssembler(state_).Return(tmp86);
  }
}

TF_BUILTIN(ArrayFindIndexLoopLazyDeoptContinuation, CodeStubAssembler) {
  compiler::CodeAssemblerState* state_ = state();  compiler::CodeAssembler ca_(state());
  TNode<NativeContext> parameter0 = UncheckedCast<NativeContext>(Parameter(Descriptor::kContext));
  USE(parameter0);
  TNode<Object> parameter1 = UncheckedCast<Object>(Parameter(Descriptor::kReceiver));
USE(parameter1);
  TNode<Object> parameter2 = UncheckedCast<Object>(Parameter(Descriptor::kCallback));
  USE(parameter2);
  TNode<Object> parameter3 = UncheckedCast<Object>(Parameter(Descriptor::kThisArg));
  USE(parameter3);
  TNode<Object> parameter4 = UncheckedCast<Object>(Parameter(Descriptor::kInitialK));
  USE(parameter4);
  TNode<Object> parameter5 = UncheckedCast<Object>(Parameter(Descriptor::kLength));
  USE(parameter5);
  TNode<Object> parameter6 = UncheckedCast<Object>(Parameter(Descriptor::kResult));
  USE(parameter6);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Object, Object, Object, Object, Object> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, parameter0, parameter1, parameter2, parameter3, parameter4, parameter5, parameter6);

  if (block0.is_used()) {
    TNode<NativeContext> tmp0;
    TNode<Object> tmp1;
    TNode<Object> tmp2;
    TNode<Object> tmp3;
    TNode<Object> tmp4;
    TNode<Object> tmp5;
    TNode<Object> tmp6;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4, &tmp5, &tmp6);
    CodeStubAssembler(state_).Unreachable();
  }
}

TF_BUILTIN(ArrayFindIndexLoopAfterCallbackLazyDeoptContinuation, CodeStubAssembler) {
  compiler::CodeAssemblerState* state_ = state();  compiler::CodeAssembler ca_(state());
  TNode<NativeContext> parameter0 = UncheckedCast<NativeContext>(Parameter(Descriptor::kContext));
  USE(parameter0);
  TNode<Object> parameter1 = UncheckedCast<Object>(Parameter(Descriptor::kReceiver));
USE(parameter1);
  TNode<Object> parameter2 = UncheckedCast<Object>(Parameter(Descriptor::kCallback));
  USE(parameter2);
  TNode<Object> parameter3 = UncheckedCast<Object>(Parameter(Descriptor::kThisArg));
  USE(parameter3);
  TNode<Object> parameter4 = UncheckedCast<Object>(Parameter(Descriptor::kInitialK));
  USE(parameter4);
  TNode<Object> parameter5 = UncheckedCast<Object>(Parameter(Descriptor::kLength));
  USE(parameter5);
  TNode<Object> parameter6 = UncheckedCast<Object>(Parameter(Descriptor::kFoundValue));
  USE(parameter6);
  TNode<Object> parameter7 = UncheckedCast<Object>(Parameter(Descriptor::kIsFound));
  USE(parameter7);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Object, Object, Object, Object, Object, Object> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Object, Object, Object, Object, Object, Object, Object, NativeContext> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Object, Object, Object, Object, Object, Object, Object, NativeContext, JSReceiver> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Object, Object, Object, Object, Object, Object, JSReceiver, Object, NativeContext> block8(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Object, Object, Object, Object, Object, Object, JSReceiver, Object, NativeContext, JSReceiver> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Object, Object, Object, Object, Object, Object, JSReceiver, JSReceiver, Object> block12(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Object, Object, Object, Object, Object, Object, JSReceiver, JSReceiver, Object, Number> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Object, Object, Object, Object, Object, Object, JSReceiver, JSReceiver, Number, Object> block16(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Object, Object, Object, Object, Object, Object, JSReceiver, JSReceiver, Number, Object, Number> block15(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Object, Object, Object, Object, Object, Object, JSReceiver, JSReceiver, Number, Number> block17(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<NativeContext, Object, Object, Object, Object, Object, Object, Object, JSReceiver, JSReceiver, Number, Number> block18(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, parameter0, parameter1, parameter2, parameter3, parameter4, parameter5, parameter6, parameter7);

  if (block0.is_used()) {
    TNode<NativeContext> tmp0;
    TNode<Object> tmp1;
    TNode<Object> tmp2;
    TNode<Object> tmp3;
    TNode<Object> tmp4;
    TNode<Object> tmp5;
    TNode<Object> tmp6;
    TNode<Object> tmp7;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4, &tmp5, &tmp6, &tmp7);
    TNode<JSReceiver> tmp8;
    USE(tmp8);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp8 = Cast_JSReceiver_1(state_, TNode<Context>{tmp0}, TNode<Object>{tmp1}, &label0);
    ca_.Goto(&block3, tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp6, tmp7, tmp1, tmp0, tmp8);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block4, tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp6, tmp7, tmp1, tmp0);
    }
  }

  if (block4.is_used()) {
    TNode<NativeContext> tmp9;
    TNode<Object> tmp10;
    TNode<Object> tmp11;
    TNode<Object> tmp12;
    TNode<Object> tmp13;
    TNode<Object> tmp14;
    TNode<Object> tmp15;
    TNode<Object> tmp16;
    TNode<Object> tmp17;
    TNode<NativeContext> tmp18;
    ca_.Bind(&block4, &tmp9, &tmp10, &tmp11, &tmp12, &tmp13, &tmp14, &tmp15, &tmp16, &tmp17, &tmp18);
    CodeStubAssembler(state_).Unreachable();
  }

  if (block3.is_used()) {
    TNode<NativeContext> tmp19;
    TNode<Object> tmp20;
    TNode<Object> tmp21;
    TNode<Object> tmp22;
    TNode<Object> tmp23;
    TNode<Object> tmp24;
    TNode<Object> tmp25;
    TNode<Object> tmp26;
    TNode<Object> tmp27;
    TNode<NativeContext> tmp28;
    TNode<JSReceiver> tmp29;
    ca_.Bind(&block3, &tmp19, &tmp20, &tmp21, &tmp22, &tmp23, &tmp24, &tmp25, &tmp26, &tmp27, &tmp28, &tmp29);
    TNode<JSReceiver> tmp30;
    USE(tmp30);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp30 = Cast_Callable_1(state_, TNode<Context>{tmp19}, TNode<Object>{tmp21}, &label0);
    ca_.Goto(&block7, tmp19, tmp20, tmp21, tmp22, tmp23, tmp24, tmp25, tmp26, tmp29, tmp21, tmp19, tmp30);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block8, tmp19, tmp20, tmp21, tmp22, tmp23, tmp24, tmp25, tmp26, tmp29, tmp21, tmp19);
    }
  }

  if (block8.is_used()) {
    TNode<NativeContext> tmp31;
    TNode<Object> tmp32;
    TNode<Object> tmp33;
    TNode<Object> tmp34;
    TNode<Object> tmp35;
    TNode<Object> tmp36;
    TNode<Object> tmp37;
    TNode<Object> tmp38;
    TNode<JSReceiver> tmp39;
    TNode<Object> tmp40;
    TNode<NativeContext> tmp41;
    ca_.Bind(&block8, &tmp31, &tmp32, &tmp33, &tmp34, &tmp35, &tmp36, &tmp37, &tmp38, &tmp39, &tmp40, &tmp41);
    CodeStubAssembler(state_).Unreachable();
  }

  if (block7.is_used()) {
    TNode<NativeContext> tmp42;
    TNode<Object> tmp43;
    TNode<Object> tmp44;
    TNode<Object> tmp45;
    TNode<Object> tmp46;
    TNode<Object> tmp47;
    TNode<Object> tmp48;
    TNode<Object> tmp49;
    TNode<JSReceiver> tmp50;
    TNode<Object> tmp51;
    TNode<NativeContext> tmp52;
    TNode<JSReceiver> tmp53;
    ca_.Bind(&block7, &tmp42, &tmp43, &tmp44, &tmp45, &tmp46, &tmp47, &tmp48, &tmp49, &tmp50, &tmp51, &tmp52, &tmp53);
    TNode<Number> tmp54;
    USE(tmp54);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp54 = Cast_Number_0(state_, TNode<Object>{tmp46}, &label0);
    ca_.Goto(&block11, tmp42, tmp43, tmp44, tmp45, tmp46, tmp47, tmp48, tmp49, tmp50, tmp53, tmp46, tmp54);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block12, tmp42, tmp43, tmp44, tmp45, tmp46, tmp47, tmp48, tmp49, tmp50, tmp53, tmp46);
    }
  }

  if (block12.is_used()) {
    TNode<NativeContext> tmp55;
    TNode<Object> tmp56;
    TNode<Object> tmp57;
    TNode<Object> tmp58;
    TNode<Object> tmp59;
    TNode<Object> tmp60;
    TNode<Object> tmp61;
    TNode<Object> tmp62;
    TNode<JSReceiver> tmp63;
    TNode<JSReceiver> tmp64;
    TNode<Object> tmp65;
    ca_.Bind(&block12, &tmp55, &tmp56, &tmp57, &tmp58, &tmp59, &tmp60, &tmp61, &tmp62, &tmp63, &tmp64, &tmp65);
    CodeStubAssembler(state_).Unreachable();
  }

  if (block11.is_used()) {
    TNode<NativeContext> tmp66;
    TNode<Object> tmp67;
    TNode<Object> tmp68;
    TNode<Object> tmp69;
    TNode<Object> tmp70;
    TNode<Object> tmp71;
    TNode<Object> tmp72;
    TNode<Object> tmp73;
    TNode<JSReceiver> tmp74;
    TNode<JSReceiver> tmp75;
    TNode<Object> tmp76;
    TNode<Number> tmp77;
    ca_.Bind(&block11, &tmp66, &tmp67, &tmp68, &tmp69, &tmp70, &tmp71, &tmp72, &tmp73, &tmp74, &tmp75, &tmp76, &tmp77);
    TNode<Number> tmp78;
    USE(tmp78);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp78 = Cast_Number_0(state_, TNode<Object>{tmp71}, &label0);
    ca_.Goto(&block15, tmp66, tmp67, tmp68, tmp69, tmp70, tmp71, tmp72, tmp73, tmp74, tmp75, tmp77, tmp71, tmp78);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block16, tmp66, tmp67, tmp68, tmp69, tmp70, tmp71, tmp72, tmp73, tmp74, tmp75, tmp77, tmp71);
    }
  }

  if (block16.is_used()) {
    TNode<NativeContext> tmp79;
    TNode<Object> tmp80;
    TNode<Object> tmp81;
    TNode<Object> tmp82;
    TNode<Object> tmp83;
    TNode<Object> tmp84;
    TNode<Object> tmp85;
    TNode<Object> tmp86;
    TNode<JSReceiver> tmp87;
    TNode<JSReceiver> tmp88;
    TNode<Number> tmp89;
    TNode<Object> tmp90;
    ca_.Bind(&block16, &tmp79, &tmp80, &tmp81, &tmp82, &tmp83, &tmp84, &tmp85, &tmp86, &tmp87, &tmp88, &tmp89, &tmp90);
    CodeStubAssembler(state_).Unreachable();
  }

  if (block15.is_used()) {
    TNode<NativeContext> tmp91;
    TNode<Object> tmp92;
    TNode<Object> tmp93;
    TNode<Object> tmp94;
    TNode<Object> tmp95;
    TNode<Object> tmp96;
    TNode<Object> tmp97;
    TNode<Object> tmp98;
    TNode<JSReceiver> tmp99;
    TNode<JSReceiver> tmp100;
    TNode<Number> tmp101;
    TNode<Object> tmp102;
    TNode<Number> tmp103;
    ca_.Bind(&block15, &tmp91, &tmp92, &tmp93, &tmp94, &tmp95, &tmp96, &tmp97, &tmp98, &tmp99, &tmp100, &tmp101, &tmp102, &tmp103);
    TNode<BoolT> tmp104;
    USE(tmp104);
    tmp104 = ToBoolean_0(state_, TNode<Object>{tmp98});
    ca_.Branch(tmp104, &block17, &block18, tmp91, tmp92, tmp93, tmp94, tmp95, tmp96, tmp97, tmp98, tmp99, tmp100, tmp101, tmp103);
  }

  if (block17.is_used()) {
    TNode<NativeContext> tmp105;
    TNode<Object> tmp106;
    TNode<Object> tmp107;
    TNode<Object> tmp108;
    TNode<Object> tmp109;
    TNode<Object> tmp110;
    TNode<Object> tmp111;
    TNode<Object> tmp112;
    TNode<JSReceiver> tmp113;
    TNode<JSReceiver> tmp114;
    TNode<Number> tmp115;
    TNode<Number> tmp116;
    ca_.Bind(&block17, &tmp105, &tmp106, &tmp107, &tmp108, &tmp109, &tmp110, &tmp111, &tmp112, &tmp113, &tmp114, &tmp115, &tmp116);
    CodeStubAssembler(state_).Return(tmp111);
  }

  if (block18.is_used()) {
    TNode<NativeContext> tmp117;
    TNode<Object> tmp118;
    TNode<Object> tmp119;
    TNode<Object> tmp120;
    TNode<Object> tmp121;
    TNode<Object> tmp122;
    TNode<Object> tmp123;
    TNode<Object> tmp124;
    TNode<JSReceiver> tmp125;
    TNode<JSReceiver> tmp126;
    TNode<Number> tmp127;
    TNode<Number> tmp128;
    ca_.Bind(&block18, &tmp117, &tmp118, &tmp119, &tmp120, &tmp121, &tmp122, &tmp123, &tmp124, &tmp125, &tmp126, &tmp127, &tmp128);
    TNode<Number> tmp129;
    tmp129 = TORQUE_CAST(CodeStubAssembler(state_).CallBuiltin(Builtins::kArrayFindIndexLoopContinuation, tmp117, tmp125, tmp126, tmp120, tmp125, tmp127, tmp128));
    USE(tmp129);
    CodeStubAssembler(state_).Return(tmp129);
  }
}

TF_BUILTIN(ArrayFindIndexLoopContinuation, CodeStubAssembler) {
  compiler::CodeAssemblerState* state_ = state();  compiler::CodeAssembler ca_(state());
  TNode<Context> parameter0 = UncheckedCast<Context>(Parameter(Descriptor::kContext));
  USE(parameter0);
  TNode<JSReceiver> parameter1 = UncheckedCast<JSReceiver>(Parameter(Descriptor::ParameterIndex<0>()));
  USE(parameter1);
  TNode<JSReceiver> parameter2 = UncheckedCast<JSReceiver>(Parameter(Descriptor::ParameterIndex<1>()));
  USE(parameter2);
  TNode<Object> parameter3 = UncheckedCast<Object>(Parameter(Descriptor::ParameterIndex<2>()));
  USE(parameter3);
  TNode<JSReceiver> parameter4 = UncheckedCast<JSReceiver>(Parameter(Descriptor::ParameterIndex<3>()));
  USE(parameter4);
  TNode<Number> parameter5 = UncheckedCast<Number>(Parameter(Descriptor::ParameterIndex<4>()));
  USE(parameter5);
  TNode<Number> parameter6 = UncheckedCast<Number>(Parameter(Descriptor::ParameterIndex<5>()));
  USE(parameter6);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, JSReceiver, Object, JSReceiver, Number, Number> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, JSReceiver, Object, JSReceiver, Number, Number, Number> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, JSReceiver, Object, JSReceiver, Number, Number, Number> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, JSReceiver, Object, JSReceiver, Number, Number, Number, Object, Object> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, JSReceiver, Object, JSReceiver, Number, Number, Number, Object, Object> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, JSReceiver, Object, JSReceiver, Number, Number, Number> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, parameter0, parameter1, parameter2, parameter3, parameter4, parameter5, parameter6);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<JSReceiver> tmp1;
    TNode<JSReceiver> tmp2;
    TNode<Object> tmp3;
    TNode<JSReceiver> tmp4;
    TNode<Number> tmp5;
    TNode<Number> tmp6;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4, &tmp5, &tmp6);
    ca_.Goto(&block3, tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp6, tmp5);
  }

  if (block3.is_used()) {
    TNode<Context> tmp7;
    TNode<JSReceiver> tmp8;
    TNode<JSReceiver> tmp9;
    TNode<Object> tmp10;
    TNode<JSReceiver> tmp11;
    TNode<Number> tmp12;
    TNode<Number> tmp13;
    TNode<Number> tmp14;
    ca_.Bind(&block3, &tmp7, &tmp8, &tmp9, &tmp10, &tmp11, &tmp12, &tmp13, &tmp14);
    TNode<BoolT> tmp15;
    USE(tmp15);
    tmp15 = NumberIsLessThan_0(state_, TNode<Number>{tmp14}, TNode<Number>{tmp13});
    ca_.Branch(tmp15, &block1, &block2, tmp7, tmp8, tmp9, tmp10, tmp11, tmp12, tmp13, tmp14);
  }

  if (block1.is_used()) {
    TNode<Context> tmp16;
    TNode<JSReceiver> tmp17;
    TNode<JSReceiver> tmp18;
    TNode<Object> tmp19;
    TNode<JSReceiver> tmp20;
    TNode<Number> tmp21;
    TNode<Number> tmp22;
    TNode<Number> tmp23;
    ca_.Bind(&block1, &tmp16, &tmp17, &tmp18, &tmp19, &tmp20, &tmp21, &tmp22, &tmp23);
    TNode<Object> tmp24;
    USE(tmp24);
    tmp24 = CodeStubAssembler(state_).GetProperty(TNode<Context>{tmp16}, TNode<Object>{tmp20}, TNode<Object>{tmp23});
    TNode<Object> tmp25;
    USE(tmp25);
    tmp25 = CodeStubAssembler(state_).Call(TNode<Context>{tmp16}, TNode<Object>{tmp18}, TNode<Object>{tmp19}, TNode<Object>{tmp24}, TNode<Object>{tmp23}, TNode<Object>{tmp20});
    TNode<BoolT> tmp26;
    USE(tmp26);
    tmp26 = ToBoolean_0(state_, TNode<Object>{tmp25});
    ca_.Branch(tmp26, &block5, &block6, tmp16, tmp17, tmp18, tmp19, tmp20, tmp21, tmp22, tmp23, tmp24, tmp25);
  }

  if (block5.is_used()) {
    TNode<Context> tmp27;
    TNode<JSReceiver> tmp28;
    TNode<JSReceiver> tmp29;
    TNode<Object> tmp30;
    TNode<JSReceiver> tmp31;
    TNode<Number> tmp32;
    TNode<Number> tmp33;
    TNode<Number> tmp34;
    TNode<Object> tmp35;
    TNode<Object> tmp36;
    ca_.Bind(&block5, &tmp27, &tmp28, &tmp29, &tmp30, &tmp31, &tmp32, &tmp33, &tmp34, &tmp35, &tmp36);
    CodeStubAssembler(state_).Return(tmp34);
  }

  if (block6.is_used()) {
    TNode<Context> tmp37;
    TNode<JSReceiver> tmp38;
    TNode<JSReceiver> tmp39;
    TNode<Object> tmp40;
    TNode<JSReceiver> tmp41;
    TNode<Number> tmp42;
    TNode<Number> tmp43;
    TNode<Number> tmp44;
    TNode<Object> tmp45;
    TNode<Object> tmp46;
    ca_.Bind(&block6, &tmp37, &tmp38, &tmp39, &tmp40, &tmp41, &tmp42, &tmp43, &tmp44, &tmp45, &tmp46);
    TNode<Number> tmp47;
    USE(tmp47);
    tmp47 = FromConstexpr_Number_constexpr_int31_0(state_, 1);
    TNode<Number> tmp48;
    USE(tmp48);
    tmp48 = CodeStubAssembler(state_).NumberAdd(TNode<Number>{tmp44}, TNode<Number>{tmp47});
    ca_.Goto(&block3, tmp37, tmp38, tmp39, tmp40, tmp41, tmp42, tmp43, tmp48);
  }

  if (block2.is_used()) {
    TNode<Context> tmp49;
    TNode<JSReceiver> tmp50;
    TNode<JSReceiver> tmp51;
    TNode<Object> tmp52;
    TNode<JSReceiver> tmp53;
    TNode<Number> tmp54;
    TNode<Number> tmp55;
    TNode<Number> tmp56;
    ca_.Bind(&block2, &tmp49, &tmp50, &tmp51, &tmp52, &tmp53, &tmp54, &tmp55, &tmp56);
    TNode<Smi> tmp57;
    USE(tmp57);
    tmp57 = Convert_Smi_constexpr_int31_0(state_, -1);
    CodeStubAssembler(state_).Return(tmp57);
  }
}

TNode<Number> FastArrayFindIndex_0(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TNode<JSReceiver> p_o, TNode<Number> p_len, TNode<JSReceiver> p_callbackfn, TNode<Object> p_thisArg, compiler::CodeAssemblerLabel* label_Bailout, compiler::TypedCodeAssemblerVariable<Smi>* label_Bailout_parameter_0) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Number> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Number, Smi> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSReceiver, Context> block10(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSReceiver, Context, JSArray> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSArray, JSArray, JSArray, Map, BoolT, BoolT, BoolT> block13(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSArray, JSArray, JSArray, Map, BoolT, BoolT, BoolT> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSArray, JSArray, JSArray, Map, BoolT, BoolT, BoolT> block18(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSArray, JSArray, JSArray, Map, BoolT, BoolT, BoolT> block19(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSArray, JSArray, JSArray, Map, BoolT, BoolT, BoolT> block20(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSArray, JSArray, JSArray, Map, BoolT, BoolT, BoolT> block21(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSArray, JSArray, JSArray, Map, BoolT, BoolT, BoolT> block16(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSArray, JSArray, JSArray, Map, BoolT, BoolT, BoolT> block22(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSArray, JSArray, JSArray, Map, BoolT, BoolT, BoolT> block23(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSArray, JSArray, JSArray, Map, BoolT, BoolT, BoolT, Smi, Context, Context, Smi, Smi, Context, Context, Smi> block29(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSArray, JSArray, JSArray, Map, BoolT, BoolT, BoolT, Smi, Context, Context, Smi, Smi, Context, Context, Smi, JSArray, Smi, Context> block33(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSArray, JSArray, JSArray, Map, BoolT, BoolT, BoolT, Smi, Context, Context, Smi, Smi, Context, Context, Smi, JSArray, Smi, Context, Object> block32(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSArray, JSArray, JSArray, Map, BoolT, BoolT, BoolT, Smi, Context, Context, Smi, Smi, Context, Context, Smi> block30(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSArray, JSArray, JSArray, Map, BoolT, BoolT, BoolT, Smi, Context, Context, Smi, Smi, Context, Context, Smi, JSArray, Smi, Context> block35(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSArray, JSArray, JSArray, Map, BoolT, BoolT, BoolT, Smi, Context, Context, Smi, Smi, Context, Context, Smi, JSArray, Smi, Context, Object> block34(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSArray, JSArray, JSArray, Map, BoolT, BoolT, BoolT, Smi, Context, Context, Smi, Smi, Context, Context, Smi, Object> block28(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSArray, JSArray, JSArray, Map, BoolT, BoolT, BoolT, Smi, Context, Context, Smi> block27(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSArray, JSArray, JSArray, Map, BoolT, BoolT, BoolT, Smi, Context, Context, Smi, Object> block25(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSArray, JSArray, JSArray, Map, BoolT, BoolT, BoolT, Object, Object> block37(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSArray, JSArray, JSArray, Map, BoolT, BoolT, BoolT, Object, Object> block38(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Smi, Smi, JSArray, JSArray, JSArray, Map, BoolT, BoolT, BoolT> block12(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Number> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Smi> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, JSReceiver, Object, Number> block39(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_o, p_len, p_callbackfn, p_thisArg);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<JSReceiver> tmp1;
    TNode<Number> tmp2;
    TNode<JSReceiver> tmp3;
    TNode<Object> tmp4;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4);
    TNode<Smi> tmp5;
    USE(tmp5);
    tmp5 = FromConstexpr_Smi_constexpr_int31_0(state_, 0);
    TNode<Smi> tmp6;
    USE(tmp6);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp6 = Cast_Smi_0(state_, TNode<Object>{tmp2}, &label0);
    ca_.Goto(&block5, tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp2, tmp6);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block6, tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp2);
    }
  }

  if (block6.is_used()) {
    TNode<Context> tmp7;
    TNode<JSReceiver> tmp8;
    TNode<Number> tmp9;
    TNode<JSReceiver> tmp10;
    TNode<Object> tmp11;
    TNode<Smi> tmp12;
    TNode<Number> tmp13;
    ca_.Bind(&block6, &tmp7, &tmp8, &tmp9, &tmp10, &tmp11, &tmp12, &tmp13);
    ca_.Goto(&block1, tmp12);
  }

  if (block5.is_used()) {
    TNode<Context> tmp14;
    TNode<JSReceiver> tmp15;
    TNode<Number> tmp16;
    TNode<JSReceiver> tmp17;
    TNode<Object> tmp18;
    TNode<Smi> tmp19;
    TNode<Number> tmp20;
    TNode<Smi> tmp21;
    ca_.Bind(&block5, &tmp14, &tmp15, &tmp16, &tmp17, &tmp18, &tmp19, &tmp20, &tmp21);
    TNode<JSArray> tmp22;
    USE(tmp22);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp22 = Cast_FastJSArray_0(state_, TNode<Context>{tmp14}, TNode<HeapObject>{tmp15}, &label0);
    ca_.Goto(&block9, tmp14, tmp15, tmp16, tmp17, tmp18, tmp19, tmp21, tmp15, tmp14, tmp22);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block10, tmp14, tmp15, tmp16, tmp17, tmp18, tmp19, tmp21, tmp15, tmp14);
    }
  }

  if (block10.is_used()) {
    TNode<Context> tmp23;
    TNode<JSReceiver> tmp24;
    TNode<Number> tmp25;
    TNode<JSReceiver> tmp26;
    TNode<Object> tmp27;
    TNode<Smi> tmp28;
    TNode<Smi> tmp29;
    TNode<JSReceiver> tmp30;
    TNode<Context> tmp31;
    ca_.Bind(&block10, &tmp23, &tmp24, &tmp25, &tmp26, &tmp27, &tmp28, &tmp29, &tmp30, &tmp31);
    ca_.Goto(&block1, tmp28);
  }

  if (block9.is_used()) {
    TNode<Context> tmp32;
    TNode<JSReceiver> tmp33;
    TNode<Number> tmp34;
    TNode<JSReceiver> tmp35;
    TNode<Object> tmp36;
    TNode<Smi> tmp37;
    TNode<Smi> tmp38;
    TNode<JSReceiver> tmp39;
    TNode<Context> tmp40;
    TNode<JSArray> tmp41;
    ca_.Bind(&block9, &tmp32, &tmp33, &tmp34, &tmp35, &tmp36, &tmp37, &tmp38, &tmp39, &tmp40, &tmp41);
    TNode<JSArray> tmp42;
    USE(tmp42);
    TNode<JSArray> tmp43;
    USE(tmp43);
    TNode<Map> tmp44;
    USE(tmp44);
    TNode<BoolT> tmp45;
    USE(tmp45);
    TNode<BoolT> tmp46;
    USE(tmp46);
    TNode<BoolT> tmp47;
    USE(tmp47);
    std::tie(tmp42, tmp43, tmp44, tmp45, tmp46, tmp47) = NewFastJSArrayWitness_0(state_, TNode<JSArray>{tmp41}).Flatten();
    ca_.Goto(&block13, tmp32, tmp33, tmp34, tmp35, tmp36, tmp37, tmp38, tmp41, tmp42, tmp43, tmp44, tmp45, tmp46, tmp47);
  }

  if (block13.is_used()) {
    TNode<Context> tmp48;
    TNode<JSReceiver> tmp49;
    TNode<Number> tmp50;
    TNode<JSReceiver> tmp51;
    TNode<Object> tmp52;
    TNode<Smi> tmp53;
    TNode<Smi> tmp54;
    TNode<JSArray> tmp55;
    TNode<JSArray> tmp56;
    TNode<JSArray> tmp57;
    TNode<Map> tmp58;
    TNode<BoolT> tmp59;
    TNode<BoolT> tmp60;
    TNode<BoolT> tmp61;
    ca_.Bind(&block13, &tmp48, &tmp49, &tmp50, &tmp51, &tmp52, &tmp53, &tmp54, &tmp55, &tmp56, &tmp57, &tmp58, &tmp59, &tmp60, &tmp61);
    TNode<BoolT> tmp62;
    USE(tmp62);
    tmp62 = CodeStubAssembler(state_).SmiLessThan(TNode<Smi>{tmp53}, TNode<Smi>{tmp54});
    ca_.Branch(tmp62, &block11, &block12, tmp48, tmp49, tmp50, tmp51, tmp52, tmp53, tmp54, tmp55, tmp56, tmp57, tmp58, tmp59, tmp60, tmp61);
  }

  if (block11.is_used()) {
    TNode<Context> tmp63;
    TNode<JSReceiver> tmp64;
    TNode<Number> tmp65;
    TNode<JSReceiver> tmp66;
    TNode<Object> tmp67;
    TNode<Smi> tmp68;
    TNode<Smi> tmp69;
    TNode<JSArray> tmp70;
    TNode<JSArray> tmp71;
    TNode<JSArray> tmp72;
    TNode<Map> tmp73;
    TNode<BoolT> tmp74;
    TNode<BoolT> tmp75;
    TNode<BoolT> tmp76;
    ca_.Bind(&block11, &tmp63, &tmp64, &tmp65, &tmp66, &tmp67, &tmp68, &tmp69, &tmp70, &tmp71, &tmp72, &tmp73, &tmp74, &tmp75, &tmp76);
    TNode<IntPtrT> tmp77;
    USE(tmp77);
    tmp77 = FromConstexpr_intptr_constexpr_int31_0(state_, 0);
    TNode<Map>tmp78 = CodeStubAssembler(state_).LoadReference<Map>(CodeStubAssembler::Reference{tmp71, tmp77});
    TNode<BoolT> tmp79;
    USE(tmp79);
    tmp79 = CodeStubAssembler(state_).TaggedNotEqual(TNode<HeapObject>{tmp78}, TNode<HeapObject>{tmp73});
    ca_.Branch(tmp79, &block18, &block19, tmp63, tmp64, tmp65, tmp66, tmp67, tmp68, tmp69, tmp70, tmp71, tmp72, tmp73, tmp74, tmp75, tmp76);
  }

  if (block18.is_used()) {
    TNode<Context> tmp80;
    TNode<JSReceiver> tmp81;
    TNode<Number> tmp82;
    TNode<JSReceiver> tmp83;
    TNode<Object> tmp84;
    TNode<Smi> tmp85;
    TNode<Smi> tmp86;
    TNode<JSArray> tmp87;
    TNode<JSArray> tmp88;
    TNode<JSArray> tmp89;
    TNode<Map> tmp90;
    TNode<BoolT> tmp91;
    TNode<BoolT> tmp92;
    TNode<BoolT> tmp93;
    ca_.Bind(&block18, &tmp80, &tmp81, &tmp82, &tmp83, &tmp84, &tmp85, &tmp86, &tmp87, &tmp88, &tmp89, &tmp90, &tmp91, &tmp92, &tmp93);
    ca_.Goto(&block16, tmp80, tmp81, tmp82, tmp83, tmp84, tmp85, tmp86, tmp87, tmp88, tmp89, tmp90, tmp91, tmp92, tmp93);
  }

  if (block19.is_used()) {
    TNode<Context> tmp94;
    TNode<JSReceiver> tmp95;
    TNode<Number> tmp96;
    TNode<JSReceiver> tmp97;
    TNode<Object> tmp98;
    TNode<Smi> tmp99;
    TNode<Smi> tmp100;
    TNode<JSArray> tmp101;
    TNode<JSArray> tmp102;
    TNode<JSArray> tmp103;
    TNode<Map> tmp104;
    TNode<BoolT> tmp105;
    TNode<BoolT> tmp106;
    TNode<BoolT> tmp107;
    ca_.Bind(&block19, &tmp94, &tmp95, &tmp96, &tmp97, &tmp98, &tmp99, &tmp100, &tmp101, &tmp102, &tmp103, &tmp104, &tmp105, &tmp106, &tmp107);
    TNode<BoolT> tmp108;
    USE(tmp108);
    tmp108 = CodeStubAssembler(state_).IsNoElementsProtectorCellInvalid();
    ca_.Branch(tmp108, &block20, &block21, tmp94, tmp95, tmp96, tmp97, tmp98, tmp99, tmp100, tmp101, tmp102, tmp103, tmp104, tmp105, tmp106, tmp107);
  }

  if (block20.is_used()) {
    TNode<Context> tmp109;
    TNode<JSReceiver> tmp110;
    TNode<Number> tmp111;
    TNode<JSReceiver> tmp112;
    TNode<Object> tmp113;
    TNode<Smi> tmp114;
    TNode<Smi> tmp115;
    TNode<JSArray> tmp116;
    TNode<JSArray> tmp117;
    TNode<JSArray> tmp118;
    TNode<Map> tmp119;
    TNode<BoolT> tmp120;
    TNode<BoolT> tmp121;
    TNode<BoolT> tmp122;
    ca_.Bind(&block20, &tmp109, &tmp110, &tmp111, &tmp112, &tmp113, &tmp114, &tmp115, &tmp116, &tmp117, &tmp118, &tmp119, &tmp120, &tmp121, &tmp122);
    ca_.Goto(&block16, tmp109, tmp110, tmp111, tmp112, tmp113, tmp114, tmp115, tmp116, tmp117, tmp118, tmp119, tmp120, tmp121, tmp122);
  }

  if (block21.is_used()) {
    TNode<Context> tmp123;
    TNode<JSReceiver> tmp124;
    TNode<Number> tmp125;
    TNode<JSReceiver> tmp126;
    TNode<Object> tmp127;
    TNode<Smi> tmp128;
    TNode<Smi> tmp129;
    TNode<JSArray> tmp130;
    TNode<JSArray> tmp131;
    TNode<JSArray> tmp132;
    TNode<Map> tmp133;
    TNode<BoolT> tmp134;
    TNode<BoolT> tmp135;
    TNode<BoolT> tmp136;
    ca_.Bind(&block21, &tmp123, &tmp124, &tmp125, &tmp126, &tmp127, &tmp128, &tmp129, &tmp130, &tmp131, &tmp132, &tmp133, &tmp134, &tmp135, &tmp136);
    TNode<JSArray> tmp137;
    USE(tmp137);
    tmp137 = (TNode<JSArray>{tmp131});
    TNode<Smi> tmp138;
    USE(tmp138);
    tmp138 = CodeStubAssembler(state_).LoadFastJSArrayLength(TNode<JSArray>{tmp137});
    TNode<BoolT> tmp139;
    USE(tmp139);
    tmp139 = CodeStubAssembler(state_).SmiGreaterThanOrEqual(TNode<Smi>{tmp128}, TNode<Smi>{tmp138});
    ca_.Branch(tmp139, &block22, &block23, tmp123, tmp124, tmp125, tmp126, tmp127, tmp128, tmp129, tmp130, tmp131, tmp137, tmp133, tmp134, tmp135, tmp136);
  }

  if (block16.is_used()) {
    TNode<Context> tmp140;
    TNode<JSReceiver> tmp141;
    TNode<Number> tmp142;
    TNode<JSReceiver> tmp143;
    TNode<Object> tmp144;
    TNode<Smi> tmp145;
    TNode<Smi> tmp146;
    TNode<JSArray> tmp147;
    TNode<JSArray> tmp148;
    TNode<JSArray> tmp149;
    TNode<Map> tmp150;
    TNode<BoolT> tmp151;
    TNode<BoolT> tmp152;
    TNode<BoolT> tmp153;
    ca_.Bind(&block16, &tmp140, &tmp141, &tmp142, &tmp143, &tmp144, &tmp145, &tmp146, &tmp147, &tmp148, &tmp149, &tmp150, &tmp151, &tmp152, &tmp153);
    ca_.Goto(&block1, tmp145);
  }

  if (block22.is_used()) {
    TNode<Context> tmp154;
    TNode<JSReceiver> tmp155;
    TNode<Number> tmp156;
    TNode<JSReceiver> tmp157;
    TNode<Object> tmp158;
    TNode<Smi> tmp159;
    TNode<Smi> tmp160;
    TNode<JSArray> tmp161;
    TNode<JSArray> tmp162;
    TNode<JSArray> tmp163;
    TNode<Map> tmp164;
    TNode<BoolT> tmp165;
    TNode<BoolT> tmp166;
    TNode<BoolT> tmp167;
    ca_.Bind(&block22, &tmp154, &tmp155, &tmp156, &tmp157, &tmp158, &tmp159, &tmp160, &tmp161, &tmp162, &tmp163, &tmp164, &tmp165, &tmp166, &tmp167);
    ca_.Goto(&block1, tmp159);
  }

  if (block23.is_used()) {
    TNode<Context> tmp168;
    TNode<JSReceiver> tmp169;
    TNode<Number> tmp170;
    TNode<JSReceiver> tmp171;
    TNode<Object> tmp172;
    TNode<Smi> tmp173;
    TNode<Smi> tmp174;
    TNode<JSArray> tmp175;
    TNode<JSArray> tmp176;
    TNode<JSArray> tmp177;
    TNode<Map> tmp178;
    TNode<BoolT> tmp179;
    TNode<BoolT> tmp180;
    TNode<BoolT> tmp181;
    ca_.Bind(&block23, &tmp168, &tmp169, &tmp170, &tmp171, &tmp172, &tmp173, &tmp174, &tmp175, &tmp176, &tmp177, &tmp178, &tmp179, &tmp180, &tmp181);
    ca_.Branch(tmp179, &block29, &block30, tmp168, tmp169, tmp170, tmp171, tmp172, tmp173, tmp174, tmp175, tmp176, tmp177, tmp178, tmp179, tmp180, tmp181, tmp173, tmp168, tmp168, tmp173, tmp173, tmp168, tmp168, tmp173);
  }

  if (block29.is_used()) {
    TNode<Context> tmp182;
    TNode<JSReceiver> tmp183;
    TNode<Number> tmp184;
    TNode<JSReceiver> tmp185;
    TNode<Object> tmp186;
    TNode<Smi> tmp187;
    TNode<Smi> tmp188;
    TNode<JSArray> tmp189;
    TNode<JSArray> tmp190;
    TNode<JSArray> tmp191;
    TNode<Map> tmp192;
    TNode<BoolT> tmp193;
    TNode<BoolT> tmp194;
    TNode<BoolT> tmp195;
    TNode<Smi> tmp196;
    TNode<Context> tmp197;
    TNode<Context> tmp198;
    TNode<Smi> tmp199;
    TNode<Smi> tmp200;
    TNode<Context> tmp201;
    TNode<Context> tmp202;
    TNode<Smi> tmp203;
    ca_.Bind(&block29, &tmp182, &tmp183, &tmp184, &tmp185, &tmp186, &tmp187, &tmp188, &tmp189, &tmp190, &tmp191, &tmp192, &tmp193, &tmp194, &tmp195, &tmp196, &tmp197, &tmp198, &tmp199, &tmp200, &tmp201, &tmp202, &tmp203);
    TNode<Object> tmp204;
    USE(tmp204);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp204 = LoadElementNoHole_FixedDoubleArray_0(state_, TNode<Context>{tmp202}, TNode<JSArray>{tmp191}, TNode<Smi>{tmp203}, &label0);
    ca_.Goto(&block32, tmp182, tmp183, tmp184, tmp185, tmp186, tmp187, tmp188, tmp189, tmp190, tmp191, tmp192, tmp193, tmp194, tmp195, tmp196, tmp197, tmp198, tmp199, tmp200, tmp201, tmp202, tmp203, tmp191, tmp203, tmp202, tmp204);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block33, tmp182, tmp183, tmp184, tmp185, tmp186, tmp187, tmp188, tmp189, tmp190, tmp191, tmp192, tmp193, tmp194, tmp195, tmp196, tmp197, tmp198, tmp199, tmp200, tmp201, tmp202, tmp203, tmp191, tmp203, tmp202);
    }
  }

  if (block33.is_used()) {
    TNode<Context> tmp205;
    TNode<JSReceiver> tmp206;
    TNode<Number> tmp207;
    TNode<JSReceiver> tmp208;
    TNode<Object> tmp209;
    TNode<Smi> tmp210;
    TNode<Smi> tmp211;
    TNode<JSArray> tmp212;
    TNode<JSArray> tmp213;
    TNode<JSArray> tmp214;
    TNode<Map> tmp215;
    TNode<BoolT> tmp216;
    TNode<BoolT> tmp217;
    TNode<BoolT> tmp218;
    TNode<Smi> tmp219;
    TNode<Context> tmp220;
    TNode<Context> tmp221;
    TNode<Smi> tmp222;
    TNode<Smi> tmp223;
    TNode<Context> tmp224;
    TNode<Context> tmp225;
    TNode<Smi> tmp226;
    TNode<JSArray> tmp227;
    TNode<Smi> tmp228;
    TNode<Context> tmp229;
    ca_.Bind(&block33, &tmp205, &tmp206, &tmp207, &tmp208, &tmp209, &tmp210, &tmp211, &tmp212, &tmp213, &tmp214, &tmp215, &tmp216, &tmp217, &tmp218, &tmp219, &tmp220, &tmp221, &tmp222, &tmp223, &tmp224, &tmp225, &tmp226, &tmp227, &tmp228, &tmp229);
    ca_.Goto(&block27, tmp205, tmp206, tmp207, tmp208, tmp209, tmp210, tmp211, tmp212, tmp213, tmp214, tmp215, tmp216, tmp217, tmp218, tmp219, tmp220, tmp221, tmp222);
  }

  if (block32.is_used()) {
    TNode<Context> tmp230;
    TNode<JSReceiver> tmp231;
    TNode<Number> tmp232;
    TNode<JSReceiver> tmp233;
    TNode<Object> tmp234;
    TNode<Smi> tmp235;
    TNode<Smi> tmp236;
    TNode<JSArray> tmp237;
    TNode<JSArray> tmp238;
    TNode<JSArray> tmp239;
    TNode<Map> tmp240;
    TNode<BoolT> tmp241;
    TNode<BoolT> tmp242;
    TNode<BoolT> tmp243;
    TNode<Smi> tmp244;
    TNode<Context> tmp245;
    TNode<Context> tmp246;
    TNode<Smi> tmp247;
    TNode<Smi> tmp248;
    TNode<Context> tmp249;
    TNode<Context> tmp250;
    TNode<Smi> tmp251;
    TNode<JSArray> tmp252;
    TNode<Smi> tmp253;
    TNode<Context> tmp254;
    TNode<Object> tmp255;
    ca_.Bind(&block32, &tmp230, &tmp231, &tmp232, &tmp233, &tmp234, &tmp235, &tmp236, &tmp237, &tmp238, &tmp239, &tmp240, &tmp241, &tmp242, &tmp243, &tmp244, &tmp245, &tmp246, &tmp247, &tmp248, &tmp249, &tmp250, &tmp251, &tmp252, &tmp253, &tmp254, &tmp255);
    ca_.Goto(&block28, tmp230, tmp231, tmp232, tmp233, tmp234, tmp235, tmp236, tmp237, tmp238, tmp239, tmp240, tmp241, tmp242, tmp243, tmp244, tmp245, tmp246, tmp247, tmp248, tmp249, tmp250, tmp251, tmp255);
  }

  if (block30.is_used()) {
    TNode<Context> tmp256;
    TNode<JSReceiver> tmp257;
    TNode<Number> tmp258;
    TNode<JSReceiver> tmp259;
    TNode<Object> tmp260;
    TNode<Smi> tmp261;
    TNode<Smi> tmp262;
    TNode<JSArray> tmp263;
    TNode<JSArray> tmp264;
    TNode<JSArray> tmp265;
    TNode<Map> tmp266;
    TNode<BoolT> tmp267;
    TNode<BoolT> tmp268;
    TNode<BoolT> tmp269;
    TNode<Smi> tmp270;
    TNode<Context> tmp271;
    TNode<Context> tmp272;
    TNode<Smi> tmp273;
    TNode<Smi> tmp274;
    TNode<Context> tmp275;
    TNode<Context> tmp276;
    TNode<Smi> tmp277;
    ca_.Bind(&block30, &tmp256, &tmp257, &tmp258, &tmp259, &tmp260, &tmp261, &tmp262, &tmp263, &tmp264, &tmp265, &tmp266, &tmp267, &tmp268, &tmp269, &tmp270, &tmp271, &tmp272, &tmp273, &tmp274, &tmp275, &tmp276, &tmp277);
    TNode<Object> tmp278;
    USE(tmp278);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp278 = LoadElementNoHole_FixedArray_0(state_, TNode<Context>{tmp276}, TNode<JSArray>{tmp265}, TNode<Smi>{tmp277}, &label0);
    ca_.Goto(&block34, tmp256, tmp257, tmp258, tmp259, tmp260, tmp261, tmp262, tmp263, tmp264, tmp265, tmp266, tmp267, tmp268, tmp269, tmp270, tmp271, tmp272, tmp273, tmp274, tmp275, tmp276, tmp277, tmp265, tmp277, tmp276, tmp278);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block35, tmp256, tmp257, tmp258, tmp259, tmp260, tmp261, tmp262, tmp263, tmp264, tmp265, tmp266, tmp267, tmp268, tmp269, tmp270, tmp271, tmp272, tmp273, tmp274, tmp275, tmp276, tmp277, tmp265, tmp277, tmp276);
    }
  }

  if (block35.is_used()) {
    TNode<Context> tmp279;
    TNode<JSReceiver> tmp280;
    TNode<Number> tmp281;
    TNode<JSReceiver> tmp282;
    TNode<Object> tmp283;
    TNode<Smi> tmp284;
    TNode<Smi> tmp285;
    TNode<JSArray> tmp286;
    TNode<JSArray> tmp287;
    TNode<JSArray> tmp288;
    TNode<Map> tmp289;
    TNode<BoolT> tmp290;
    TNode<BoolT> tmp291;
    TNode<BoolT> tmp292;
    TNode<Smi> tmp293;
    TNode<Context> tmp294;
    TNode<Context> tmp295;
    TNode<Smi> tmp296;
    TNode<Smi> tmp297;
    TNode<Context> tmp298;
    TNode<Context> tmp299;
    TNode<Smi> tmp300;
    TNode<JSArray> tmp301;
    TNode<Smi> tmp302;
    TNode<Context> tmp303;
    ca_.Bind(&block35, &tmp279, &tmp280, &tmp281, &tmp282, &tmp283, &tmp284, &tmp285, &tmp286, &tmp287, &tmp288, &tmp289, &tmp290, &tmp291, &tmp292, &tmp293, &tmp294, &tmp295, &tmp296, &tmp297, &tmp298, &tmp299, &tmp300, &tmp301, &tmp302, &tmp303);
    ca_.Goto(&block27, tmp279, tmp280, tmp281, tmp282, tmp283, tmp284, tmp285, tmp286, tmp287, tmp288, tmp289, tmp290, tmp291, tmp292, tmp293, tmp294, tmp295, tmp296);
  }

  if (block34.is_used()) {
    TNode<Context> tmp304;
    TNode<JSReceiver> tmp305;
    TNode<Number> tmp306;
    TNode<JSReceiver> tmp307;
    TNode<Object> tmp308;
    TNode<Smi> tmp309;
    TNode<Smi> tmp310;
    TNode<JSArray> tmp311;
    TNode<JSArray> tmp312;
    TNode<JSArray> tmp313;
    TNode<Map> tmp314;
    TNode<BoolT> tmp315;
    TNode<BoolT> tmp316;
    TNode<BoolT> tmp317;
    TNode<Smi> tmp318;
    TNode<Context> tmp319;
    TNode<Context> tmp320;
    TNode<Smi> tmp321;
    TNode<Smi> tmp322;
    TNode<Context> tmp323;
    TNode<Context> tmp324;
    TNode<Smi> tmp325;
    TNode<JSArray> tmp326;
    TNode<Smi> tmp327;
    TNode<Context> tmp328;
    TNode<Object> tmp329;
    ca_.Bind(&block34, &tmp304, &tmp305, &tmp306, &tmp307, &tmp308, &tmp309, &tmp310, &tmp311, &tmp312, &tmp313, &tmp314, &tmp315, &tmp316, &tmp317, &tmp318, &tmp319, &tmp320, &tmp321, &tmp322, &tmp323, &tmp324, &tmp325, &tmp326, &tmp327, &tmp328, &tmp329);
    ca_.Goto(&block28, tmp304, tmp305, tmp306, tmp307, tmp308, tmp309, tmp310, tmp311, tmp312, tmp313, tmp314, tmp315, tmp316, tmp317, tmp318, tmp319, tmp320, tmp321, tmp322, tmp323, tmp324, tmp325, tmp329);
  }

  if (block28.is_used()) {
    TNode<Context> tmp330;
    TNode<JSReceiver> tmp331;
    TNode<Number> tmp332;
    TNode<JSReceiver> tmp333;
    TNode<Object> tmp334;
    TNode<Smi> tmp335;
    TNode<Smi> tmp336;
    TNode<JSArray> tmp337;
    TNode<JSArray> tmp338;
    TNode<JSArray> tmp339;
    TNode<Map> tmp340;
    TNode<BoolT> tmp341;
    TNode<BoolT> tmp342;
    TNode<BoolT> tmp343;
    TNode<Smi> tmp344;
    TNode<Context> tmp345;
    TNode<Context> tmp346;
    TNode<Smi> tmp347;
    TNode<Smi> tmp348;
    TNode<Context> tmp349;
    TNode<Context> tmp350;
    TNode<Smi> tmp351;
    TNode<Object> tmp352;
    ca_.Bind(&block28, &tmp330, &tmp331, &tmp332, &tmp333, &tmp334, &tmp335, &tmp336, &tmp337, &tmp338, &tmp339, &tmp340, &tmp341, &tmp342, &tmp343, &tmp344, &tmp345, &tmp346, &tmp347, &tmp348, &tmp349, &tmp350, &tmp351, &tmp352);
    ca_.Goto(&block25, tmp330, tmp331, tmp332, tmp333, tmp334, tmp335, tmp336, tmp337, tmp338, tmp339, tmp340, tmp341, tmp342, tmp343, tmp344, tmp345, tmp346, tmp347, tmp352);
  }

  if (block27.is_used()) {
    TNode<Context> tmp353;
    TNode<JSReceiver> tmp354;
    TNode<Number> tmp355;
    TNode<JSReceiver> tmp356;
    TNode<Object> tmp357;
    TNode<Smi> tmp358;
    TNode<Smi> tmp359;
    TNode<JSArray> tmp360;
    TNode<JSArray> tmp361;
    TNode<JSArray> tmp362;
    TNode<Map> tmp363;
    TNode<BoolT> tmp364;
    TNode<BoolT> tmp365;
    TNode<BoolT> tmp366;
    TNode<Smi> tmp367;
    TNode<Context> tmp368;
    TNode<Context> tmp369;
    TNode<Smi> tmp370;
    ca_.Bind(&block27, &tmp353, &tmp354, &tmp355, &tmp356, &tmp357, &tmp358, &tmp359, &tmp360, &tmp361, &tmp362, &tmp363, &tmp364, &tmp365, &tmp366, &tmp367, &tmp368, &tmp369, &tmp370);
    TNode<Oddball> tmp371;
    USE(tmp371);
    tmp371 = Undefined_0(state_);
    ca_.Goto(&block25, tmp353, tmp354, tmp355, tmp356, tmp357, tmp358, tmp359, tmp360, tmp361, tmp362, tmp363, tmp364, tmp365, tmp366, tmp367, tmp368, tmp369, tmp370, tmp371);
  }

  if (block25.is_used()) {
    TNode<Context> tmp372;
    TNode<JSReceiver> tmp373;
    TNode<Number> tmp374;
    TNode<JSReceiver> tmp375;
    TNode<Object> tmp376;
    TNode<Smi> tmp377;
    TNode<Smi> tmp378;
    TNode<JSArray> tmp379;
    TNode<JSArray> tmp380;
    TNode<JSArray> tmp381;
    TNode<Map> tmp382;
    TNode<BoolT> tmp383;
    TNode<BoolT> tmp384;
    TNode<BoolT> tmp385;
    TNode<Smi> tmp386;
    TNode<Context> tmp387;
    TNode<Context> tmp388;
    TNode<Smi> tmp389;
    TNode<Object> tmp390;
    ca_.Bind(&block25, &tmp372, &tmp373, &tmp374, &tmp375, &tmp376, &tmp377, &tmp378, &tmp379, &tmp380, &tmp381, &tmp382, &tmp383, &tmp384, &tmp385, &tmp386, &tmp387, &tmp388, &tmp389, &tmp390);
    TNode<Object> tmp391;
    USE(tmp391);
    tmp391 = CodeStubAssembler(state_).Call(TNode<Context>{tmp372}, TNode<Object>{tmp375}, TNode<Object>{tmp376}, TNode<Object>{tmp390}, TNode<Object>{tmp377}, TNode<Object>{tmp381});
    TNode<BoolT> tmp392;
    USE(tmp392);
    tmp392 = ToBoolean_0(state_, TNode<Object>{tmp391});
    ca_.Branch(tmp392, &block37, &block38, tmp372, tmp373, tmp374, tmp375, tmp376, tmp377, tmp378, tmp379, tmp380, tmp381, tmp382, tmp383, tmp384, tmp385, tmp390, tmp391);
  }

  if (block37.is_used()) {
    TNode<Context> tmp393;
    TNode<JSReceiver> tmp394;
    TNode<Number> tmp395;
    TNode<JSReceiver> tmp396;
    TNode<Object> tmp397;
    TNode<Smi> tmp398;
    TNode<Smi> tmp399;
    TNode<JSArray> tmp400;
    TNode<JSArray> tmp401;
    TNode<JSArray> tmp402;
    TNode<Map> tmp403;
    TNode<BoolT> tmp404;
    TNode<BoolT> tmp405;
    TNode<BoolT> tmp406;
    TNode<Object> tmp407;
    TNode<Object> tmp408;
    ca_.Bind(&block37, &tmp393, &tmp394, &tmp395, &tmp396, &tmp397, &tmp398, &tmp399, &tmp400, &tmp401, &tmp402, &tmp403, &tmp404, &tmp405, &tmp406, &tmp407, &tmp408);
    ca_.Goto(&block2, tmp393, tmp394, tmp395, tmp396, tmp397, tmp398);
  }

  if (block38.is_used()) {
    TNode<Context> tmp409;
    TNode<JSReceiver> tmp410;
    TNode<Number> tmp411;
    TNode<JSReceiver> tmp412;
    TNode<Object> tmp413;
    TNode<Smi> tmp414;
    TNode<Smi> tmp415;
    TNode<JSArray> tmp416;
    TNode<JSArray> tmp417;
    TNode<JSArray> tmp418;
    TNode<Map> tmp419;
    TNode<BoolT> tmp420;
    TNode<BoolT> tmp421;
    TNode<BoolT> tmp422;
    TNode<Object> tmp423;
    TNode<Object> tmp424;
    ca_.Bind(&block38, &tmp409, &tmp410, &tmp411, &tmp412, &tmp413, &tmp414, &tmp415, &tmp416, &tmp417, &tmp418, &tmp419, &tmp420, &tmp421, &tmp422, &tmp423, &tmp424);
    TNode<Smi> tmp425;
    USE(tmp425);
    tmp425 = FromConstexpr_Smi_constexpr_int31_0(state_, 1);
    TNode<Smi> tmp426;
    USE(tmp426);
    tmp426 = CodeStubAssembler(state_).SmiAdd(TNode<Smi>{tmp414}, TNode<Smi>{tmp425});
    ca_.Goto(&block13, tmp409, tmp410, tmp411, tmp412, tmp413, tmp426, tmp415, tmp416, tmp417, tmp418, tmp419, tmp420, tmp421, tmp422);
  }

  if (block12.is_used()) {
    TNode<Context> tmp427;
    TNode<JSReceiver> tmp428;
    TNode<Number> tmp429;
    TNode<JSReceiver> tmp430;
    TNode<Object> tmp431;
    TNode<Smi> tmp432;
    TNode<Smi> tmp433;
    TNode<JSArray> tmp434;
    TNode<JSArray> tmp435;
    TNode<JSArray> tmp436;
    TNode<Map> tmp437;
    TNode<BoolT> tmp438;
    TNode<BoolT> tmp439;
    TNode<BoolT> tmp440;
    ca_.Bind(&block12, &tmp427, &tmp428, &tmp429, &tmp430, &tmp431, &tmp432, &tmp433, &tmp434, &tmp435, &tmp436, &tmp437, &tmp438, &tmp439, &tmp440);
    TNode<Number> tmp441;
    USE(tmp441);
    tmp441 = FromConstexpr_Number_constexpr_int31_0(state_, -1);
    ca_.Goto(&block2, tmp427, tmp428, tmp429, tmp430, tmp431, tmp441);
  }

  if (block2.is_used()) {
    TNode<Context> tmp442;
    TNode<JSReceiver> tmp443;
    TNode<Number> tmp444;
    TNode<JSReceiver> tmp445;
    TNode<Object> tmp446;
    TNode<Number> tmp447;
    ca_.Bind(&block2, &tmp442, &tmp443, &tmp444, &tmp445, &tmp446, &tmp447);
    ca_.Goto(&block39, tmp442, tmp443, tmp444, tmp445, tmp446, tmp447);
  }

  if (block1.is_used()) {
    TNode<Smi> tmp448;
    ca_.Bind(&block1, &tmp448);
    *label_Bailout_parameter_0 = tmp448;
    ca_.Goto(label_Bailout);
  }

    TNode<Context> tmp449;
    TNode<JSReceiver> tmp450;
    TNode<Number> tmp451;
    TNode<JSReceiver> tmp452;
    TNode<Object> tmp453;
    TNode<Number> tmp454;
    ca_.Bind(&block39, &tmp449, &tmp450, &tmp451, &tmp452, &tmp453, &tmp454);
  return TNode<Number>{tmp454};
}

TF_BUILTIN(ArrayPrototypeFindIndex, CodeStubAssembler) {
  compiler::CodeAssemblerState* state_ = state();  compiler::CodeAssembler ca_(state());
  Node* argc = Parameter(Descriptor::kJSActualArgumentsCount);
  TNode<IntPtrT> arguments_length(ChangeInt32ToIntPtr(argc));
  TNode<RawPtrT> arguments_frame = UncheckedCast<RawPtrT>(LoadFramePointer());
  TorqueStructArguments torque_arguments(GetFrameArguments(arguments_frame, arguments_length));
  CodeStubArguments arguments(this, torque_arguments);
  TNode<NativeContext> parameter0 = UncheckedCast<NativeContext>(Parameter(Descriptor::kContext));
  USE(parameter0);
  TNode<Object> parameter1 = arguments.GetReceiver();
USE(parameter1);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object, JSReceiver, Number> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object, JSReceiver, Number> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object, JSReceiver, Number, Object, NativeContext> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object, JSReceiver, Number, Object, NativeContext, JSReceiver> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object, JSReceiver, Number, JSReceiver> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object, JSReceiver, Number, JSReceiver> block8(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object, JSReceiver, Number, JSReceiver, Object> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object, JSReceiver, Number, JSReceiver, Object, JSReceiver, Number, JSReceiver, Object, NativeContext, Smi> block14(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object, JSReceiver, Number, JSReceiver, Object, JSReceiver, Number, JSReceiver, Object, NativeContext, Number> block13(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object> block2(&ca_, compiler::CodeAssemblerLabel::kDeferred);
    ca_.Goto(&block0, torque_arguments.frame, torque_arguments.base, torque_arguments.length, parameter0, parameter1);

  if (block0.is_used()) {
    TNode<RawPtrT> tmp0;
    TNode<RawPtrT> tmp1;
    TNode<IntPtrT> tmp2;
    TNode<NativeContext> tmp3;
    TNode<Object> tmp4;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4);
    TNode<Object> tmp5;
    USE(tmp5);
    tmp5 = RequireObjectCoercible_0(state_, TNode<Context>{tmp3}, TNode<Object>{tmp4}, "Array.prototype.findIndex");
    TNode<JSReceiver> tmp6;
    USE(tmp6);
    tmp6 = CodeStubAssembler(state_).ToObject_Inline(TNode<Context>{tmp3}, TNode<Object>{tmp4});
    TNode<Number> tmp7;
    USE(tmp7);
    tmp7 = GetLengthProperty_0(state_, TNode<Context>{tmp3}, TNode<Object>{tmp6});
    TNode<IntPtrT> tmp8;
    USE(tmp8);
    tmp8 = FromConstexpr_intptr_constexpr_int31_0(state_, 0);
    TNode<BoolT> tmp9;
    USE(tmp9);
    tmp9 = CodeStubAssembler(state_).WordEqual(TNode<IntPtrT>{tmp2}, TNode<IntPtrT>{tmp8});
    ca_.Branch(tmp9, &block3, &block4, tmp0, tmp1, tmp2, tmp3, tmp4, tmp6, tmp7);
  }

  if (block3.is_used()) {
    TNode<RawPtrT> tmp10;
    TNode<RawPtrT> tmp11;
    TNode<IntPtrT> tmp12;
    TNode<NativeContext> tmp13;
    TNode<Object> tmp14;
    TNode<JSReceiver> tmp15;
    TNode<Number> tmp16;
    ca_.Bind(&block3, &tmp10, &tmp11, &tmp12, &tmp13, &tmp14, &tmp15, &tmp16);
    ca_.Goto(&block2, tmp10, tmp11, tmp12, tmp13, tmp14);
  }

  if (block4.is_used()) {
    TNode<RawPtrT> tmp17;
    TNode<RawPtrT> tmp18;
    TNode<IntPtrT> tmp19;
    TNode<NativeContext> tmp20;
    TNode<Object> tmp21;
    TNode<JSReceiver> tmp22;
    TNode<Number> tmp23;
    ca_.Bind(&block4, &tmp17, &tmp18, &tmp19, &tmp20, &tmp21, &tmp22, &tmp23);
    TNode<IntPtrT> tmp24;
    USE(tmp24);
    tmp24 = FromConstexpr_intptr_constexpr_int31_0(state_, 0);
    TNode<Object> tmp25;
    USE(tmp25);
    tmp25 = CodeStubAssembler(state_).GetArgumentValue(TorqueStructArguments{TNode<RawPtrT>{tmp17}, TNode<RawPtrT>{tmp18}, TNode<IntPtrT>{tmp19}}, TNode<IntPtrT>{tmp24});
    TNode<JSReceiver> tmp26;
    USE(tmp26);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp26 = Cast_Callable_1(state_, TNode<Context>{tmp20}, TNode<Object>{tmp25}, &label0);
    ca_.Goto(&block5, tmp17, tmp18, tmp19, tmp20, tmp21, tmp22, tmp23, tmp25, tmp20, tmp26);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block6, tmp17, tmp18, tmp19, tmp20, tmp21, tmp22, tmp23, tmp25, tmp20);
    }
  }

  if (block6.is_used()) {
    TNode<RawPtrT> tmp27;
    TNode<RawPtrT> tmp28;
    TNode<IntPtrT> tmp29;
    TNode<NativeContext> tmp30;
    TNode<Object> tmp31;
    TNode<JSReceiver> tmp32;
    TNode<Number> tmp33;
    TNode<Object> tmp34;
    TNode<NativeContext> tmp35;
    ca_.Bind(&block6, &tmp27, &tmp28, &tmp29, &tmp30, &tmp31, &tmp32, &tmp33, &tmp34, &tmp35);
    ca_.Goto(&block2, tmp27, tmp28, tmp29, tmp30, tmp31);
  }

  if (block5.is_used()) {
    TNode<RawPtrT> tmp36;
    TNode<RawPtrT> tmp37;
    TNode<IntPtrT> tmp38;
    TNode<NativeContext> tmp39;
    TNode<Object> tmp40;
    TNode<JSReceiver> tmp41;
    TNode<Number> tmp42;
    TNode<Object> tmp43;
    TNode<NativeContext> tmp44;
    TNode<JSReceiver> tmp45;
    ca_.Bind(&block5, &tmp36, &tmp37, &tmp38, &tmp39, &tmp40, &tmp41, &tmp42, &tmp43, &tmp44, &tmp45);
    TNode<IntPtrT> tmp46;
    USE(tmp46);
    tmp46 = FromConstexpr_intptr_constexpr_int31_0(state_, 1);
    TNode<BoolT> tmp47;
    USE(tmp47);
    tmp47 = CodeStubAssembler(state_).IntPtrGreaterThan(TNode<IntPtrT>{tmp38}, TNode<IntPtrT>{tmp46});
    ca_.Branch(tmp47, &block7, &block8, tmp36, tmp37, tmp38, tmp39, tmp40, tmp41, tmp42, tmp45);
  }

  if (block7.is_used()) {
    TNode<RawPtrT> tmp48;
    TNode<RawPtrT> tmp49;
    TNode<IntPtrT> tmp50;
    TNode<NativeContext> tmp51;
    TNode<Object> tmp52;
    TNode<JSReceiver> tmp53;
    TNode<Number> tmp54;
    TNode<JSReceiver> tmp55;
    ca_.Bind(&block7, &tmp48, &tmp49, &tmp50, &tmp51, &tmp52, &tmp53, &tmp54, &tmp55);
    TNode<IntPtrT> tmp56;
    USE(tmp56);
    tmp56 = FromConstexpr_intptr_constexpr_int31_0(state_, 1);
    TNode<Object> tmp57;
    USE(tmp57);
    tmp57 = CodeStubAssembler(state_).GetArgumentValue(TorqueStructArguments{TNode<RawPtrT>{tmp48}, TNode<RawPtrT>{tmp49}, TNode<IntPtrT>{tmp50}}, TNode<IntPtrT>{tmp56});
    ca_.Goto(&block9, tmp48, tmp49, tmp50, tmp51, tmp52, tmp53, tmp54, tmp55, tmp57);
  }

  if (block8.is_used()) {
    TNode<RawPtrT> tmp58;
    TNode<RawPtrT> tmp59;
    TNode<IntPtrT> tmp60;
    TNode<NativeContext> tmp61;
    TNode<Object> tmp62;
    TNode<JSReceiver> tmp63;
    TNode<Number> tmp64;
    TNode<JSReceiver> tmp65;
    ca_.Bind(&block8, &tmp58, &tmp59, &tmp60, &tmp61, &tmp62, &tmp63, &tmp64, &tmp65);
    TNode<Oddball> tmp66;
    USE(tmp66);
    tmp66 = Undefined_0(state_);
    ca_.Goto(&block9, tmp58, tmp59, tmp60, tmp61, tmp62, tmp63, tmp64, tmp65, tmp66);
  }

  if (block9.is_used()) {
    TNode<RawPtrT> tmp67;
    TNode<RawPtrT> tmp68;
    TNode<IntPtrT> tmp69;
    TNode<NativeContext> tmp70;
    TNode<Object> tmp71;
    TNode<JSReceiver> tmp72;
    TNode<Number> tmp73;
    TNode<JSReceiver> tmp74;
    TNode<Object> tmp75;
    ca_.Bind(&block9, &tmp67, &tmp68, &tmp69, &tmp70, &tmp71, &tmp72, &tmp73, &tmp74, &tmp75);
    TNode<Number> tmp76;
    USE(tmp76);
    compiler::TypedCodeAssemblerVariable<Smi> result_0_0(&ca_);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp76 = FastArrayFindIndex_0(state_, TNode<Context>{tmp70}, TNode<JSReceiver>{tmp72}, TNode<Number>{tmp73}, TNode<JSReceiver>{tmp74}, TNode<Object>{tmp75}, &label0, &result_0_0);
    ca_.Goto(&block13, tmp67, tmp68, tmp69, tmp70, tmp71, tmp72, tmp73, tmp74, tmp75, tmp72, tmp73, tmp74, tmp75, tmp70, tmp76);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block14, tmp67, tmp68, tmp69, tmp70, tmp71, tmp72, tmp73, tmp74, tmp75, tmp72, tmp73, tmp74, tmp75, tmp70, result_0_0.value());
    }
  }

  if (block14.is_used()) {
    TNode<RawPtrT> tmp77;
    TNode<RawPtrT> tmp78;
    TNode<IntPtrT> tmp79;
    TNode<NativeContext> tmp80;
    TNode<Object> tmp81;
    TNode<JSReceiver> tmp82;
    TNode<Number> tmp83;
    TNode<JSReceiver> tmp84;
    TNode<Object> tmp85;
    TNode<JSReceiver> tmp86;
    TNode<Number> tmp87;
    TNode<JSReceiver> tmp88;
    TNode<Object> tmp89;
    TNode<NativeContext> tmp90;
    TNode<Smi> tmp91;
    ca_.Bind(&block14, &tmp77, &tmp78, &tmp79, &tmp80, &tmp81, &tmp82, &tmp83, &tmp84, &tmp85, &tmp86, &tmp87, &tmp88, &tmp89, &tmp90, &tmp91);
    TNode<Number> tmp92;
    tmp92 = TORQUE_CAST(CodeStubAssembler(state_).CallBuiltin(Builtins::kArrayFindIndexLoopContinuation, tmp80, tmp82, tmp84, tmp85, tmp82, tmp91, tmp83));
    USE(tmp92);
    arguments.PopAndReturn(tmp92);
  }

  if (block13.is_used()) {
    TNode<RawPtrT> tmp93;
    TNode<RawPtrT> tmp94;
    TNode<IntPtrT> tmp95;
    TNode<NativeContext> tmp96;
    TNode<Object> tmp97;
    TNode<JSReceiver> tmp98;
    TNode<Number> tmp99;
    TNode<JSReceiver> tmp100;
    TNode<Object> tmp101;
    TNode<JSReceiver> tmp102;
    TNode<Number> tmp103;
    TNode<JSReceiver> tmp104;
    TNode<Object> tmp105;
    TNode<NativeContext> tmp106;
    TNode<Number> tmp107;
    ca_.Bind(&block13, &tmp93, &tmp94, &tmp95, &tmp96, &tmp97, &tmp98, &tmp99, &tmp100, &tmp101, &tmp102, &tmp103, &tmp104, &tmp105, &tmp106, &tmp107);
    arguments.PopAndReturn(tmp107);
  }

  if (block2.is_used()) {
    TNode<RawPtrT> tmp108;
    TNode<RawPtrT> tmp109;
    TNode<IntPtrT> tmp110;
    TNode<NativeContext> tmp111;
    TNode<Object> tmp112;
    ca_.Bind(&block2, &tmp108, &tmp109, &tmp110, &tmp111, &tmp112);
    TNode<IntPtrT> tmp113;
    USE(tmp113);
    tmp113 = FromConstexpr_intptr_constexpr_int31_0(state_, 0);
    TNode<Object> tmp114;
    USE(tmp114);
    tmp114 = CodeStubAssembler(state_).GetArgumentValue(TorqueStructArguments{TNode<RawPtrT>{tmp108}, TNode<RawPtrT>{tmp109}, TNode<IntPtrT>{tmp110}}, TNode<IntPtrT>{tmp113});
    CodeStubAssembler(state_).ThrowTypeError(TNode<Context>{tmp111}, MessageTemplate::kCalledNonCallable, TNode<Object>{tmp114});
  }
}

TNode<Smi> Convert_Smi_constexpr_int31_0(compiler::CodeAssemblerState* state_, int31_t p_i) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Smi> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0);

  if (block0.is_used()) {
    ca_.Bind(&block0);
    TNode<Smi> tmp0;
    USE(tmp0);
    tmp0 = FromConstexpr_Smi_constexpr_int31_0(state_, p_i);
    ca_.Goto(&block2, tmp0);
  }

    TNode<Smi> tmp1;
    ca_.Bind(&block2, &tmp1);
  return TNode<Smi>{tmp1};
}

}  // namespace internal
}  // namespace v8

