#include "src/builtins/builtins-array-gen.h"
#include "src/builtins/builtins-bigint-gen.h"
#include "src/builtins/builtins-collections-gen.h"
#include "src/builtins/builtins-constructor-gen.h"
#include "src/builtins/builtins-data-view-gen.h"
#include "src/builtins/builtins-iterator-gen.h"
#include "src/builtins/builtins-promise-gen.h"
#include "src/builtins/builtins-promise.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-utils-gen.h"
#include "src/builtins/builtins.h"
#include "src/codegen/code-factory.h"
#include "src/heap/factory-inl.h"
#include "src/objects/arguments.h"
#include "src/objects/bigint.h"
#include "src/objects/elements-kind.h"
#include "src/objects/free-space.h"
#include "src/objects/js-break-iterator.h"
#include "src/objects/js-collator.h"
#include "src/objects/js-date-time-format.h"
#include "src/objects/js-display-names.h"
#include "src/objects/js-generator.h"
#include "src/objects/js-list-format.h"
#include "src/objects/js-locale.h"
#include "src/objects/js-number-format.h"
#include "src/objects/js-objects.h"
#include "src/objects/js-plural-rules.h"
#include "src/objects/js-promise.h"
#include "src/objects/js-regexp-string-iterator.h"
#include "src/objects/js-relative-time-format.h"
#include "src/objects/js-segment-iterator.h"
#include "src/objects/js-segmenter.h"
#include "src/objects/js-weak-refs.h"
#include "src/objects/objects.h"
#include "src/objects/ordered-hash-table.h"
#include "src/objects/property-array.h"
#include "src/objects/property-descriptor-object.h"
#include "src/objects/source-text-module.h"
#include "src/objects/stack-frame-info.h"
#include "src/objects/synthetic-module.h"
#include "src/objects/template-objects.h"
#include "src/torque/runtime-support.h"
#include "torque-generated/../../deps/v8/src/builtins/array-copywithin-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-from-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-isarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-join-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-lastindexof-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-map-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-right-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reverse-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-shift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-splice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-unshift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/base-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/bigint-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/boolean-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/builtins-string-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/collections-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/cast-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/convert-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/console-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/data-view-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/frames-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/frame-arguments-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/growable-fixed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/internal-coverage-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/math-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/number-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-fromentries-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/promise-abstract-operations-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/promise-all-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/promise-all-element-closure-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/promise-constructor-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/promise-finally-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/promise-misc-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/promise-race-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/promise-reaction-job-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/promise-resolve-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/promise-then-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/promise-jobs-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-constructor-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-delete-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-has-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-is-extensible-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-prevent-extensions-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revocable-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revoke-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/reflect-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-exec-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-all-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-replace-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-search-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-source-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-split-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-test-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-endswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-html-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-pad-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-repeat-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-replaceall-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-startswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-substring-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-substr-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/symbol-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/torque-internal-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-createtypedarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-from-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduceright-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-set-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-sort-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-subarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/ic/handler-configuration-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/allocation-site-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/api-callbacks-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/arguments-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/cell-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/code-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/contexts-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/data-handler-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/debug-objects-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/descriptor-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/embedder-data-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/feedback-cell-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/feedback-vector-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/fixed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/foreign-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/free-space-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/heap-number-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/heap-object-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/js-array-buffer-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/js-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/js-collection-iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/js-collection-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/js-generator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/js-objects-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/js-promise-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/js-proxy-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/js-regexp-string-iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/js-regexp-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/js-weak-refs-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/literal-objects-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/map-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/microtask-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/module-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/name-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/oddball-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/ordered-hash-table-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/primitive-heap-object-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/promise-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/property-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/property-cell-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/property-descriptor-object-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/prototype-info-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/regexp-match-info-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/scope-info-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/script-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/shared-function-info-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/source-text-module-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/stack-frame-info-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/string-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/struct-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/synthetic-module-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/template-objects-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/template-tq-csa.h"
#include "torque-generated/../../deps/v8/src/wasm/wasm-objects-tq-csa.h"
#include "torque-generated/../../deps/v8/test/torque/test-torque-tq-csa.h"
#include "torque-generated/../../deps/v8/third_party/v8/builtins/array-sort-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/intl-objects-tq-csa.h"

namespace v8 {
namespace internal {

TNode<FixedArray> Extract_0(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TNode<FixedArray> p_elements, TNode<Smi> p_first, TNode<Smi> p_count, TNode<Smi> p_capacity) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArray, Smi, Smi, Smi> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArray, Smi, Smi, Smi, FixedArray> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_elements, p_first, p_count, p_capacity);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<FixedArray> tmp1;
    TNode<Smi> tmp2;
    TNode<Smi> tmp3;
    TNode<Smi> tmp4;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4);
    TNode<IntPtrT> tmp5;
    USE(tmp5);
    tmp5 = Convert_intptr_Smi_0(state_, TNode<Smi>{tmp2});
    TNode<IntPtrT> tmp6;
    USE(tmp6);
    tmp6 = Convert_intptr_Smi_0(state_, TNode<Smi>{tmp3});
    TNode<IntPtrT> tmp7;
    USE(tmp7);
    tmp7 = Convert_intptr_Smi_0(state_, TNode<Smi>{tmp4});
    TNode<FixedArray> tmp8;
    USE(tmp8);
    tmp8 = ExtractFixedArray_0(state_, TNode<FixedArray>{tmp1}, TNode<IntPtrT>{tmp5}, TNode<IntPtrT>{tmp6}, TNode<IntPtrT>{tmp7});
    ca_.Goto(&block2, tmp0, tmp1, tmp2, tmp3, tmp4, tmp8);
  }

    TNode<Context> tmp9;
    TNode<FixedArray> tmp10;
    TNode<Smi> tmp11;
    TNode<Smi> tmp12;
    TNode<Smi> tmp13;
    TNode<FixedArray> tmp14;
    ca_.Bind(&block2, &tmp9, &tmp10, &tmp11, &tmp12, &tmp13, &tmp14);
  return TNode<FixedArray>{tmp14};
}

TNode<FixedArrayBase> Extract_1(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TNode<FixedArrayBase> p_elements, TNode<Smi> p_first, TNode<Smi> p_count, TNode<Smi> p_capacity) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArrayBase, Smi, Smi, Smi> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArrayBase, Smi, Smi, Smi, FixedArrayBase, FixedArrayBase> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArrayBase, Smi, Smi, Smi, FixedArrayBase, FixedArrayBase, FixedArray> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArrayBase, Smi, Smi, Smi, FixedArrayBase> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, FixedArrayBase, Smi, Smi, Smi, FixedArrayBase> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_elements, p_first, p_count, p_capacity);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<FixedArrayBase> tmp1;
    TNode<Smi> tmp2;
    TNode<Smi> tmp3;
    TNode<Smi> tmp4;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4);
    TNode<FixedArray> tmp5;
    USE(tmp5);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp5 = Cast_EmptyFixedArray_1(state_, TNode<HeapObject>{tmp1}, &label0);
    ca_.Goto(&block4, tmp0, tmp1, tmp2, tmp3, tmp4, tmp1, tmp1, tmp5);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block5, tmp0, tmp1, tmp2, tmp3, tmp4, tmp1, tmp1);
    }
  }

  if (block5.is_used()) {
    TNode<Context> tmp6;
    TNode<FixedArrayBase> tmp7;
    TNode<Smi> tmp8;
    TNode<Smi> tmp9;
    TNode<Smi> tmp10;
    TNode<FixedArrayBase> tmp11;
    TNode<FixedArrayBase> tmp12;
    ca_.Bind(&block5, &tmp6, &tmp7, &tmp8, &tmp9, &tmp10, &tmp11, &tmp12);
    TNode<IntPtrT> tmp13;
    USE(tmp13);
    tmp13 = Convert_intptr_Smi_0(state_, TNode<Smi>{tmp8});
    TNode<IntPtrT> tmp14;
    USE(tmp14);
    tmp14 = Convert_intptr_Smi_0(state_, TNode<Smi>{tmp9});
    TNode<IntPtrT> tmp15;
    USE(tmp15);
    tmp15 = Convert_intptr_Smi_0(state_, TNode<Smi>{tmp10});
    TNode<FixedArrayBase> tmp16;
    USE(tmp16);
    tmp16 = ExtractFixedDoubleArray_0(state_, TNode<FixedDoubleArray>{ca_.UncheckedCast<FixedDoubleArray>(tmp11)}, TNode<IntPtrT>{tmp13}, TNode<IntPtrT>{tmp14}, TNode<IntPtrT>{tmp15});
    ca_.Goto(&block1, tmp6, tmp7, tmp8, tmp9, tmp10, tmp16);
  }

  if (block4.is_used()) {
    TNode<Context> tmp17;
    TNode<FixedArrayBase> tmp18;
    TNode<Smi> tmp19;
    TNode<Smi> tmp20;
    TNode<Smi> tmp21;
    TNode<FixedArrayBase> tmp22;
    TNode<FixedArrayBase> tmp23;
    TNode<FixedArray> tmp24;
    ca_.Bind(&block4, &tmp17, &tmp18, &tmp19, &tmp20, &tmp21, &tmp22, &tmp23, &tmp24);
    TNode<IntPtrT> tmp25;
    USE(tmp25);
    tmp25 = Convert_intptr_Smi_0(state_, TNode<Smi>{tmp21});
    TNode<FixedDoubleArray> tmp26;
    USE(tmp26);
    tmp26 = CodeStubAssembler(state_).AllocateZeroedFixedDoubleArray(TNode<IntPtrT>{tmp25});
    ca_.Goto(&block1, tmp17, tmp18, tmp19, tmp20, tmp21, tmp26);
  }

  if (block1.is_used()) {
    TNode<Context> tmp27;
    TNode<FixedArrayBase> tmp28;
    TNode<Smi> tmp29;
    TNode<Smi> tmp30;
    TNode<Smi> tmp31;
    TNode<FixedArrayBase> tmp32;
    ca_.Bind(&block1, &tmp27, &tmp28, &tmp29, &tmp30, &tmp31, &tmp32);
    ca_.Goto(&block6, tmp27, tmp28, tmp29, tmp30, tmp31, tmp32);
  }

    TNode<Context> tmp33;
    TNode<FixedArrayBase> tmp34;
    TNode<Smi> tmp35;
    TNode<Smi> tmp36;
    TNode<Smi> tmp37;
    TNode<FixedArrayBase> tmp38;
    ca_.Bind(&block6, &tmp33, &tmp34, &tmp35, &tmp36, &tmp37, &tmp38);
  return TNode<FixedArrayBase>{tmp38};
}

TNode<Object> FastArraySplice_0(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TorqueStructArguments p_args, TNode<JSReceiver> p_o, TNode<Number> p_originalLengthNumber, TNode<Number> p_actualStartNumber, TNode<Smi> p_insertCount, TNode<Number> p_actualDeleteCountNumber, compiler::CodeAssemblerLabel* label_Bailout) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Number> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Number, Smi> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Number> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Number, Smi> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Number> block8(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Number, Smi> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSReceiver> block10(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSReceiver, JSArray> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map> block12(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map> block13(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map> block14(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map> block15(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map> block16(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Map, Context> block18(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Map, Context, Int32T> block17(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T> block19(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T> block20(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, IntPtrT> block23(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, IntPtrT> block21(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, IntPtrT, Object> block25(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, IntPtrT, Object> block28(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, IntPtrT, Object, HeapObject> block30(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, IntPtrT, Object, HeapObject> block31(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, IntPtrT, Object, HeapObject, Int32T> block32(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, IntPtrT, Object> block29(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, IntPtrT, Object> block26(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, IntPtrT, Object> block34(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, IntPtrT, Object> block36(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, IntPtrT, Object> block37(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, IntPtrT, Object> block35(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, IntPtrT, Object> block27(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, IntPtrT> block22(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T> block38(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T> block39(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, Number> block41(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, Number, Smi> block40(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, Smi> block42(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, Smi> block43(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, Smi, JSArray> block44(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, Smi, JSArray> block45(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, Smi, JSArray> block46(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, Smi, JSArray> block47(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Smi, Smi, Smi, Smi, Smi, JSArray, Map, Int32T, Int32T, Smi, JSArray> block48(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Object> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Object> block49(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_args.frame, p_args.base, p_args.length, p_o, p_originalLengthNumber, p_actualStartNumber, p_insertCount, p_actualDeleteCountNumber);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<RawPtrT> tmp1;
    TNode<RawPtrT> tmp2;
    TNode<IntPtrT> tmp3;
    TNode<JSReceiver> tmp4;
    TNode<Number> tmp5;
    TNode<Number> tmp6;
    TNode<Smi> tmp7;
    TNode<Number> tmp8;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4, &tmp5, &tmp6, &tmp7, &tmp8);
    TNode<Smi> tmp9;
    USE(tmp9);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp9 = Cast_Smi_0(state_, TNode<Object>{tmp5}, &label0);
    ca_.Goto(&block3, tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp6, tmp7, tmp8, tmp5, tmp9);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block4, tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp6, tmp7, tmp8, tmp5);
    }
  }

  if (block4.is_used()) {
    TNode<Context> tmp10;
    TNode<RawPtrT> tmp11;
    TNode<RawPtrT> tmp12;
    TNode<IntPtrT> tmp13;
    TNode<JSReceiver> tmp14;
    TNode<Number> tmp15;
    TNode<Number> tmp16;
    TNode<Smi> tmp17;
    TNode<Number> tmp18;
    TNode<Number> tmp19;
    ca_.Bind(&block4, &tmp10, &tmp11, &tmp12, &tmp13, &tmp14, &tmp15, &tmp16, &tmp17, &tmp18, &tmp19);
    ca_.Goto(&block1);
  }

  if (block3.is_used()) {
    TNode<Context> tmp20;
    TNode<RawPtrT> tmp21;
    TNode<RawPtrT> tmp22;
    TNode<IntPtrT> tmp23;
    TNode<JSReceiver> tmp24;
    TNode<Number> tmp25;
    TNode<Number> tmp26;
    TNode<Smi> tmp27;
    TNode<Number> tmp28;
    TNode<Number> tmp29;
    TNode<Smi> tmp30;
    ca_.Bind(&block3, &tmp20, &tmp21, &tmp22, &tmp23, &tmp24, &tmp25, &tmp26, &tmp27, &tmp28, &tmp29, &tmp30);
    TNode<Smi> tmp31;
    USE(tmp31);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp31 = Cast_Smi_0(state_, TNode<Object>{tmp26}, &label0);
    ca_.Goto(&block5, tmp20, tmp21, tmp22, tmp23, tmp24, tmp25, tmp26, tmp27, tmp28, tmp30, tmp26, tmp31);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block6, tmp20, tmp21, tmp22, tmp23, tmp24, tmp25, tmp26, tmp27, tmp28, tmp30, tmp26);
    }
  }

  if (block6.is_used()) {
    TNode<Context> tmp32;
    TNode<RawPtrT> tmp33;
    TNode<RawPtrT> tmp34;
    TNode<IntPtrT> tmp35;
    TNode<JSReceiver> tmp36;
    TNode<Number> tmp37;
    TNode<Number> tmp38;
    TNode<Smi> tmp39;
    TNode<Number> tmp40;
    TNode<Smi> tmp41;
    TNode<Number> tmp42;
    ca_.Bind(&block6, &tmp32, &tmp33, &tmp34, &tmp35, &tmp36, &tmp37, &tmp38, &tmp39, &tmp40, &tmp41, &tmp42);
    ca_.Goto(&block1);
  }

  if (block5.is_used()) {
    TNode<Context> tmp43;
    TNode<RawPtrT> tmp44;
    TNode<RawPtrT> tmp45;
    TNode<IntPtrT> tmp46;
    TNode<JSReceiver> tmp47;
    TNode<Number> tmp48;
    TNode<Number> tmp49;
    TNode<Smi> tmp50;
    TNode<Number> tmp51;
    TNode<Smi> tmp52;
    TNode<Number> tmp53;
    TNode<Smi> tmp54;
    ca_.Bind(&block5, &tmp43, &tmp44, &tmp45, &tmp46, &tmp47, &tmp48, &tmp49, &tmp50, &tmp51, &tmp52, &tmp53, &tmp54);
    TNode<Smi> tmp55;
    USE(tmp55);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp55 = Cast_Smi_0(state_, TNode<Object>{tmp51}, &label0);
    ca_.Goto(&block7, tmp43, tmp44, tmp45, tmp46, tmp47, tmp48, tmp49, tmp50, tmp51, tmp52, tmp54, tmp51, tmp55);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block8, tmp43, tmp44, tmp45, tmp46, tmp47, tmp48, tmp49, tmp50, tmp51, tmp52, tmp54, tmp51);
    }
  }

  if (block8.is_used()) {
    TNode<Context> tmp56;
    TNode<RawPtrT> tmp57;
    TNode<RawPtrT> tmp58;
    TNode<IntPtrT> tmp59;
    TNode<JSReceiver> tmp60;
    TNode<Number> tmp61;
    TNode<Number> tmp62;
    TNode<Smi> tmp63;
    TNode<Number> tmp64;
    TNode<Smi> tmp65;
    TNode<Smi> tmp66;
    TNode<Number> tmp67;
    ca_.Bind(&block8, &tmp56, &tmp57, &tmp58, &tmp59, &tmp60, &tmp61, &tmp62, &tmp63, &tmp64, &tmp65, &tmp66, &tmp67);
    ca_.Goto(&block1);
  }

  if (block7.is_used()) {
    TNode<Context> tmp68;
    TNode<RawPtrT> tmp69;
    TNode<RawPtrT> tmp70;
    TNode<IntPtrT> tmp71;
    TNode<JSReceiver> tmp72;
    TNode<Number> tmp73;
    TNode<Number> tmp74;
    TNode<Smi> tmp75;
    TNode<Number> tmp76;
    TNode<Smi> tmp77;
    TNode<Smi> tmp78;
    TNode<Number> tmp79;
    TNode<Smi> tmp80;
    ca_.Bind(&block7, &tmp68, &tmp69, &tmp70, &tmp71, &tmp72, &tmp73, &tmp74, &tmp75, &tmp76, &tmp77, &tmp78, &tmp79, &tmp80);
    TNode<Smi> tmp81;
    USE(tmp81);
    tmp81 = CodeStubAssembler(state_).SmiSub(TNode<Smi>{tmp75}, TNode<Smi>{tmp80});
    TNode<Smi> tmp82;
    USE(tmp82);
    tmp82 = CodeStubAssembler(state_).SmiAdd(TNode<Smi>{tmp77}, TNode<Smi>{tmp81});
    TNode<JSArray> tmp83;
    USE(tmp83);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp83 = Cast_JSArray_0(state_, TNode<HeapObject>{tmp72}, &label0);
    ca_.Goto(&block9, tmp68, tmp69, tmp70, tmp71, tmp72, tmp73, tmp74, tmp75, tmp76, tmp77, tmp78, tmp80, tmp81, tmp82, tmp72, tmp83);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block10, tmp68, tmp69, tmp70, tmp71, tmp72, tmp73, tmp74, tmp75, tmp76, tmp77, tmp78, tmp80, tmp81, tmp82, tmp72);
    }
  }

  if (block10.is_used()) {
    TNode<Context> tmp84;
    TNode<RawPtrT> tmp85;
    TNode<RawPtrT> tmp86;
    TNode<IntPtrT> tmp87;
    TNode<JSReceiver> tmp88;
    TNode<Number> tmp89;
    TNode<Number> tmp90;
    TNode<Smi> tmp91;
    TNode<Number> tmp92;
    TNode<Smi> tmp93;
    TNode<Smi> tmp94;
    TNode<Smi> tmp95;
    TNode<Smi> tmp96;
    TNode<Smi> tmp97;
    TNode<JSReceiver> tmp98;
    ca_.Bind(&block10, &tmp84, &tmp85, &tmp86, &tmp87, &tmp88, &tmp89, &tmp90, &tmp91, &tmp92, &tmp93, &tmp94, &tmp95, &tmp96, &tmp97, &tmp98);
    ca_.Goto(&block1);
  }

  if (block9.is_used()) {
    TNode<Context> tmp99;
    TNode<RawPtrT> tmp100;
    TNode<RawPtrT> tmp101;
    TNode<IntPtrT> tmp102;
    TNode<JSReceiver> tmp103;
    TNode<Number> tmp104;
    TNode<Number> tmp105;
    TNode<Smi> tmp106;
    TNode<Number> tmp107;
    TNode<Smi> tmp108;
    TNode<Smi> tmp109;
    TNode<Smi> tmp110;
    TNode<Smi> tmp111;
    TNode<Smi> tmp112;
    TNode<JSReceiver> tmp113;
    TNode<JSArray> tmp114;
    ca_.Bind(&block9, &tmp99, &tmp100, &tmp101, &tmp102, &tmp103, &tmp104, &tmp105, &tmp106, &tmp107, &tmp108, &tmp109, &tmp110, &tmp111, &tmp112, &tmp113, &tmp114);
    TNode<IntPtrT> tmp115;
    USE(tmp115);
    tmp115 = FromConstexpr_intptr_constexpr_int31_0(state_, 0);
    TNode<Map>tmp116 = CodeStubAssembler(state_).LoadReference<Map>(CodeStubAssembler::Reference{tmp114, tmp115});
    TNode<BoolT> tmp117;
    USE(tmp117);
    tmp117 = CodeStubAssembler(state_).IsPrototypeInitialArrayPrototype(TNode<Context>{tmp99}, TNode<Map>{tmp116});
    TNode<BoolT> tmp118;
    USE(tmp118);
    tmp118 = CodeStubAssembler(state_).Word32BinaryNot(TNode<BoolT>{tmp117});
    ca_.Branch(tmp118, &block11, &block12, tmp99, tmp100, tmp101, tmp102, tmp103, tmp104, tmp105, tmp106, tmp107, tmp108, tmp109, tmp110, tmp111, tmp112, tmp114, tmp116);
  }

  if (block11.is_used()) {
    TNode<Context> tmp119;
    TNode<RawPtrT> tmp120;
    TNode<RawPtrT> tmp121;
    TNode<IntPtrT> tmp122;
    TNode<JSReceiver> tmp123;
    TNode<Number> tmp124;
    TNode<Number> tmp125;
    TNode<Smi> tmp126;
    TNode<Number> tmp127;
    TNode<Smi> tmp128;
    TNode<Smi> tmp129;
    TNode<Smi> tmp130;
    TNode<Smi> tmp131;
    TNode<Smi> tmp132;
    TNode<JSArray> tmp133;
    TNode<Map> tmp134;
    ca_.Bind(&block11, &tmp119, &tmp120, &tmp121, &tmp122, &tmp123, &tmp124, &tmp125, &tmp126, &tmp127, &tmp128, &tmp129, &tmp130, &tmp131, &tmp132, &tmp133, &tmp134);
    ca_.Goto(&block1);
  }

  if (block12.is_used()) {
    TNode<Context> tmp135;
    TNode<RawPtrT> tmp136;
    TNode<RawPtrT> tmp137;
    TNode<IntPtrT> tmp138;
    TNode<JSReceiver> tmp139;
    TNode<Number> tmp140;
    TNode<Number> tmp141;
    TNode<Smi> tmp142;
    TNode<Number> tmp143;
    TNode<Smi> tmp144;
    TNode<Smi> tmp145;
    TNode<Smi> tmp146;
    TNode<Smi> tmp147;
    TNode<Smi> tmp148;
    TNode<JSArray> tmp149;
    TNode<Map> tmp150;
    ca_.Bind(&block12, &tmp135, &tmp136, &tmp137, &tmp138, &tmp139, &tmp140, &tmp141, &tmp142, &tmp143, &tmp144, &tmp145, &tmp146, &tmp147, &tmp148, &tmp149, &tmp150);
    TNode<BoolT> tmp151;
    USE(tmp151);
    tmp151 = CodeStubAssembler(state_).IsNoElementsProtectorCellInvalid();
    ca_.Branch(tmp151, &block13, &block14, tmp135, tmp136, tmp137, tmp138, tmp139, tmp140, tmp141, tmp142, tmp143, tmp144, tmp145, tmp146, tmp147, tmp148, tmp149, tmp150);
  }

  if (block13.is_used()) {
    TNode<Context> tmp152;
    TNode<RawPtrT> tmp153;
    TNode<RawPtrT> tmp154;
    TNode<IntPtrT> tmp155;
    TNode<JSReceiver> tmp156;
    TNode<Number> tmp157;
    TNode<Number> tmp158;
    TNode<Smi> tmp159;
    TNode<Number> tmp160;
    TNode<Smi> tmp161;
    TNode<Smi> tmp162;
    TNode<Smi> tmp163;
    TNode<Smi> tmp164;
    TNode<Smi> tmp165;
    TNode<JSArray> tmp166;
    TNode<Map> tmp167;
    ca_.Bind(&block13, &tmp152, &tmp153, &tmp154, &tmp155, &tmp156, &tmp157, &tmp158, &tmp159, &tmp160, &tmp161, &tmp162, &tmp163, &tmp164, &tmp165, &tmp166, &tmp167);
    ca_.Goto(&block1);
  }

  if (block14.is_used()) {
    TNode<Context> tmp168;
    TNode<RawPtrT> tmp169;
    TNode<RawPtrT> tmp170;
    TNode<IntPtrT> tmp171;
    TNode<JSReceiver> tmp172;
    TNode<Number> tmp173;
    TNode<Number> tmp174;
    TNode<Smi> tmp175;
    TNode<Number> tmp176;
    TNode<Smi> tmp177;
    TNode<Smi> tmp178;
    TNode<Smi> tmp179;
    TNode<Smi> tmp180;
    TNode<Smi> tmp181;
    TNode<JSArray> tmp182;
    TNode<Map> tmp183;
    ca_.Bind(&block14, &tmp168, &tmp169, &tmp170, &tmp171, &tmp172, &tmp173, &tmp174, &tmp175, &tmp176, &tmp177, &tmp178, &tmp179, &tmp180, &tmp181, &tmp182, &tmp183);
    TNode<BoolT> tmp184;
    USE(tmp184);
    tmp184 = CodeStubAssembler(state_).IsArraySpeciesProtectorCellInvalid();
    ca_.Branch(tmp184, &block15, &block16, tmp168, tmp169, tmp170, tmp171, tmp172, tmp173, tmp174, tmp175, tmp176, tmp177, tmp178, tmp179, tmp180, tmp181, tmp182, tmp183);
  }

  if (block15.is_used()) {
    TNode<Context> tmp185;
    TNode<RawPtrT> tmp186;
    TNode<RawPtrT> tmp187;
    TNode<IntPtrT> tmp188;
    TNode<JSReceiver> tmp189;
    TNode<Number> tmp190;
    TNode<Number> tmp191;
    TNode<Smi> tmp192;
    TNode<Number> tmp193;
    TNode<Smi> tmp194;
    TNode<Smi> tmp195;
    TNode<Smi> tmp196;
    TNode<Smi> tmp197;
    TNode<Smi> tmp198;
    TNode<JSArray> tmp199;
    TNode<Map> tmp200;
    ca_.Bind(&block15, &tmp185, &tmp186, &tmp187, &tmp188, &tmp189, &tmp190, &tmp191, &tmp192, &tmp193, &tmp194, &tmp195, &tmp196, &tmp197, &tmp198, &tmp199, &tmp200);
    ca_.Goto(&block1);
  }

  if (block16.is_used()) {
    TNode<Context> tmp201;
    TNode<RawPtrT> tmp202;
    TNode<RawPtrT> tmp203;
    TNode<IntPtrT> tmp204;
    TNode<JSReceiver> tmp205;
    TNode<Number> tmp206;
    TNode<Number> tmp207;
    TNode<Smi> tmp208;
    TNode<Number> tmp209;
    TNode<Smi> tmp210;
    TNode<Smi> tmp211;
    TNode<Smi> tmp212;
    TNode<Smi> tmp213;
    TNode<Smi> tmp214;
    TNode<JSArray> tmp215;
    TNode<Map> tmp216;
    ca_.Bind(&block16, &tmp201, &tmp202, &tmp203, &tmp204, &tmp205, &tmp206, &tmp207, &tmp208, &tmp209, &tmp210, &tmp211, &tmp212, &tmp213, &tmp214, &tmp215, &tmp216);
    TNode<Int32T> tmp217;
    USE(tmp217);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp217 = CodeStubAssembler(state_).EnsureArrayPushable(TNode<Context>{tmp201}, TNode<Map>{tmp216}, &label0);
    ca_.Goto(&block17, tmp201, tmp202, tmp203, tmp204, tmp205, tmp206, tmp207, tmp208, tmp209, tmp210, tmp211, tmp212, tmp213, tmp214, tmp215, tmp216, tmp216, tmp201, tmp217);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block18, tmp201, tmp202, tmp203, tmp204, tmp205, tmp206, tmp207, tmp208, tmp209, tmp210, tmp211, tmp212, tmp213, tmp214, tmp215, tmp216, tmp216, tmp201);
    }
  }

  if (block18.is_used()) {
    TNode<Context> tmp218;
    TNode<RawPtrT> tmp219;
    TNode<RawPtrT> tmp220;
    TNode<IntPtrT> tmp221;
    TNode<JSReceiver> tmp222;
    TNode<Number> tmp223;
    TNode<Number> tmp224;
    TNode<Smi> tmp225;
    TNode<Number> tmp226;
    TNode<Smi> tmp227;
    TNode<Smi> tmp228;
    TNode<Smi> tmp229;
    TNode<Smi> tmp230;
    TNode<Smi> tmp231;
    TNode<JSArray> tmp232;
    TNode<Map> tmp233;
    TNode<Map> tmp234;
    TNode<Context> tmp235;
    ca_.Bind(&block18, &tmp218, &tmp219, &tmp220, &tmp221, &tmp222, &tmp223, &tmp224, &tmp225, &tmp226, &tmp227, &tmp228, &tmp229, &tmp230, &tmp231, &tmp232, &tmp233, &tmp234, &tmp235);
    ca_.Goto(&block1);
  }

  if (block17.is_used()) {
    TNode<Context> tmp236;
    TNode<RawPtrT> tmp237;
    TNode<RawPtrT> tmp238;
    TNode<IntPtrT> tmp239;
    TNode<JSReceiver> tmp240;
    TNode<Number> tmp241;
    TNode<Number> tmp242;
    TNode<Smi> tmp243;
    TNode<Number> tmp244;
    TNode<Smi> tmp245;
    TNode<Smi> tmp246;
    TNode<Smi> tmp247;
    TNode<Smi> tmp248;
    TNode<Smi> tmp249;
    TNode<JSArray> tmp250;
    TNode<Map> tmp251;
    TNode<Map> tmp252;
    TNode<Context> tmp253;
    TNode<Int32T> tmp254;
    ca_.Bind(&block17, &tmp236, &tmp237, &tmp238, &tmp239, &tmp240, &tmp241, &tmp242, &tmp243, &tmp244, &tmp245, &tmp246, &tmp247, &tmp248, &tmp249, &tmp250, &tmp251, &tmp252, &tmp253, &tmp254);
    TNode<BoolT> tmp255;
    USE(tmp255);
    tmp255 = CodeStubAssembler(state_).IsFastElementsKind(TNode<Int32T>{tmp254});
    TNode<BoolT> tmp256;
    USE(tmp256);
    tmp256 = CodeStubAssembler(state_).Word32BinaryNot(TNode<BoolT>{tmp255});
    ca_.Branch(tmp256, &block19, &block20, tmp236, tmp237, tmp238, tmp239, tmp240, tmp241, tmp242, tmp243, tmp244, tmp245, tmp246, tmp247, tmp248, tmp249, tmp250, tmp251, tmp254);
  }

  if (block19.is_used()) {
    TNode<Context> tmp257;
    TNode<RawPtrT> tmp258;
    TNode<RawPtrT> tmp259;
    TNode<IntPtrT> tmp260;
    TNode<JSReceiver> tmp261;
    TNode<Number> tmp262;
    TNode<Number> tmp263;
    TNode<Smi> tmp264;
    TNode<Number> tmp265;
    TNode<Smi> tmp266;
    TNode<Smi> tmp267;
    TNode<Smi> tmp268;
    TNode<Smi> tmp269;
    TNode<Smi> tmp270;
    TNode<JSArray> tmp271;
    TNode<Map> tmp272;
    TNode<Int32T> tmp273;
    ca_.Bind(&block19, &tmp257, &tmp258, &tmp259, &tmp260, &tmp261, &tmp262, &tmp263, &tmp264, &tmp265, &tmp266, &tmp267, &tmp268, &tmp269, &tmp270, &tmp271, &tmp272, &tmp273);
    ca_.Goto(&block1);
  }

  if (block20.is_used()) {
    TNode<Context> tmp274;
    TNode<RawPtrT> tmp275;
    TNode<RawPtrT> tmp276;
    TNode<IntPtrT> tmp277;
    TNode<JSReceiver> tmp278;
    TNode<Number> tmp279;
    TNode<Number> tmp280;
    TNode<Smi> tmp281;
    TNode<Number> tmp282;
    TNode<Smi> tmp283;
    TNode<Smi> tmp284;
    TNode<Smi> tmp285;
    TNode<Smi> tmp286;
    TNode<Smi> tmp287;
    TNode<JSArray> tmp288;
    TNode<Map> tmp289;
    TNode<Int32T> tmp290;
    ca_.Bind(&block20, &tmp274, &tmp275, &tmp276, &tmp277, &tmp278, &tmp279, &tmp280, &tmp281, &tmp282, &tmp283, &tmp284, &tmp285, &tmp286, &tmp287, &tmp288, &tmp289, &tmp290);
    TNode<IntPtrT> tmp291;
    USE(tmp291);
    tmp291 = FromConstexpr_intptr_constexpr_int31_0(state_, 2);
    ca_.Goto(&block23, tmp274, tmp275, tmp276, tmp277, tmp278, tmp279, tmp280, tmp281, tmp282, tmp283, tmp284, tmp285, tmp286, tmp287, tmp288, tmp289, tmp290, tmp290, tmp291);
  }

  if (block23.is_used()) {
    TNode<Context> tmp292;
    TNode<RawPtrT> tmp293;
    TNode<RawPtrT> tmp294;
    TNode<IntPtrT> tmp295;
    TNode<JSReceiver> tmp296;
    TNode<Number> tmp297;
    TNode<Number> tmp298;
    TNode<Smi> tmp299;
    TNode<Number> tmp300;
    TNode<Smi> tmp301;
    TNode<Smi> tmp302;
    TNode<Smi> tmp303;
    TNode<Smi> tmp304;
    TNode<Smi> tmp305;
    TNode<JSArray> tmp306;
    TNode<Map> tmp307;
    TNode<Int32T> tmp308;
    TNode<Int32T> tmp309;
    TNode<IntPtrT> tmp310;
    ca_.Bind(&block23, &tmp292, &tmp293, &tmp294, &tmp295, &tmp296, &tmp297, &tmp298, &tmp299, &tmp300, &tmp301, &tmp302, &tmp303, &tmp304, &tmp305, &tmp306, &tmp307, &tmp308, &tmp309, &tmp310);
    TNode<BoolT> tmp311;
    USE(tmp311);
    tmp311 = CodeStubAssembler(state_).IntPtrLessThan(TNode<IntPtrT>{tmp310}, TNode<IntPtrT>{tmp295});
    ca_.Branch(tmp311, &block21, &block22, tmp292, tmp293, tmp294, tmp295, tmp296, tmp297, tmp298, tmp299, tmp300, tmp301, tmp302, tmp303, tmp304, tmp305, tmp306, tmp307, tmp308, tmp309, tmp310);
  }

  if (block21.is_used()) {
    TNode<Context> tmp312;
    TNode<RawPtrT> tmp313;
    TNode<RawPtrT> tmp314;
    TNode<IntPtrT> tmp315;
    TNode<JSReceiver> tmp316;
    TNode<Number> tmp317;
    TNode<Number> tmp318;
    TNode<Smi> tmp319;
    TNode<Number> tmp320;
    TNode<Smi> tmp321;
    TNode<Smi> tmp322;
    TNode<Smi> tmp323;
    TNode<Smi> tmp324;
    TNode<Smi> tmp325;
    TNode<JSArray> tmp326;
    TNode<Map> tmp327;
    TNode<Int32T> tmp328;
    TNode<Int32T> tmp329;
    TNode<IntPtrT> tmp330;
    ca_.Bind(&block21, &tmp312, &tmp313, &tmp314, &tmp315, &tmp316, &tmp317, &tmp318, &tmp319, &tmp320, &tmp321, &tmp322, &tmp323, &tmp324, &tmp325, &tmp326, &tmp327, &tmp328, &tmp329, &tmp330);
    TNode<Object> tmp331;
    USE(tmp331);
    tmp331 = CodeStubAssembler(state_).GetArgumentValue(TorqueStructArguments{TNode<RawPtrT>{tmp313}, TNode<RawPtrT>{tmp314}, TNode<IntPtrT>{tmp315}}, TNode<IntPtrT>{tmp330});
    TNode<BoolT> tmp332;
    USE(tmp332);
    tmp332 = CodeStubAssembler(state_).IsFastSmiElementsKind(TNode<Int32T>{tmp328});
    ca_.Branch(tmp332, &block25, &block26, tmp312, tmp313, tmp314, tmp315, tmp316, tmp317, tmp318, tmp319, tmp320, tmp321, tmp322, tmp323, tmp324, tmp325, tmp326, tmp327, tmp328, tmp329, tmp330, tmp331);
  }

  if (block25.is_used()) {
    TNode<Context> tmp333;
    TNode<RawPtrT> tmp334;
    TNode<RawPtrT> tmp335;
    TNode<IntPtrT> tmp336;
    TNode<JSReceiver> tmp337;
    TNode<Number> tmp338;
    TNode<Number> tmp339;
    TNode<Smi> tmp340;
    TNode<Number> tmp341;
    TNode<Smi> tmp342;
    TNode<Smi> tmp343;
    TNode<Smi> tmp344;
    TNode<Smi> tmp345;
    TNode<Smi> tmp346;
    TNode<JSArray> tmp347;
    TNode<Map> tmp348;
    TNode<Int32T> tmp349;
    TNode<Int32T> tmp350;
    TNode<IntPtrT> tmp351;
    TNode<Object> tmp352;
    ca_.Bind(&block25, &tmp333, &tmp334, &tmp335, &tmp336, &tmp337, &tmp338, &tmp339, &tmp340, &tmp341, &tmp342, &tmp343, &tmp344, &tmp345, &tmp346, &tmp347, &tmp348, &tmp349, &tmp350, &tmp351, &tmp352);
    TNode<BoolT> tmp353;
    USE(tmp353);
    tmp353 = CodeStubAssembler(state_).TaggedIsNotSmi(TNode<Object>{tmp352});
    ca_.Branch(tmp353, &block28, &block29, tmp333, tmp334, tmp335, tmp336, tmp337, tmp338, tmp339, tmp340, tmp341, tmp342, tmp343, tmp344, tmp345, tmp346, tmp347, tmp348, tmp349, tmp350, tmp351, tmp352);
  }

  if (block28.is_used()) {
    TNode<Context> tmp354;
    TNode<RawPtrT> tmp355;
    TNode<RawPtrT> tmp356;
    TNode<IntPtrT> tmp357;
    TNode<JSReceiver> tmp358;
    TNode<Number> tmp359;
    TNode<Number> tmp360;
    TNode<Smi> tmp361;
    TNode<Number> tmp362;
    TNode<Smi> tmp363;
    TNode<Smi> tmp364;
    TNode<Smi> tmp365;
    TNode<Smi> tmp366;
    TNode<Smi> tmp367;
    TNode<JSArray> tmp368;
    TNode<Map> tmp369;
    TNode<Int32T> tmp370;
    TNode<Int32T> tmp371;
    TNode<IntPtrT> tmp372;
    TNode<Object> tmp373;
    ca_.Bind(&block28, &tmp354, &tmp355, &tmp356, &tmp357, &tmp358, &tmp359, &tmp360, &tmp361, &tmp362, &tmp363, &tmp364, &tmp365, &tmp366, &tmp367, &tmp368, &tmp369, &tmp370, &tmp371, &tmp372, &tmp373);
    TNode<HeapObject> tmp374;
    USE(tmp374);
    tmp374 = UnsafeCast_HeapObject_0(state_, TNode<Context>{tmp354}, TNode<Object>{tmp373});
    TNode<BoolT> tmp375;
    USE(tmp375);
    tmp375 = CodeStubAssembler(state_).IsHeapNumber(TNode<HeapObject>{tmp374});
    ca_.Branch(tmp375, &block30, &block31, tmp354, tmp355, tmp356, tmp357, tmp358, tmp359, tmp360, tmp361, tmp362, tmp363, tmp364, tmp365, tmp366, tmp367, tmp368, tmp369, tmp370, tmp371, tmp372, tmp373, tmp374);
  }

  if (block30.is_used()) {
    TNode<Context> tmp376;
    TNode<RawPtrT> tmp377;
    TNode<RawPtrT> tmp378;
    TNode<IntPtrT> tmp379;
    TNode<JSReceiver> tmp380;
    TNode<Number> tmp381;
    TNode<Number> tmp382;
    TNode<Smi> tmp383;
    TNode<Number> tmp384;
    TNode<Smi> tmp385;
    TNode<Smi> tmp386;
    TNode<Smi> tmp387;
    TNode<Smi> tmp388;
    TNode<Smi> tmp389;
    TNode<JSArray> tmp390;
    TNode<Map> tmp391;
    TNode<Int32T> tmp392;
    TNode<Int32T> tmp393;
    TNode<IntPtrT> tmp394;
    TNode<Object> tmp395;
    TNode<HeapObject> tmp396;
    ca_.Bind(&block30, &tmp376, &tmp377, &tmp378, &tmp379, &tmp380, &tmp381, &tmp382, &tmp383, &tmp384, &tmp385, &tmp386, &tmp387, &tmp388, &tmp389, &tmp390, &tmp391, &tmp392, &tmp393, &tmp394, &tmp395, &tmp396);
    TNode<Int32T> tmp397;
    USE(tmp397);
    tmp397 = AllowDoubleElements_0(state_, TNode<Int32T>{tmp392});
    ca_.Goto(&block32, tmp376, tmp377, tmp378, tmp379, tmp380, tmp381, tmp382, tmp383, tmp384, tmp385, tmp386, tmp387, tmp388, tmp389, tmp390, tmp391, tmp392, tmp393, tmp394, tmp395, tmp396, tmp397);
  }

  if (block31.is_used()) {
    TNode<Context> tmp398;
    TNode<RawPtrT> tmp399;
    TNode<RawPtrT> tmp400;
    TNode<IntPtrT> tmp401;
    TNode<JSReceiver> tmp402;
    TNode<Number> tmp403;
    TNode<Number> tmp404;
    TNode<Smi> tmp405;
    TNode<Number> tmp406;
    TNode<Smi> tmp407;
    TNode<Smi> tmp408;
    TNode<Smi> tmp409;
    TNode<Smi> tmp410;
    TNode<Smi> tmp411;
    TNode<JSArray> tmp412;
    TNode<Map> tmp413;
    TNode<Int32T> tmp414;
    TNode<Int32T> tmp415;
    TNode<IntPtrT> tmp416;
    TNode<Object> tmp417;
    TNode<HeapObject> tmp418;
    ca_.Bind(&block31, &tmp398, &tmp399, &tmp400, &tmp401, &tmp402, &tmp403, &tmp404, &tmp405, &tmp406, &tmp407, &tmp408, &tmp409, &tmp410, &tmp411, &tmp412, &tmp413, &tmp414, &tmp415, &tmp416, &tmp417, &tmp418);
    TNode<Int32T> tmp419;
    USE(tmp419);
    tmp419 = AllowNonNumberElements_0(state_, TNode<Int32T>{tmp414});
    ca_.Goto(&block32, tmp398, tmp399, tmp400, tmp401, tmp402, tmp403, tmp404, tmp405, tmp406, tmp407, tmp408, tmp409, tmp410, tmp411, tmp412, tmp413, tmp414, tmp415, tmp416, tmp417, tmp418, tmp419);
  }

  if (block32.is_used()) {
    TNode<Context> tmp420;
    TNode<RawPtrT> tmp421;
    TNode<RawPtrT> tmp422;
    TNode<IntPtrT> tmp423;
    TNode<JSReceiver> tmp424;
    TNode<Number> tmp425;
    TNode<Number> tmp426;
    TNode<Smi> tmp427;
    TNode<Number> tmp428;
    TNode<Smi> tmp429;
    TNode<Smi> tmp430;
    TNode<Smi> tmp431;
    TNode<Smi> tmp432;
    TNode<Smi> tmp433;
    TNode<JSArray> tmp434;
    TNode<Map> tmp435;
    TNode<Int32T> tmp436;
    TNode<Int32T> tmp437;
    TNode<IntPtrT> tmp438;
    TNode<Object> tmp439;
    TNode<HeapObject> tmp440;
    TNode<Int32T> tmp441;
    ca_.Bind(&block32, &tmp420, &tmp421, &tmp422, &tmp423, &tmp424, &tmp425, &tmp426, &tmp427, &tmp428, &tmp429, &tmp430, &tmp431, &tmp432, &tmp433, &tmp434, &tmp435, &tmp436, &tmp437, &tmp438, &tmp439, &tmp440, &tmp441);
    ca_.Goto(&block29, tmp420, tmp421, tmp422, tmp423, tmp424, tmp425, tmp426, tmp427, tmp428, tmp429, tmp430, tmp431, tmp432, tmp433, tmp434, tmp435, tmp441, tmp437, tmp438, tmp439);
  }

  if (block29.is_used()) {
    TNode<Context> tmp442;
    TNode<RawPtrT> tmp443;
    TNode<RawPtrT> tmp444;
    TNode<IntPtrT> tmp445;
    TNode<JSReceiver> tmp446;
    TNode<Number> tmp447;
    TNode<Number> tmp448;
    TNode<Smi> tmp449;
    TNode<Number> tmp450;
    TNode<Smi> tmp451;
    TNode<Smi> tmp452;
    TNode<Smi> tmp453;
    TNode<Smi> tmp454;
    TNode<Smi> tmp455;
    TNode<JSArray> tmp456;
    TNode<Map> tmp457;
    TNode<Int32T> tmp458;
    TNode<Int32T> tmp459;
    TNode<IntPtrT> tmp460;
    TNode<Object> tmp461;
    ca_.Bind(&block29, &tmp442, &tmp443, &tmp444, &tmp445, &tmp446, &tmp447, &tmp448, &tmp449, &tmp450, &tmp451, &tmp452, &tmp453, &tmp454, &tmp455, &tmp456, &tmp457, &tmp458, &tmp459, &tmp460, &tmp461);
    ca_.Goto(&block27, tmp442, tmp443, tmp444, tmp445, tmp446, tmp447, tmp448, tmp449, tmp450, tmp451, tmp452, tmp453, tmp454, tmp455, tmp456, tmp457, tmp458, tmp459, tmp460, tmp461);
  }

  if (block26.is_used()) {
    TNode<Context> tmp462;
    TNode<RawPtrT> tmp463;
    TNode<RawPtrT> tmp464;
    TNode<IntPtrT> tmp465;
    TNode<JSReceiver> tmp466;
    TNode<Number> tmp467;
    TNode<Number> tmp468;
    TNode<Smi> tmp469;
    TNode<Number> tmp470;
    TNode<Smi> tmp471;
    TNode<Smi> tmp472;
    TNode<Smi> tmp473;
    TNode<Smi> tmp474;
    TNode<Smi> tmp475;
    TNode<JSArray> tmp476;
    TNode<Map> tmp477;
    TNode<Int32T> tmp478;
    TNode<Int32T> tmp479;
    TNode<IntPtrT> tmp480;
    TNode<Object> tmp481;
    ca_.Bind(&block26, &tmp462, &tmp463, &tmp464, &tmp465, &tmp466, &tmp467, &tmp468, &tmp469, &tmp470, &tmp471, &tmp472, &tmp473, &tmp474, &tmp475, &tmp476, &tmp477, &tmp478, &tmp479, &tmp480, &tmp481);
    TNode<BoolT> tmp482;
    USE(tmp482);
    tmp482 = CodeStubAssembler(state_).IsDoubleElementsKind(TNode<Int32T>{tmp478});
    ca_.Branch(tmp482, &block34, &block35, tmp462, tmp463, tmp464, tmp465, tmp466, tmp467, tmp468, tmp469, tmp470, tmp471, tmp472, tmp473, tmp474, tmp475, tmp476, tmp477, tmp478, tmp479, tmp480, tmp481);
  }

  if (block34.is_used()) {
    TNode<Context> tmp483;
    TNode<RawPtrT> tmp484;
    TNode<RawPtrT> tmp485;
    TNode<IntPtrT> tmp486;
    TNode<JSReceiver> tmp487;
    TNode<Number> tmp488;
    TNode<Number> tmp489;
    TNode<Smi> tmp490;
    TNode<Number> tmp491;
    TNode<Smi> tmp492;
    TNode<Smi> tmp493;
    TNode<Smi> tmp494;
    TNode<Smi> tmp495;
    TNode<Smi> tmp496;
    TNode<JSArray> tmp497;
    TNode<Map> tmp498;
    TNode<Int32T> tmp499;
    TNode<Int32T> tmp500;
    TNode<IntPtrT> tmp501;
    TNode<Object> tmp502;
    ca_.Bind(&block34, &tmp483, &tmp484, &tmp485, &tmp486, &tmp487, &tmp488, &tmp489, &tmp490, &tmp491, &tmp492, &tmp493, &tmp494, &tmp495, &tmp496, &tmp497, &tmp498, &tmp499, &tmp500, &tmp501, &tmp502);
    TNode<BoolT> tmp503;
    USE(tmp503);
    tmp503 = CodeStubAssembler(state_).IsNumber(TNode<Object>{tmp502});
    TNode<BoolT> tmp504;
    USE(tmp504);
    tmp504 = CodeStubAssembler(state_).Word32BinaryNot(TNode<BoolT>{tmp503});
    ca_.Branch(tmp504, &block36, &block37, tmp483, tmp484, tmp485, tmp486, tmp487, tmp488, tmp489, tmp490, tmp491, tmp492, tmp493, tmp494, tmp495, tmp496, tmp497, tmp498, tmp499, tmp500, tmp501, tmp502);
  }

  if (block36.is_used()) {
    TNode<Context> tmp505;
    TNode<RawPtrT> tmp506;
    TNode<RawPtrT> tmp507;
    TNode<IntPtrT> tmp508;
    TNode<JSReceiver> tmp509;
    TNode<Number> tmp510;
    TNode<Number> tmp511;
    TNode<Smi> tmp512;
    TNode<Number> tmp513;
    TNode<Smi> tmp514;
    TNode<Smi> tmp515;
    TNode<Smi> tmp516;
    TNode<Smi> tmp517;
    TNode<Smi> tmp518;
    TNode<JSArray> tmp519;
    TNode<Map> tmp520;
    TNode<Int32T> tmp521;
    TNode<Int32T> tmp522;
    TNode<IntPtrT> tmp523;
    TNode<Object> tmp524;
    ca_.Bind(&block36, &tmp505, &tmp506, &tmp507, &tmp508, &tmp509, &tmp510, &tmp511, &tmp512, &tmp513, &tmp514, &tmp515, &tmp516, &tmp517, &tmp518, &tmp519, &tmp520, &tmp521, &tmp522, &tmp523, &tmp524);
    TNode<Int32T> tmp525;
    USE(tmp525);
    tmp525 = AllowNonNumberElements_0(state_, TNode<Int32T>{tmp521});
    ca_.Goto(&block37, tmp505, tmp506, tmp507, tmp508, tmp509, tmp510, tmp511, tmp512, tmp513, tmp514, tmp515, tmp516, tmp517, tmp518, tmp519, tmp520, tmp525, tmp522, tmp523, tmp524);
  }

  if (block37.is_used()) {
    TNode<Context> tmp526;
    TNode<RawPtrT> tmp527;
    TNode<RawPtrT> tmp528;
    TNode<IntPtrT> tmp529;
    TNode<JSReceiver> tmp530;
    TNode<Number> tmp531;
    TNode<Number> tmp532;
    TNode<Smi> tmp533;
    TNode<Number> tmp534;
    TNode<Smi> tmp535;
    TNode<Smi> tmp536;
    TNode<Smi> tmp537;
    TNode<Smi> tmp538;
    TNode<Smi> tmp539;
    TNode<JSArray> tmp540;
    TNode<Map> tmp541;
    TNode<Int32T> tmp542;
    TNode<Int32T> tmp543;
    TNode<IntPtrT> tmp544;
    TNode<Object> tmp545;
    ca_.Bind(&block37, &tmp526, &tmp527, &tmp528, &tmp529, &tmp530, &tmp531, &tmp532, &tmp533, &tmp534, &tmp535, &tmp536, &tmp537, &tmp538, &tmp539, &tmp540, &tmp541, &tmp542, &tmp543, &tmp544, &tmp545);
    ca_.Goto(&block35, tmp526, tmp527, tmp528, tmp529, tmp530, tmp531, tmp532, tmp533, tmp534, tmp535, tmp536, tmp537, tmp538, tmp539, tmp540, tmp541, tmp542, tmp543, tmp544, tmp545);
  }

  if (block35.is_used()) {
    TNode<Context> tmp546;
    TNode<RawPtrT> tmp547;
    TNode<RawPtrT> tmp548;
    TNode<IntPtrT> tmp549;
    TNode<JSReceiver> tmp550;
    TNode<Number> tmp551;
    TNode<Number> tmp552;
    TNode<Smi> tmp553;
    TNode<Number> tmp554;
    TNode<Smi> tmp555;
    TNode<Smi> tmp556;
    TNode<Smi> tmp557;
    TNode<Smi> tmp558;
    TNode<Smi> tmp559;
    TNode<JSArray> tmp560;
    TNode<Map> tmp561;
    TNode<Int32T> tmp562;
    TNode<Int32T> tmp563;
    TNode<IntPtrT> tmp564;
    TNode<Object> tmp565;
    ca_.Bind(&block35, &tmp546, &tmp547, &tmp548, &tmp549, &tmp550, &tmp551, &tmp552, &tmp553, &tmp554, &tmp555, &tmp556, &tmp557, &tmp558, &tmp559, &tmp560, &tmp561, &tmp562, &tmp563, &tmp564, &tmp565);
    ca_.Goto(&block27, tmp546, tmp547, tmp548, tmp549, tmp550, tmp551, tmp552, tmp553, tmp554, tmp555, tmp556, tmp557, tmp558, tmp559, tmp560, tmp561, tmp562, tmp563, tmp564, tmp565);
  }

  if (block27.is_used()) {
    TNode<Context> tmp566;
    TNode<RawPtrT> tmp567;
    TNode<RawPtrT> tmp568;
    TNode<IntPtrT> tmp569;
    TNode<JSReceiver> tmp570;
    TNode<Number> tmp571;
    TNode<Number> tmp572;
    TNode<Smi> tmp573;
    TNode<Number> tmp574;
    TNode<Smi> tmp575;
    TNode<Smi> tmp576;
    TNode<Smi> tmp577;
    TNode<Smi> tmp578;
    TNode<Smi> tmp579;
    TNode<JSArray> tmp580;
    TNode<Map> tmp581;
    TNode<Int32T> tmp582;
    TNode<Int32T> tmp583;
    TNode<IntPtrT> tmp584;
    TNode<Object> tmp585;
    ca_.Bind(&block27, &tmp566, &tmp567, &tmp568, &tmp569, &tmp570, &tmp571, &tmp572, &tmp573, &tmp574, &tmp575, &tmp576, &tmp577, &tmp578, &tmp579, &tmp580, &tmp581, &tmp582, &tmp583, &tmp584, &tmp585);
    TNode<IntPtrT> tmp586;
    USE(tmp586);
    tmp586 = FromConstexpr_intptr_constexpr_int31_0(state_, 1);
    TNode<IntPtrT> tmp587;
    USE(tmp587);
    tmp587 = CodeStubAssembler(state_).IntPtrAdd(TNode<IntPtrT>{tmp584}, TNode<IntPtrT>{tmp586});
    ca_.Goto(&block23, tmp566, tmp567, tmp568, tmp569, tmp570, tmp571, tmp572, tmp573, tmp574, tmp575, tmp576, tmp577, tmp578, tmp579, tmp580, tmp581, tmp582, tmp583, tmp587);
  }

  if (block22.is_used()) {
    TNode<Context> tmp588;
    TNode<RawPtrT> tmp589;
    TNode<RawPtrT> tmp590;
    TNode<IntPtrT> tmp591;
    TNode<JSReceiver> tmp592;
    TNode<Number> tmp593;
    TNode<Number> tmp594;
    TNode<Smi> tmp595;
    TNode<Number> tmp596;
    TNode<Smi> tmp597;
    TNode<Smi> tmp598;
    TNode<Smi> tmp599;
    TNode<Smi> tmp600;
    TNode<Smi> tmp601;
    TNode<JSArray> tmp602;
    TNode<Map> tmp603;
    TNode<Int32T> tmp604;
    TNode<Int32T> tmp605;
    TNode<IntPtrT> tmp606;
    ca_.Bind(&block22, &tmp588, &tmp589, &tmp590, &tmp591, &tmp592, &tmp593, &tmp594, &tmp595, &tmp596, &tmp597, &tmp598, &tmp599, &tmp600, &tmp601, &tmp602, &tmp603, &tmp604, &tmp605, &tmp606);
    TNode<BoolT> tmp607;
    USE(tmp607);
    tmp607 = ElementsKindNotEqual_0(state_, TNode<Int32T>{tmp604}, TNode<Int32T>{tmp605});
    ca_.Branch(tmp607, &block38, &block39, tmp588, tmp589, tmp590, tmp591, tmp592, tmp593, tmp594, tmp595, tmp596, tmp597, tmp598, tmp599, tmp600, tmp601, tmp602, tmp603, tmp604, tmp605);
  }

  if (block38.is_used()) {
    TNode<Context> tmp608;
    TNode<RawPtrT> tmp609;
    TNode<RawPtrT> tmp610;
    TNode<IntPtrT> tmp611;
    TNode<JSReceiver> tmp612;
    TNode<Number> tmp613;
    TNode<Number> tmp614;
    TNode<Smi> tmp615;
    TNode<Number> tmp616;
    TNode<Smi> tmp617;
    TNode<Smi> tmp618;
    TNode<Smi> tmp619;
    TNode<Smi> tmp620;
    TNode<Smi> tmp621;
    TNode<JSArray> tmp622;
    TNode<Map> tmp623;
    TNode<Int32T> tmp624;
    TNode<Int32T> tmp625;
    ca_.Bind(&block38, &tmp608, &tmp609, &tmp610, &tmp611, &tmp612, &tmp613, &tmp614, &tmp615, &tmp616, &tmp617, &tmp618, &tmp619, &tmp620, &tmp621, &tmp622, &tmp623, &tmp624, &tmp625);
    TNode<Int32T> tmp626;
    USE(tmp626);
    tmp626 = Convert_int32_ElementsKind_0(state_, TNode<Int32T>{tmp624});
    TNode<Smi> tmp627;
    USE(tmp627);
    tmp627 = Convert_Smi_int32_0(state_, TNode<Int32T>{tmp626});
    CodeStubAssembler(state_).CallRuntime(Runtime::kTransitionElementsKindWithKind, tmp608, tmp622, tmp627);
    ca_.Goto(&block39, tmp608, tmp609, tmp610, tmp611, tmp612, tmp613, tmp614, tmp615, tmp616, tmp617, tmp618, tmp619, tmp620, tmp621, tmp622, tmp623, tmp624, tmp625);
  }

  if (block39.is_used()) {
    TNode<Context> tmp629;
    TNode<RawPtrT> tmp630;
    TNode<RawPtrT> tmp631;
    TNode<IntPtrT> tmp632;
    TNode<JSReceiver> tmp633;
    TNode<Number> tmp634;
    TNode<Number> tmp635;
    TNode<Smi> tmp636;
    TNode<Number> tmp637;
    TNode<Smi> tmp638;
    TNode<Smi> tmp639;
    TNode<Smi> tmp640;
    TNode<Smi> tmp641;
    TNode<Smi> tmp642;
    TNode<JSArray> tmp643;
    TNode<Map> tmp644;
    TNode<Int32T> tmp645;
    TNode<Int32T> tmp646;
    ca_.Bind(&block39, &tmp629, &tmp630, &tmp631, &tmp632, &tmp633, &tmp634, &tmp635, &tmp636, &tmp637, &tmp638, &tmp639, &tmp640, &tmp641, &tmp642, &tmp643, &tmp644, &tmp645, &tmp646);
    TNode<IntPtrT> tmp647;
    USE(tmp647);
    tmp647 = FromConstexpr_intptr_constexpr_int31_0(state_, 24);
    TNode<Number>tmp648 = CodeStubAssembler(state_).LoadReference<Number>(CodeStubAssembler::Reference{tmp643, tmp647});
    TNode<Smi> tmp649;
    USE(tmp649);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp649 = Cast_Smi_0(state_, TNode<Object>{tmp648}, &label0);
    ca_.Goto(&block40, tmp629, tmp630, tmp631, tmp632, tmp633, tmp634, tmp635, tmp636, tmp637, tmp638, tmp639, tmp640, tmp641, tmp642, tmp643, tmp644, tmp645, tmp646, tmp648, tmp649);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block41, tmp629, tmp630, tmp631, tmp632, tmp633, tmp634, tmp635, tmp636, tmp637, tmp638, tmp639, tmp640, tmp641, tmp642, tmp643, tmp644, tmp645, tmp646, tmp648);
    }
  }

  if (block41.is_used()) {
    TNode<Context> tmp650;
    TNode<RawPtrT> tmp651;
    TNode<RawPtrT> tmp652;
    TNode<IntPtrT> tmp653;
    TNode<JSReceiver> tmp654;
    TNode<Number> tmp655;
    TNode<Number> tmp656;
    TNode<Smi> tmp657;
    TNode<Number> tmp658;
    TNode<Smi> tmp659;
    TNode<Smi> tmp660;
    TNode<Smi> tmp661;
    TNode<Smi> tmp662;
    TNode<Smi> tmp663;
    TNode<JSArray> tmp664;
    TNode<Map> tmp665;
    TNode<Int32T> tmp666;
    TNode<Int32T> tmp667;
    TNode<Number> tmp668;
    ca_.Bind(&block41, &tmp650, &tmp651, &tmp652, &tmp653, &tmp654, &tmp655, &tmp656, &tmp657, &tmp658, &tmp659, &tmp660, &tmp661, &tmp662, &tmp663, &tmp664, &tmp665, &tmp666, &tmp667, &tmp668);
    ca_.Goto(&block1);
  }

  if (block40.is_used()) {
    TNode<Context> tmp669;
    TNode<RawPtrT> tmp670;
    TNode<RawPtrT> tmp671;
    TNode<IntPtrT> tmp672;
    TNode<JSReceiver> tmp673;
    TNode<Number> tmp674;
    TNode<Number> tmp675;
    TNode<Smi> tmp676;
    TNode<Number> tmp677;
    TNode<Smi> tmp678;
    TNode<Smi> tmp679;
    TNode<Smi> tmp680;
    TNode<Smi> tmp681;
    TNode<Smi> tmp682;
    TNode<JSArray> tmp683;
    TNode<Map> tmp684;
    TNode<Int32T> tmp685;
    TNode<Int32T> tmp686;
    TNode<Number> tmp687;
    TNode<Smi> tmp688;
    ca_.Bind(&block40, &tmp669, &tmp670, &tmp671, &tmp672, &tmp673, &tmp674, &tmp675, &tmp676, &tmp677, &tmp678, &tmp679, &tmp680, &tmp681, &tmp682, &tmp683, &tmp684, &tmp685, &tmp686, &tmp687, &tmp688);
    TNode<BoolT> tmp689;
    USE(tmp689);
    tmp689 = CodeStubAssembler(state_).SmiNotEqual(TNode<Smi>{tmp678}, TNode<Smi>{tmp688});
    ca_.Branch(tmp689, &block42, &block43, tmp669, tmp670, tmp671, tmp672, tmp673, tmp674, tmp675, tmp676, tmp677, tmp678, tmp679, tmp680, tmp681, tmp682, tmp683, tmp684, tmp685, tmp686, tmp688);
  }

  if (block42.is_used()) {
    TNode<Context> tmp690;
    TNode<RawPtrT> tmp691;
    TNode<RawPtrT> tmp692;
    TNode<IntPtrT> tmp693;
    TNode<JSReceiver> tmp694;
    TNode<Number> tmp695;
    TNode<Number> tmp696;
    TNode<Smi> tmp697;
    TNode<Number> tmp698;
    TNode<Smi> tmp699;
    TNode<Smi> tmp700;
    TNode<Smi> tmp701;
    TNode<Smi> tmp702;
    TNode<Smi> tmp703;
    TNode<JSArray> tmp704;
    TNode<Map> tmp705;
    TNode<Int32T> tmp706;
    TNode<Int32T> tmp707;
    TNode<Smi> tmp708;
    ca_.Bind(&block42, &tmp690, &tmp691, &tmp692, &tmp693, &tmp694, &tmp695, &tmp696, &tmp697, &tmp698, &tmp699, &tmp700, &tmp701, &tmp702, &tmp703, &tmp704, &tmp705, &tmp706, &tmp707, &tmp708);
    ca_.Goto(&block1);
  }

  if (block43.is_used()) {
    TNode<Context> tmp709;
    TNode<RawPtrT> tmp710;
    TNode<RawPtrT> tmp711;
    TNode<IntPtrT> tmp712;
    TNode<JSReceiver> tmp713;
    TNode<Number> tmp714;
    TNode<Number> tmp715;
    TNode<Smi> tmp716;
    TNode<Number> tmp717;
    TNode<Smi> tmp718;
    TNode<Smi> tmp719;
    TNode<Smi> tmp720;
    TNode<Smi> tmp721;
    TNode<Smi> tmp722;
    TNode<JSArray> tmp723;
    TNode<Map> tmp724;
    TNode<Int32T> tmp725;
    TNode<Int32T> tmp726;
    TNode<Smi> tmp727;
    ca_.Bind(&block43, &tmp709, &tmp710, &tmp711, &tmp712, &tmp713, &tmp714, &tmp715, &tmp716, &tmp717, &tmp718, &tmp719, &tmp720, &tmp721, &tmp722, &tmp723, &tmp724, &tmp725, &tmp726, &tmp727);
    TNode<JSArray> tmp728;
    tmp728 = TORQUE_CAST(CodeStubAssembler(state_).CallBuiltin(Builtins::kExtractFastJSArray, tmp709, tmp723, tmp719, tmp720));
    USE(tmp728);
    TNode<Smi> tmp729;
    USE(tmp729);
    tmp729 = FromConstexpr_Smi_constexpr_int31_0(state_, 0);
    TNode<BoolT> tmp730;
    USE(tmp730);
    tmp730 = CodeStubAssembler(state_).SmiEqual(TNode<Smi>{tmp722}, TNode<Smi>{tmp729});
    ca_.Branch(tmp730, &block44, &block45, tmp709, tmp710, tmp711, tmp712, tmp713, tmp714, tmp715, tmp716, tmp717, tmp718, tmp719, tmp720, tmp721, tmp722, tmp723, tmp724, tmp725, tmp726, tmp727, tmp728);
  }

  if (block44.is_used()) {
    TNode<Context> tmp731;
    TNode<RawPtrT> tmp732;
    TNode<RawPtrT> tmp733;
    TNode<IntPtrT> tmp734;
    TNode<JSReceiver> tmp735;
    TNode<Number> tmp736;
    TNode<Number> tmp737;
    TNode<Smi> tmp738;
    TNode<Number> tmp739;
    TNode<Smi> tmp740;
    TNode<Smi> tmp741;
    TNode<Smi> tmp742;
    TNode<Smi> tmp743;
    TNode<Smi> tmp744;
    TNode<JSArray> tmp745;
    TNode<Map> tmp746;
    TNode<Int32T> tmp747;
    TNode<Int32T> tmp748;
    TNode<Smi> tmp749;
    TNode<JSArray> tmp750;
    ca_.Bind(&block44, &tmp731, &tmp732, &tmp733, &tmp734, &tmp735, &tmp736, &tmp737, &tmp738, &tmp739, &tmp740, &tmp741, &tmp742, &tmp743, &tmp744, &tmp745, &tmp746, &tmp747, &tmp748, &tmp749, &tmp750);
    TNode<IntPtrT> tmp751;
    USE(tmp751);
    tmp751 = FromConstexpr_intptr_constexpr_int31_0(state_, 16);
    TNode<FixedArray> tmp752;
    USE(tmp752);
    tmp752 = kEmptyFixedArray_0(state_);
    CodeStubAssembler(state_).StoreReference<FixedArrayBase>(CodeStubAssembler::Reference{tmp745, tmp751}, tmp752);
    TNode<IntPtrT> tmp753;
    USE(tmp753);
    tmp753 = FromConstexpr_intptr_constexpr_int31_0(state_, 24);
    TNode<Number> tmp754;
    USE(tmp754);
    tmp754 = FromConstexpr_Number_constexpr_int31_0(state_, 0);
    CodeStubAssembler(state_).StoreReference<Number>(CodeStubAssembler::Reference{tmp745, tmp753}, tmp754);
    ca_.Goto(&block2, tmp731, tmp732, tmp733, tmp734, tmp735, tmp736, tmp737, tmp738, tmp739, tmp750);
  }

  if (block45.is_used()) {
    TNode<Context> tmp755;
    TNode<RawPtrT> tmp756;
    TNode<RawPtrT> tmp757;
    TNode<IntPtrT> tmp758;
    TNode<JSReceiver> tmp759;
    TNode<Number> tmp760;
    TNode<Number> tmp761;
    TNode<Smi> tmp762;
    TNode<Number> tmp763;
    TNode<Smi> tmp764;
    TNode<Smi> tmp765;
    TNode<Smi> tmp766;
    TNode<Smi> tmp767;
    TNode<Smi> tmp768;
    TNode<JSArray> tmp769;
    TNode<Map> tmp770;
    TNode<Int32T> tmp771;
    TNode<Int32T> tmp772;
    TNode<Smi> tmp773;
    TNode<JSArray> tmp774;
    ca_.Bind(&block45, &tmp755, &tmp756, &tmp757, &tmp758, &tmp759, &tmp760, &tmp761, &tmp762, &tmp763, &tmp764, &tmp765, &tmp766, &tmp767, &tmp768, &tmp769, &tmp770, &tmp771, &tmp772, &tmp773, &tmp774);
    TNode<BoolT> tmp775;
    USE(tmp775);
    tmp775 = CodeStubAssembler(state_).IsFastSmiOrTaggedElementsKind(TNode<Int32T>{tmp771});
    ca_.Branch(tmp775, &block46, &block47, tmp755, tmp756, tmp757, tmp758, tmp759, tmp760, tmp761, tmp762, tmp763, tmp764, tmp765, tmp766, tmp767, tmp768, tmp769, tmp770, tmp771, tmp772, tmp773, tmp774);
  }

  if (block46.is_used()) {
    TNode<Context> tmp776;
    TNode<RawPtrT> tmp777;
    TNode<RawPtrT> tmp778;
    TNode<IntPtrT> tmp779;
    TNode<JSReceiver> tmp780;
    TNode<Number> tmp781;
    TNode<Number> tmp782;
    TNode<Smi> tmp783;
    TNode<Number> tmp784;
    TNode<Smi> tmp785;
    TNode<Smi> tmp786;
    TNode<Smi> tmp787;
    TNode<Smi> tmp788;
    TNode<Smi> tmp789;
    TNode<JSArray> tmp790;
    TNode<Map> tmp791;
    TNode<Int32T> tmp792;
    TNode<Int32T> tmp793;
    TNode<Smi> tmp794;
    TNode<JSArray> tmp795;
    ca_.Bind(&block46, &tmp776, &tmp777, &tmp778, &tmp779, &tmp780, &tmp781, &tmp782, &tmp783, &tmp784, &tmp785, &tmp786, &tmp787, &tmp788, &tmp789, &tmp790, &tmp791, &tmp792, &tmp793, &tmp794, &tmp795);
    FastSplice_FixedArray_JSAny_0(state_, TNode<Context>{tmp776}, TorqueStructArguments{TNode<RawPtrT>{tmp777}, TNode<RawPtrT>{tmp778}, TNode<IntPtrT>{tmp779}}, TNode<JSArray>{tmp790}, TNode<Smi>{tmp794}, TNode<Smi>{tmp789}, TNode<Smi>{tmp786}, TNode<Smi>{tmp783}, TNode<Smi>{tmp787});
    ca_.Goto(&block48, tmp776, tmp777, tmp778, tmp779, tmp780, tmp781, tmp782, tmp783, tmp784, tmp785, tmp786, tmp787, tmp788, tmp789, tmp790, tmp791, tmp792, tmp793, tmp794, tmp795);
  }

  if (block47.is_used()) {
    TNode<Context> tmp796;
    TNode<RawPtrT> tmp797;
    TNode<RawPtrT> tmp798;
    TNode<IntPtrT> tmp799;
    TNode<JSReceiver> tmp800;
    TNode<Number> tmp801;
    TNode<Number> tmp802;
    TNode<Smi> tmp803;
    TNode<Number> tmp804;
    TNode<Smi> tmp805;
    TNode<Smi> tmp806;
    TNode<Smi> tmp807;
    TNode<Smi> tmp808;
    TNode<Smi> tmp809;
    TNode<JSArray> tmp810;
    TNode<Map> tmp811;
    TNode<Int32T> tmp812;
    TNode<Int32T> tmp813;
    TNode<Smi> tmp814;
    TNode<JSArray> tmp815;
    ca_.Bind(&block47, &tmp796, &tmp797, &tmp798, &tmp799, &tmp800, &tmp801, &tmp802, &tmp803, &tmp804, &tmp805, &tmp806, &tmp807, &tmp808, &tmp809, &tmp810, &tmp811, &tmp812, &tmp813, &tmp814, &tmp815);
    FastSplice_FixedDoubleArray_Number_0(state_, TNode<Context>{tmp796}, TorqueStructArguments{TNode<RawPtrT>{tmp797}, TNode<RawPtrT>{tmp798}, TNode<IntPtrT>{tmp799}}, TNode<JSArray>{tmp810}, TNode<Smi>{tmp814}, TNode<Smi>{tmp809}, TNode<Smi>{tmp806}, TNode<Smi>{tmp803}, TNode<Smi>{tmp807});
    ca_.Goto(&block48, tmp796, tmp797, tmp798, tmp799, tmp800, tmp801, tmp802, tmp803, tmp804, tmp805, tmp806, tmp807, tmp808, tmp809, tmp810, tmp811, tmp812, tmp813, tmp814, tmp815);
  }

  if (block48.is_used()) {
    TNode<Context> tmp816;
    TNode<RawPtrT> tmp817;
    TNode<RawPtrT> tmp818;
    TNode<IntPtrT> tmp819;
    TNode<JSReceiver> tmp820;
    TNode<Number> tmp821;
    TNode<Number> tmp822;
    TNode<Smi> tmp823;
    TNode<Number> tmp824;
    TNode<Smi> tmp825;
    TNode<Smi> tmp826;
    TNode<Smi> tmp827;
    TNode<Smi> tmp828;
    TNode<Smi> tmp829;
    TNode<JSArray> tmp830;
    TNode<Map> tmp831;
    TNode<Int32T> tmp832;
    TNode<Int32T> tmp833;
    TNode<Smi> tmp834;
    TNode<JSArray> tmp835;
    ca_.Bind(&block48, &tmp816, &tmp817, &tmp818, &tmp819, &tmp820, &tmp821, &tmp822, &tmp823, &tmp824, &tmp825, &tmp826, &tmp827, &tmp828, &tmp829, &tmp830, &tmp831, &tmp832, &tmp833, &tmp834, &tmp835);
    ca_.Goto(&block2, tmp816, tmp817, tmp818, tmp819, tmp820, tmp821, tmp822, tmp823, tmp824, tmp835);
  }

  if (block2.is_used()) {
    TNode<Context> tmp836;
    TNode<RawPtrT> tmp837;
    TNode<RawPtrT> tmp838;
    TNode<IntPtrT> tmp839;
    TNode<JSReceiver> tmp840;
    TNode<Number> tmp841;
    TNode<Number> tmp842;
    TNode<Smi> tmp843;
    TNode<Number> tmp844;
    TNode<Object> tmp845;
    ca_.Bind(&block2, &tmp836, &tmp837, &tmp838, &tmp839, &tmp840, &tmp841, &tmp842, &tmp843, &tmp844, &tmp845);
    ca_.Goto(&block49, tmp836, tmp837, tmp838, tmp839, tmp840, tmp841, tmp842, tmp843, tmp844, tmp845);
  }

  if (block1.is_used()) {
    ca_.Bind(&block1);
    ca_.Goto(label_Bailout);
  }

    TNode<Context> tmp846;
    TNode<RawPtrT> tmp847;
    TNode<RawPtrT> tmp848;
    TNode<IntPtrT> tmp849;
    TNode<JSReceiver> tmp850;
    TNode<Number> tmp851;
    TNode<Number> tmp852;
    TNode<Smi> tmp853;
    TNode<Number> tmp854;
    TNode<Object> tmp855;
    ca_.Bind(&block49, &tmp846, &tmp847, &tmp848, &tmp849, &tmp850, &tmp851, &tmp852, &tmp853, &tmp854, &tmp855);
  return TNode<Object>{tmp855};
}

TNode<Object> FillDeletedElementsArray_0(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TNode<JSReceiver> p_o, TNode<Number> p_actualStart, TNode<Number> p_actualDeleteCount, TNode<JSReceiver> p_a) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, JSReceiver> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, JSReceiver, Number> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, JSReceiver, Number> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, JSReceiver, Number, Number, Oddball> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, JSReceiver, Number, Number, Oddball> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, JSReceiver, Number> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, JSReceiver, Object> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_o, p_actualStart, p_actualDeleteCount, p_a);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<JSReceiver> tmp1;
    TNode<Number> tmp2;
    TNode<Number> tmp3;
    TNode<JSReceiver> tmp4;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4);
    TNode<Number> tmp5;
    USE(tmp5);
    tmp5 = FromConstexpr_Number_constexpr_int31_0(state_, 0);
    ca_.Goto(&block4, tmp0, tmp1, tmp2, tmp3, tmp4, tmp5);
  }

  if (block4.is_used()) {
    TNode<Context> tmp6;
    TNode<JSReceiver> tmp7;
    TNode<Number> tmp8;
    TNode<Number> tmp9;
    TNode<JSReceiver> tmp10;
    TNode<Number> tmp11;
    ca_.Bind(&block4, &tmp6, &tmp7, &tmp8, &tmp9, &tmp10, &tmp11);
    TNode<BoolT> tmp12;
    USE(tmp12);
    tmp12 = NumberIsLessThan_0(state_, TNode<Number>{tmp11}, TNode<Number>{tmp9});
    ca_.Branch(tmp12, &block2, &block3, tmp6, tmp7, tmp8, tmp9, tmp10, tmp11);
  }

  if (block2.is_used()) {
    TNode<Context> tmp13;
    TNode<JSReceiver> tmp14;
    TNode<Number> tmp15;
    TNode<Number> tmp16;
    TNode<JSReceiver> tmp17;
    TNode<Number> tmp18;
    ca_.Bind(&block2, &tmp13, &tmp14, &tmp15, &tmp16, &tmp17, &tmp18);
    TNode<Number> tmp19;
    USE(tmp19);
    tmp19 = CodeStubAssembler(state_).NumberAdd(TNode<Number>{tmp15}, TNode<Number>{tmp18});
    TNode<Oddball> tmp20;
    tmp20 = TORQUE_CAST(CodeStubAssembler(state_).CallBuiltin(Builtins::kHasProperty, tmp13, tmp14, tmp19));
    USE(tmp20);
    TNode<Oddball> tmp21;
    USE(tmp21);
    tmp21 = True_0(state_);
    TNode<BoolT> tmp22;
    USE(tmp22);
    tmp22 = CodeStubAssembler(state_).TaggedEqual(TNode<HeapObject>{tmp20}, TNode<HeapObject>{tmp21});
    ca_.Branch(tmp22, &block5, &block6, tmp13, tmp14, tmp15, tmp16, tmp17, tmp18, tmp19, tmp20);
  }

  if (block5.is_used()) {
    TNode<Context> tmp23;
    TNode<JSReceiver> tmp24;
    TNode<Number> tmp25;
    TNode<Number> tmp26;
    TNode<JSReceiver> tmp27;
    TNode<Number> tmp28;
    TNode<Number> tmp29;
    TNode<Oddball> tmp30;
    ca_.Bind(&block5, &tmp23, &tmp24, &tmp25, &tmp26, &tmp27, &tmp28, &tmp29, &tmp30);
    TNode<Object> tmp31;
    USE(tmp31);
    tmp31 = CodeStubAssembler(state_).GetProperty(TNode<Context>{tmp23}, TNode<Object>{tmp24}, TNode<Object>{tmp29});
    TNode<Object> tmp32;
    tmp32 = CodeStubAssembler(state_).CallBuiltin(Builtins::kFastCreateDataProperty, tmp23, tmp27, tmp28, tmp31);
    USE(tmp32);
    ca_.Goto(&block6, tmp23, tmp24, tmp25, tmp26, tmp27, tmp28, tmp29, tmp30);
  }

  if (block6.is_used()) {
    TNode<Context> tmp33;
    TNode<JSReceiver> tmp34;
    TNode<Number> tmp35;
    TNode<Number> tmp36;
    TNode<JSReceiver> tmp37;
    TNode<Number> tmp38;
    TNode<Number> tmp39;
    TNode<Oddball> tmp40;
    ca_.Bind(&block6, &tmp33, &tmp34, &tmp35, &tmp36, &tmp37, &tmp38, &tmp39, &tmp40);
    TNode<Number> tmp41;
    USE(tmp41);
    tmp41 = FromConstexpr_Number_constexpr_int31_0(state_, 1);
    TNode<Number> tmp42;
    USE(tmp42);
    tmp42 = CodeStubAssembler(state_).NumberAdd(TNode<Number>{tmp38}, TNode<Number>{tmp41});
    ca_.Goto(&block4, tmp33, tmp34, tmp35, tmp36, tmp37, tmp42);
  }

  if (block3.is_used()) {
    TNode<Context> tmp43;
    TNode<JSReceiver> tmp44;
    TNode<Number> tmp45;
    TNode<Number> tmp46;
    TNode<JSReceiver> tmp47;
    TNode<Number> tmp48;
    ca_.Bind(&block3, &tmp43, &tmp44, &tmp45, &tmp46, &tmp47, &tmp48);
    TNode<String> tmp49;
    USE(tmp49);
    tmp49 = kLengthString_0(state_);
    CodeStubAssembler(state_).CallBuiltin(Builtins::kSetProperty, tmp43, tmp47, tmp49, tmp46);
    ca_.Goto(&block7, tmp43, tmp44, tmp45, tmp46, tmp47, tmp47);
  }

    TNode<Context> tmp51;
    TNode<JSReceiver> tmp52;
    TNode<Number> tmp53;
    TNode<Number> tmp54;
    TNode<JSReceiver> tmp55;
    TNode<Object> tmp56;
    ca_.Bind(&block7, &tmp51, &tmp52, &tmp53, &tmp54, &tmp55, &tmp56);
  return TNode<Object>{tmp56};
}

void HandleForwardCase_0(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TNode<JSReceiver> p_o, TNode<Number> p_len, TNode<Number> p_itemCount, TNode<Number> p_actualStart, TNode<Number> p_actualDeleteCount) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, Number, Number> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, Number, Number, Number> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, Number, Number, Number> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, Number, Number, Number, Number, Number, Oddball> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, Number, Number, Number, Number, Number, Oddball> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, Number, Number, Number, Number, Number, Oddball> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, Number, Number, Number> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, Number, Number, Number> block10(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, Number, Number, Number> block8(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, Number, Number, Number> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, Number, Number> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_o, p_len, p_itemCount, p_actualStart, p_actualDeleteCount);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<JSReceiver> tmp1;
    TNode<Number> tmp2;
    TNode<Number> tmp3;
    TNode<Number> tmp4;
    TNode<Number> tmp5;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4, &tmp5);
    ca_.Goto(&block4, tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp4);
  }

  if (block4.is_used()) {
    TNode<Context> tmp6;
    TNode<JSReceiver> tmp7;
    TNode<Number> tmp8;
    TNode<Number> tmp9;
    TNode<Number> tmp10;
    TNode<Number> tmp11;
    TNode<Number> tmp12;
    ca_.Bind(&block4, &tmp6, &tmp7, &tmp8, &tmp9, &tmp10, &tmp11, &tmp12);
    TNode<Number> tmp13;
    USE(tmp13);
    tmp13 = CodeStubAssembler(state_).NumberSub(TNode<Number>{tmp8}, TNode<Number>{tmp11});
    TNode<BoolT> tmp14;
    USE(tmp14);
    tmp14 = NumberIsLessThan_0(state_, TNode<Number>{tmp12}, TNode<Number>{tmp13});
    ca_.Branch(tmp14, &block2, &block3, tmp6, tmp7, tmp8, tmp9, tmp10, tmp11, tmp12);
  }

  if (block2.is_used()) {
    TNode<Context> tmp15;
    TNode<JSReceiver> tmp16;
    TNode<Number> tmp17;
    TNode<Number> tmp18;
    TNode<Number> tmp19;
    TNode<Number> tmp20;
    TNode<Number> tmp21;
    ca_.Bind(&block2, &tmp15, &tmp16, &tmp17, &tmp18, &tmp19, &tmp20, &tmp21);
    TNode<Number> tmp22;
    USE(tmp22);
    tmp22 = CodeStubAssembler(state_).NumberAdd(TNode<Number>{tmp21}, TNode<Number>{tmp20});
    TNode<Number> tmp23;
    USE(tmp23);
    tmp23 = CodeStubAssembler(state_).NumberAdd(TNode<Number>{tmp21}, TNode<Number>{tmp18});
    TNode<Oddball> tmp24;
    tmp24 = TORQUE_CAST(CodeStubAssembler(state_).CallBuiltin(Builtins::kHasProperty, tmp15, tmp16, tmp22));
    USE(tmp24);
    TNode<Oddball> tmp25;
    USE(tmp25);
    tmp25 = True_0(state_);
    TNode<BoolT> tmp26;
    USE(tmp26);
    tmp26 = CodeStubAssembler(state_).TaggedEqual(TNode<HeapObject>{tmp24}, TNode<HeapObject>{tmp25});
    ca_.Branch(tmp26, &block5, &block6, tmp15, tmp16, tmp17, tmp18, tmp19, tmp20, tmp21, tmp22, tmp23, tmp24);
  }

  if (block5.is_used()) {
    TNode<Context> tmp27;
    TNode<JSReceiver> tmp28;
    TNode<Number> tmp29;
    TNode<Number> tmp30;
    TNode<Number> tmp31;
    TNode<Number> tmp32;
    TNode<Number> tmp33;
    TNode<Number> tmp34;
    TNode<Number> tmp35;
    TNode<Oddball> tmp36;
    ca_.Bind(&block5, &tmp27, &tmp28, &tmp29, &tmp30, &tmp31, &tmp32, &tmp33, &tmp34, &tmp35, &tmp36);
    TNode<Object> tmp37;
    USE(tmp37);
    tmp37 = CodeStubAssembler(state_).GetProperty(TNode<Context>{tmp27}, TNode<Object>{tmp28}, TNode<Object>{tmp34});
    CodeStubAssembler(state_).CallBuiltin(Builtins::kSetProperty, tmp27, tmp28, tmp35, tmp37);
    ca_.Goto(&block7, tmp27, tmp28, tmp29, tmp30, tmp31, tmp32, tmp33, tmp34, tmp35, tmp36);
  }

  if (block6.is_used()) {
    TNode<Context> tmp39;
    TNode<JSReceiver> tmp40;
    TNode<Number> tmp41;
    TNode<Number> tmp42;
    TNode<Number> tmp43;
    TNode<Number> tmp44;
    TNode<Number> tmp45;
    TNode<Number> tmp46;
    TNode<Number> tmp47;
    TNode<Oddball> tmp48;
    ca_.Bind(&block6, &tmp39, &tmp40, &tmp41, &tmp42, &tmp43, &tmp44, &tmp45, &tmp46, &tmp47, &tmp48);
    TNode<Smi> tmp49;
    USE(tmp49);
    tmp49 = FromConstexpr_LanguageModeSmi_constexpr_LanguageMode_0(state_, LanguageMode::kStrict);
    TNode<Oddball> tmp50;
    tmp50 = TORQUE_CAST(CodeStubAssembler(state_).CallBuiltin(Builtins::kDeleteProperty, tmp39, tmp40, tmp47, tmp49));
    USE(tmp50);
    ca_.Goto(&block7, tmp39, tmp40, tmp41, tmp42, tmp43, tmp44, tmp45, tmp46, tmp47, tmp48);
  }

  if (block7.is_used()) {
    TNode<Context> tmp51;
    TNode<JSReceiver> tmp52;
    TNode<Number> tmp53;
    TNode<Number> tmp54;
    TNode<Number> tmp55;
    TNode<Number> tmp56;
    TNode<Number> tmp57;
    TNode<Number> tmp58;
    TNode<Number> tmp59;
    TNode<Oddball> tmp60;
    ca_.Bind(&block7, &tmp51, &tmp52, &tmp53, &tmp54, &tmp55, &tmp56, &tmp57, &tmp58, &tmp59, &tmp60);
    TNode<Number> tmp61;
    USE(tmp61);
    tmp61 = FromConstexpr_Number_constexpr_int31_0(state_, 1);
    TNode<Number> tmp62;
    USE(tmp62);
    tmp62 = CodeStubAssembler(state_).NumberAdd(TNode<Number>{tmp57}, TNode<Number>{tmp61});
    ca_.Goto(&block4, tmp51, tmp52, tmp53, tmp54, tmp55, tmp56, tmp62);
  }

  if (block3.is_used()) {
    TNode<Context> tmp63;
    TNode<JSReceiver> tmp64;
    TNode<Number> tmp65;
    TNode<Number> tmp66;
    TNode<Number> tmp67;
    TNode<Number> tmp68;
    TNode<Number> tmp69;
    ca_.Bind(&block3, &tmp63, &tmp64, &tmp65, &tmp66, &tmp67, &tmp68, &tmp69);
    ca_.Goto(&block10, tmp63, tmp64, tmp65, tmp66, tmp67, tmp68, tmp65);
  }

  if (block10.is_used()) {
    TNode<Context> tmp70;
    TNode<JSReceiver> tmp71;
    TNode<Number> tmp72;
    TNode<Number> tmp73;
    TNode<Number> tmp74;
    TNode<Number> tmp75;
    TNode<Number> tmp76;
    ca_.Bind(&block10, &tmp70, &tmp71, &tmp72, &tmp73, &tmp74, &tmp75, &tmp76);
    TNode<Number> tmp77;
    USE(tmp77);
    tmp77 = CodeStubAssembler(state_).NumberSub(TNode<Number>{tmp72}, TNode<Number>{tmp75});
    TNode<Number> tmp78;
    USE(tmp78);
    tmp78 = CodeStubAssembler(state_).NumberAdd(TNode<Number>{tmp77}, TNode<Number>{tmp73});
    TNode<BoolT> tmp79;
    USE(tmp79);
    tmp79 = NumberIsGreaterThan_0(state_, TNode<Number>{tmp76}, TNode<Number>{tmp78});
    ca_.Branch(tmp79, &block8, &block9, tmp70, tmp71, tmp72, tmp73, tmp74, tmp75, tmp76);
  }

  if (block8.is_used()) {
    TNode<Context> tmp80;
    TNode<JSReceiver> tmp81;
    TNode<Number> tmp82;
    TNode<Number> tmp83;
    TNode<Number> tmp84;
    TNode<Number> tmp85;
    TNode<Number> tmp86;
    ca_.Bind(&block8, &tmp80, &tmp81, &tmp82, &tmp83, &tmp84, &tmp85, &tmp86);
    TNode<Number> tmp87;
    USE(tmp87);
    tmp87 = FromConstexpr_Number_constexpr_int31_0(state_, 1);
    TNode<Number> tmp88;
    USE(tmp88);
    tmp88 = CodeStubAssembler(state_).NumberSub(TNode<Number>{tmp86}, TNode<Number>{tmp87});
    TNode<Smi> tmp89;
    USE(tmp89);
    tmp89 = FromConstexpr_LanguageModeSmi_constexpr_LanguageMode_0(state_, LanguageMode::kStrict);
    TNode<Oddball> tmp90;
    tmp90 = TORQUE_CAST(CodeStubAssembler(state_).CallBuiltin(Builtins::kDeleteProperty, tmp80, tmp81, tmp88, tmp89));
    USE(tmp90);
    TNode<Number> tmp91;
    USE(tmp91);
    tmp91 = FromConstexpr_Number_constexpr_int31_0(state_, 1);
    TNode<Number> tmp92;
    USE(tmp92);
    tmp92 = CodeStubAssembler(state_).NumberSub(TNode<Number>{tmp86}, TNode<Number>{tmp91});
    ca_.Goto(&block10, tmp80, tmp81, tmp82, tmp83, tmp84, tmp85, tmp92);
  }

  if (block9.is_used()) {
    TNode<Context> tmp93;
    TNode<JSReceiver> tmp94;
    TNode<Number> tmp95;
    TNode<Number> tmp96;
    TNode<Number> tmp97;
    TNode<Number> tmp98;
    TNode<Number> tmp99;
    ca_.Bind(&block9, &tmp93, &tmp94, &tmp95, &tmp96, &tmp97, &tmp98, &tmp99);
    ca_.Goto(&block11, tmp93, tmp94, tmp95, tmp96, tmp97, tmp98);
  }

    TNode<Context> tmp100;
    TNode<JSReceiver> tmp101;
    TNode<Number> tmp102;
    TNode<Number> tmp103;
    TNode<Number> tmp104;
    TNode<Number> tmp105;
    ca_.Bind(&block11, &tmp100, &tmp101, &tmp102, &tmp103, &tmp104, &tmp105);
}

void HandleBackwardCase_0(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TNode<JSReceiver> p_o, TNode<Number> p_len, TNode<Number> p_itemCount, TNode<Number> p_actualStart, TNode<Number> p_actualDeleteCount) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, Number, Number> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, Number, Number, Number> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, Number, Number, Number> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, Number, Number, Number, Number, Number, Oddball> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, Number, Number, Number, Number, Number, Oddball> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, Number, Number, Number, Number, Number, Oddball> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, Number, Number, Number> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSReceiver, Number, Number, Number, Number> block8(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_o, p_len, p_itemCount, p_actualStart, p_actualDeleteCount);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<JSReceiver> tmp1;
    TNode<Number> tmp2;
    TNode<Number> tmp3;
    TNode<Number> tmp4;
    TNode<Number> tmp5;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4, &tmp5);
    TNode<Number> tmp6;
    USE(tmp6);
    tmp6 = CodeStubAssembler(state_).NumberSub(TNode<Number>{tmp2}, TNode<Number>{tmp5});
    ca_.Goto(&block4, tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp6);
  }

  if (block4.is_used()) {
    TNode<Context> tmp7;
    TNode<JSReceiver> tmp8;
    TNode<Number> tmp9;
    TNode<Number> tmp10;
    TNode<Number> tmp11;
    TNode<Number> tmp12;
    TNode<Number> tmp13;
    ca_.Bind(&block4, &tmp7, &tmp8, &tmp9, &tmp10, &tmp11, &tmp12, &tmp13);
    TNode<BoolT> tmp14;
    USE(tmp14);
    tmp14 = NumberIsGreaterThan_0(state_, TNode<Number>{tmp13}, TNode<Number>{tmp11});
    ca_.Branch(tmp14, &block2, &block3, tmp7, tmp8, tmp9, tmp10, tmp11, tmp12, tmp13);
  }

  if (block2.is_used()) {
    TNode<Context> tmp15;
    TNode<JSReceiver> tmp16;
    TNode<Number> tmp17;
    TNode<Number> tmp18;
    TNode<Number> tmp19;
    TNode<Number> tmp20;
    TNode<Number> tmp21;
    ca_.Bind(&block2, &tmp15, &tmp16, &tmp17, &tmp18, &tmp19, &tmp20, &tmp21);
    TNode<Number> tmp22;
    USE(tmp22);
    tmp22 = CodeStubAssembler(state_).NumberAdd(TNode<Number>{tmp21}, TNode<Number>{tmp20});
    TNode<Number> tmp23;
    USE(tmp23);
    tmp23 = FromConstexpr_Number_constexpr_int31_0(state_, 1);
    TNode<Number> tmp24;
    USE(tmp24);
    tmp24 = CodeStubAssembler(state_).NumberSub(TNode<Number>{tmp22}, TNode<Number>{tmp23});
    TNode<Number> tmp25;
    USE(tmp25);
    tmp25 = CodeStubAssembler(state_).NumberAdd(TNode<Number>{tmp21}, TNode<Number>{tmp18});
    TNode<Number> tmp26;
    USE(tmp26);
    tmp26 = FromConstexpr_Number_constexpr_int31_0(state_, 1);
    TNode<Number> tmp27;
    USE(tmp27);
    tmp27 = CodeStubAssembler(state_).NumberSub(TNode<Number>{tmp25}, TNode<Number>{tmp26});
    TNode<Oddball> tmp28;
    tmp28 = TORQUE_CAST(CodeStubAssembler(state_).CallBuiltin(Builtins::kHasProperty, tmp15, tmp16, tmp24));
    USE(tmp28);
    TNode<Oddball> tmp29;
    USE(tmp29);
    tmp29 = True_0(state_);
    TNode<BoolT> tmp30;
    USE(tmp30);
    tmp30 = CodeStubAssembler(state_).TaggedEqual(TNode<HeapObject>{tmp28}, TNode<HeapObject>{tmp29});
    ca_.Branch(tmp30, &block5, &block6, tmp15, tmp16, tmp17, tmp18, tmp19, tmp20, tmp21, tmp24, tmp27, tmp28);
  }

  if (block5.is_used()) {
    TNode<Context> tmp31;
    TNode<JSReceiver> tmp32;
    TNode<Number> tmp33;
    TNode<Number> tmp34;
    TNode<Number> tmp35;
    TNode<Number> tmp36;
    TNode<Number> tmp37;
    TNode<Number> tmp38;
    TNode<Number> tmp39;
    TNode<Oddball> tmp40;
    ca_.Bind(&block5, &tmp31, &tmp32, &tmp33, &tmp34, &tmp35, &tmp36, &tmp37, &tmp38, &tmp39, &tmp40);
    TNode<Object> tmp41;
    USE(tmp41);
    tmp41 = CodeStubAssembler(state_).GetProperty(TNode<Context>{tmp31}, TNode<Object>{tmp32}, TNode<Object>{tmp38});
    CodeStubAssembler(state_).CallBuiltin(Builtins::kSetProperty, tmp31, tmp32, tmp39, tmp41);
    ca_.Goto(&block7, tmp31, tmp32, tmp33, tmp34, tmp35, tmp36, tmp37, tmp38, tmp39, tmp40);
  }

  if (block6.is_used()) {
    TNode<Context> tmp43;
    TNode<JSReceiver> tmp44;
    TNode<Number> tmp45;
    TNode<Number> tmp46;
    TNode<Number> tmp47;
    TNode<Number> tmp48;
    TNode<Number> tmp49;
    TNode<Number> tmp50;
    TNode<Number> tmp51;
    TNode<Oddball> tmp52;
    ca_.Bind(&block6, &tmp43, &tmp44, &tmp45, &tmp46, &tmp47, &tmp48, &tmp49, &tmp50, &tmp51, &tmp52);
    TNode<Smi> tmp53;
    USE(tmp53);
    tmp53 = FromConstexpr_LanguageModeSmi_constexpr_LanguageMode_0(state_, LanguageMode::kStrict);
    TNode<Oddball> tmp54;
    tmp54 = TORQUE_CAST(CodeStubAssembler(state_).CallBuiltin(Builtins::kDeleteProperty, tmp43, tmp44, tmp51, tmp53));
    USE(tmp54);
    ca_.Goto(&block7, tmp43, tmp44, tmp45, tmp46, tmp47, tmp48, tmp49, tmp50, tmp51, tmp52);
  }

  if (block7.is_used()) {
    TNode<Context> tmp55;
    TNode<JSReceiver> tmp56;
    TNode<Number> tmp57;
    TNode<Number> tmp58;
    TNode<Number> tmp59;
    TNode<Number> tmp60;
    TNode<Number> tmp61;
    TNode<Number> tmp62;
    TNode<Number> tmp63;
    TNode<Oddball> tmp64;
    ca_.Bind(&block7, &tmp55, &tmp56, &tmp57, &tmp58, &tmp59, &tmp60, &tmp61, &tmp62, &tmp63, &tmp64);
    TNode<Number> tmp65;
    USE(tmp65);
    tmp65 = FromConstexpr_Number_constexpr_int31_0(state_, 1);
    TNode<Number> tmp66;
    USE(tmp66);
    tmp66 = CodeStubAssembler(state_).NumberSub(TNode<Number>{tmp61}, TNode<Number>{tmp65});
    ca_.Goto(&block4, tmp55, tmp56, tmp57, tmp58, tmp59, tmp60, tmp66);
  }

  if (block3.is_used()) {
    TNode<Context> tmp67;
    TNode<JSReceiver> tmp68;
    TNode<Number> tmp69;
    TNode<Number> tmp70;
    TNode<Number> tmp71;
    TNode<Number> tmp72;
    TNode<Number> tmp73;
    ca_.Bind(&block3, &tmp67, &tmp68, &tmp69, &tmp70, &tmp71, &tmp72, &tmp73);
    ca_.Goto(&block8, tmp67, tmp68, tmp69, tmp70, tmp71, tmp72);
  }

    TNode<Context> tmp74;
    TNode<JSReceiver> tmp75;
    TNode<Number> tmp76;
    TNode<Number> tmp77;
    TNode<Number> tmp78;
    TNode<Number> tmp79;
    ca_.Bind(&block8, &tmp74, &tmp75, &tmp76, &tmp77, &tmp78, &tmp79);
}

TNode<Object> SlowSplice_0(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TorqueStructArguments p_arguments, TNode<JSReceiver> p_o, TNode<Number> p_len, TNode<Number> p_actualStart, TNode<Smi> p_insertCount, TNode<Number> p_actualDeleteCount) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, JSReceiver, Number> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, JSReceiver, Number> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, JSReceiver, Number> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, JSReceiver, Number> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, JSReceiver, Number> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, JSReceiver, Number, Number> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, JSReceiver, Number, Number, IntPtrT> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, JSReceiver, Number, Number, IntPtrT> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, JSReceiver, Number, Number, IntPtrT> block10(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, JSReceiver, Number, Number> block8(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Object> block13(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_arguments.frame, p_arguments.base, p_arguments.length, p_o, p_len, p_actualStart, p_insertCount, p_actualDeleteCount);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<RawPtrT> tmp1;
    TNode<RawPtrT> tmp2;
    TNode<IntPtrT> tmp3;
    TNode<JSReceiver> tmp4;
    TNode<Number> tmp5;
    TNode<Number> tmp6;
    TNode<Smi> tmp7;
    TNode<Number> tmp8;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4, &tmp5, &tmp6, &tmp7, &tmp8);
    TNode<JSReceiver> tmp9;
    USE(tmp9);
    tmp9 = CodeStubAssembler(state_).ArraySpeciesCreate(TNode<Context>{tmp0}, TNode<Object>{tmp4}, TNode<Number>{tmp8});
    TNode<Object> tmp10;
    USE(tmp10);
    tmp10 = FillDeletedElementsArray_0(state_, TNode<Context>{tmp0}, TNode<JSReceiver>{tmp4}, TNode<Number>{tmp6}, TNode<Number>{tmp8}, TNode<JSReceiver>{tmp9});
    TNode<BoolT> tmp11;
    USE(tmp11);
    tmp11 = NumberIsLessThan_0(state_, TNode<Number>{tmp7}, TNode<Number>{tmp8});
    ca_.Branch(tmp11, &block2, &block3, tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp6, tmp7, tmp8, tmp9, tmp7);
  }

  if (block2.is_used()) {
    TNode<Context> tmp12;
    TNode<RawPtrT> tmp13;
    TNode<RawPtrT> tmp14;
    TNode<IntPtrT> tmp15;
    TNode<JSReceiver> tmp16;
    TNode<Number> tmp17;
    TNode<Number> tmp18;
    TNode<Smi> tmp19;
    TNode<Number> tmp20;
    TNode<JSReceiver> tmp21;
    TNode<Number> tmp22;
    ca_.Bind(&block2, &tmp12, &tmp13, &tmp14, &tmp15, &tmp16, &tmp17, &tmp18, &tmp19, &tmp20, &tmp21, &tmp22);
    HandleForwardCase_0(state_, TNode<Context>{tmp12}, TNode<JSReceiver>{tmp16}, TNode<Number>{tmp17}, TNode<Number>{tmp22}, TNode<Number>{tmp18}, TNode<Number>{tmp20});
    ca_.Goto(&block4, tmp12, tmp13, tmp14, tmp15, tmp16, tmp17, tmp18, tmp19, tmp20, tmp21, tmp22);
  }

  if (block3.is_used()) {
    TNode<Context> tmp23;
    TNode<RawPtrT> tmp24;
    TNode<RawPtrT> tmp25;
    TNode<IntPtrT> tmp26;
    TNode<JSReceiver> tmp27;
    TNode<Number> tmp28;
    TNode<Number> tmp29;
    TNode<Smi> tmp30;
    TNode<Number> tmp31;
    TNode<JSReceiver> tmp32;
    TNode<Number> tmp33;
    ca_.Bind(&block3, &tmp23, &tmp24, &tmp25, &tmp26, &tmp27, &tmp28, &tmp29, &tmp30, &tmp31, &tmp32, &tmp33);
    TNode<BoolT> tmp34;
    USE(tmp34);
    tmp34 = NumberIsGreaterThan_0(state_, TNode<Number>{tmp33}, TNode<Number>{tmp31});
    ca_.Branch(tmp34, &block5, &block6, tmp23, tmp24, tmp25, tmp26, tmp27, tmp28, tmp29, tmp30, tmp31, tmp32, tmp33);
  }

  if (block5.is_used()) {
    TNode<Context> tmp35;
    TNode<RawPtrT> tmp36;
    TNode<RawPtrT> tmp37;
    TNode<IntPtrT> tmp38;
    TNode<JSReceiver> tmp39;
    TNode<Number> tmp40;
    TNode<Number> tmp41;
    TNode<Smi> tmp42;
    TNode<Number> tmp43;
    TNode<JSReceiver> tmp44;
    TNode<Number> tmp45;
    ca_.Bind(&block5, &tmp35, &tmp36, &tmp37, &tmp38, &tmp39, &tmp40, &tmp41, &tmp42, &tmp43, &tmp44, &tmp45);
    HandleBackwardCase_0(state_, TNode<Context>{tmp35}, TNode<JSReceiver>{tmp39}, TNode<Number>{tmp40}, TNode<Number>{tmp45}, TNode<Number>{tmp41}, TNode<Number>{tmp43});
    ca_.Goto(&block6, tmp35, tmp36, tmp37, tmp38, tmp39, tmp40, tmp41, tmp42, tmp43, tmp44, tmp45);
  }

  if (block6.is_used()) {
    TNode<Context> tmp46;
    TNode<RawPtrT> tmp47;
    TNode<RawPtrT> tmp48;
    TNode<IntPtrT> tmp49;
    TNode<JSReceiver> tmp50;
    TNode<Number> tmp51;
    TNode<Number> tmp52;
    TNode<Smi> tmp53;
    TNode<Number> tmp54;
    TNode<JSReceiver> tmp55;
    TNode<Number> tmp56;
    ca_.Bind(&block6, &tmp46, &tmp47, &tmp48, &tmp49, &tmp50, &tmp51, &tmp52, &tmp53, &tmp54, &tmp55, &tmp56);
    ca_.Goto(&block4, tmp46, tmp47, tmp48, tmp49, tmp50, tmp51, tmp52, tmp53, tmp54, tmp55, tmp56);
  }

  if (block4.is_used()) {
    TNode<Context> tmp57;
    TNode<RawPtrT> tmp58;
    TNode<RawPtrT> tmp59;
    TNode<IntPtrT> tmp60;
    TNode<JSReceiver> tmp61;
    TNode<Number> tmp62;
    TNode<Number> tmp63;
    TNode<Smi> tmp64;
    TNode<Number> tmp65;
    TNode<JSReceiver> tmp66;
    TNode<Number> tmp67;
    ca_.Bind(&block4, &tmp57, &tmp58, &tmp59, &tmp60, &tmp61, &tmp62, &tmp63, &tmp64, &tmp65, &tmp66, &tmp67);
    TNode<IntPtrT> tmp68;
    USE(tmp68);
    tmp68 = FromConstexpr_intptr_constexpr_int31_0(state_, 2);
    TNode<BoolT> tmp69;
    USE(tmp69);
    tmp69 = CodeStubAssembler(state_).IntPtrGreaterThan(TNode<IntPtrT>{tmp60}, TNode<IntPtrT>{tmp68});
    ca_.Branch(tmp69, &block7, &block8, tmp57, tmp58, tmp59, tmp60, tmp61, tmp62, tmp63, tmp64, tmp65, tmp66, tmp67, tmp63);
  }

  if (block7.is_used()) {
    TNode<Context> tmp70;
    TNode<RawPtrT> tmp71;
    TNode<RawPtrT> tmp72;
    TNode<IntPtrT> tmp73;
    TNode<JSReceiver> tmp74;
    TNode<Number> tmp75;
    TNode<Number> tmp76;
    TNode<Smi> tmp77;
    TNode<Number> tmp78;
    TNode<JSReceiver> tmp79;
    TNode<Number> tmp80;
    TNode<Number> tmp81;
    ca_.Bind(&block7, &tmp70, &tmp71, &tmp72, &tmp73, &tmp74, &tmp75, &tmp76, &tmp77, &tmp78, &tmp79, &tmp80, &tmp81);
    TNode<IntPtrT> tmp82;
    USE(tmp82);
    tmp82 = FromConstexpr_intptr_constexpr_int31_0(state_, 2);
    ca_.Goto(&block11, tmp70, tmp71, tmp72, tmp73, tmp74, tmp75, tmp76, tmp77, tmp78, tmp79, tmp80, tmp81, tmp82);
  }

  if (block11.is_used()) {
    TNode<Context> tmp83;
    TNode<RawPtrT> tmp84;
    TNode<RawPtrT> tmp85;
    TNode<IntPtrT> tmp86;
    TNode<JSReceiver> tmp87;
    TNode<Number> tmp88;
    TNode<Number> tmp89;
    TNode<Smi> tmp90;
    TNode<Number> tmp91;
    TNode<JSReceiver> tmp92;
    TNode<Number> tmp93;
    TNode<Number> tmp94;
    TNode<IntPtrT> tmp95;
    ca_.Bind(&block11, &tmp83, &tmp84, &tmp85, &tmp86, &tmp87, &tmp88, &tmp89, &tmp90, &tmp91, &tmp92, &tmp93, &tmp94, &tmp95);
    TNode<BoolT> tmp96;
    USE(tmp96);
    tmp96 = CodeStubAssembler(state_).IntPtrLessThan(TNode<IntPtrT>{tmp95}, TNode<IntPtrT>{tmp86});
    ca_.Branch(tmp96, &block9, &block10, tmp83, tmp84, tmp85, tmp86, tmp87, tmp88, tmp89, tmp90, tmp91, tmp92, tmp93, tmp94, tmp95);
  }

  if (block9.is_used()) {
    TNode<Context> tmp97;
    TNode<RawPtrT> tmp98;
    TNode<RawPtrT> tmp99;
    TNode<IntPtrT> tmp100;
    TNode<JSReceiver> tmp101;
    TNode<Number> tmp102;
    TNode<Number> tmp103;
    TNode<Smi> tmp104;
    TNode<Number> tmp105;
    TNode<JSReceiver> tmp106;
    TNode<Number> tmp107;
    TNode<Number> tmp108;
    TNode<IntPtrT> tmp109;
    ca_.Bind(&block9, &tmp97, &tmp98, &tmp99, &tmp100, &tmp101, &tmp102, &tmp103, &tmp104, &tmp105, &tmp106, &tmp107, &tmp108, &tmp109);
    TNode<Object> tmp110;
    USE(tmp110);
    tmp110 = CodeStubAssembler(state_).GetArgumentValue(TorqueStructArguments{TNode<RawPtrT>{tmp98}, TNode<RawPtrT>{tmp99}, TNode<IntPtrT>{tmp100}}, TNode<IntPtrT>{tmp109});
    CodeStubAssembler(state_).CallBuiltin(Builtins::kSetProperty, tmp97, tmp101, tmp108, tmp110);
    TNode<Number> tmp112;
    USE(tmp112);
    tmp112 = FromConstexpr_Number_constexpr_int31_0(state_, 1);
    TNode<Number> tmp113;
    USE(tmp113);
    tmp113 = CodeStubAssembler(state_).NumberAdd(TNode<Number>{tmp108}, TNode<Number>{tmp112});
    TNode<IntPtrT> tmp114;
    USE(tmp114);
    tmp114 = FromConstexpr_intptr_constexpr_int31_0(state_, 1);
    TNode<IntPtrT> tmp115;
    USE(tmp115);
    tmp115 = CodeStubAssembler(state_).IntPtrAdd(TNode<IntPtrT>{tmp109}, TNode<IntPtrT>{tmp114});
    ca_.Goto(&block11, tmp97, tmp98, tmp99, tmp100, tmp101, tmp102, tmp103, tmp104, tmp105, tmp106, tmp107, tmp113, tmp115);
  }

  if (block10.is_used()) {
    TNode<Context> tmp116;
    TNode<RawPtrT> tmp117;
    TNode<RawPtrT> tmp118;
    TNode<IntPtrT> tmp119;
    TNode<JSReceiver> tmp120;
    TNode<Number> tmp121;
    TNode<Number> tmp122;
    TNode<Smi> tmp123;
    TNode<Number> tmp124;
    TNode<JSReceiver> tmp125;
    TNode<Number> tmp126;
    TNode<Number> tmp127;
    TNode<IntPtrT> tmp128;
    ca_.Bind(&block10, &tmp116, &tmp117, &tmp118, &tmp119, &tmp120, &tmp121, &tmp122, &tmp123, &tmp124, &tmp125, &tmp126, &tmp127, &tmp128);
    ca_.Goto(&block8, tmp116, tmp117, tmp118, tmp119, tmp120, tmp121, tmp122, tmp123, tmp124, tmp125, tmp126, tmp127);
  }

  if (block8.is_used()) {
    TNode<Context> tmp129;
    TNode<RawPtrT> tmp130;
    TNode<RawPtrT> tmp131;
    TNode<IntPtrT> tmp132;
    TNode<JSReceiver> tmp133;
    TNode<Number> tmp134;
    TNode<Number> tmp135;
    TNode<Smi> tmp136;
    TNode<Number> tmp137;
    TNode<JSReceiver> tmp138;
    TNode<Number> tmp139;
    TNode<Number> tmp140;
    ca_.Bind(&block8, &tmp129, &tmp130, &tmp131, &tmp132, &tmp133, &tmp134, &tmp135, &tmp136, &tmp137, &tmp138, &tmp139, &tmp140);
    TNode<String> tmp141;
    USE(tmp141);
    tmp141 = kLengthString_0(state_);
    TNode<Number> tmp142;
    USE(tmp142);
    tmp142 = CodeStubAssembler(state_).NumberSub(TNode<Number>{tmp134}, TNode<Number>{tmp137});
    TNode<Number> tmp143;
    USE(tmp143);
    tmp143 = CodeStubAssembler(state_).NumberAdd(TNode<Number>{tmp142}, TNode<Number>{tmp139});
    CodeStubAssembler(state_).CallBuiltin(Builtins::kSetProperty, tmp129, tmp133, tmp141, tmp143);
    ca_.Goto(&block13, tmp129, tmp130, tmp131, tmp132, tmp133, tmp134, tmp135, tmp136, tmp137, tmp138);
  }

    TNode<Context> tmp145;
    TNode<RawPtrT> tmp146;
    TNode<RawPtrT> tmp147;
    TNode<IntPtrT> tmp148;
    TNode<JSReceiver> tmp149;
    TNode<Number> tmp150;
    TNode<Number> tmp151;
    TNode<Smi> tmp152;
    TNode<Number> tmp153;
    TNode<Object> tmp154;
    ca_.Bind(&block13, &tmp145, &tmp146, &tmp147, &tmp148, &tmp149, &tmp150, &tmp151, &tmp152, &tmp153, &tmp154);
  return TNode<Object>{tmp154};
}

TF_BUILTIN(ArrayPrototypeSplice, CodeStubAssembler) {
  compiler::CodeAssemblerState* state_ = state();  compiler::CodeAssembler ca_(state());
  Node* argc = Parameter(Descriptor::kJSActualArgumentsCount);
  TNode<IntPtrT> arguments_length(ChangeInt32ToIntPtr(argc));
  TNode<RawPtrT> arguments_frame = UncheckedCast<RawPtrT>(LoadFramePointer());
  TorqueStructArguments torque_arguments(GetFrameArguments(arguments_frame, arguments_length));
  CodeStubArguments arguments(this, torque_arguments);
  TNode<NativeContext> parameter0 = UncheckedCast<NativeContext>(Parameter(Descriptor::kContext));
  USE(parameter0);
  TNode<Object> parameter1 = arguments.GetReceiver();
USE(parameter1);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object, JSReceiver, Number, Object, Number> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object, JSReceiver, Number, Object, Number> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object, JSReceiver, Number, Object, Number, Number> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object, JSReceiver, Number, Object, Number, Number, Smi, Number> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object, JSReceiver, Number, Object, Number, Number, Smi, Number> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object, JSReceiver, Number, Object, Number, Number, Smi, Number> block8(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object, JSReceiver, Number, Object, Number, Number, Smi, Number> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object, JSReceiver, Number, Object, Number, Number, Smi, Number> block10(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object, JSReceiver, Number, Object, Number, Number, Smi, Number> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object, JSReceiver, Number, Object, Number, Number, Smi, Number, Number> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object, JSReceiver, Number, Object, Number, Number, Smi, Number, Number> block12(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object, JSReceiver, Number, Object, Number, Number, Smi, Number, Number, NativeContext, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number> block16(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<RawPtrT, RawPtrT, IntPtrT, NativeContext, Object, JSReceiver, Number, Object, Number, Number, Smi, Number, Number, NativeContext, RawPtrT, RawPtrT, IntPtrT, JSReceiver, Number, Number, Smi, Number, Object> block15(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, torque_arguments.frame, torque_arguments.base, torque_arguments.length, parameter0, parameter1);

  if (block0.is_used()) {
    TNode<RawPtrT> tmp0;
    TNode<RawPtrT> tmp1;
    TNode<IntPtrT> tmp2;
    TNode<NativeContext> tmp3;
    TNode<Object> tmp4;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4);
    TNode<JSReceiver> tmp5;
    tmp5 = TORQUE_CAST(CodeStubAssembler(state_).CallBuiltin(Builtins::kToObject, tmp3, tmp4));
    USE(tmp5);
    TNode<Number> tmp6;
    USE(tmp6);
    tmp6 = GetLengthProperty_0(state_, TNode<Context>{tmp3}, TNode<Object>{tmp5});
    TNode<IntPtrT> tmp7;
    USE(tmp7);
    tmp7 = FromConstexpr_intptr_constexpr_int31_0(state_, 0);
    TNode<Object> tmp8;
    USE(tmp8);
    tmp8 = CodeStubAssembler(state_).GetArgumentValue(TorqueStructArguments{TNode<RawPtrT>{tmp0}, TNode<RawPtrT>{tmp1}, TNode<IntPtrT>{tmp2}}, TNode<IntPtrT>{tmp7});
    TNode<Number> tmp9;
    USE(tmp9);
    tmp9 = CodeStubAssembler(state_).ToInteger_Inline(TNode<Context>{tmp3}, TNode<Object>{tmp8});
    TNode<Number> tmp10;
    USE(tmp10);
    tmp10 = FromConstexpr_Number_constexpr_int31_0(state_, 0);
    TNode<BoolT> tmp11;
    USE(tmp11);
    tmp11 = NumberIsLessThan_0(state_, TNode<Number>{tmp9}, TNode<Number>{tmp10});
    ca_.Branch(tmp11, &block1, &block2, tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp6, tmp8, tmp9);
  }

  if (block1.is_used()) {
    TNode<RawPtrT> tmp12;
    TNode<RawPtrT> tmp13;
    TNode<IntPtrT> tmp14;
    TNode<NativeContext> tmp15;
    TNode<Object> tmp16;
    TNode<JSReceiver> tmp17;
    TNode<Number> tmp18;
    TNode<Object> tmp19;
    TNode<Number> tmp20;
    ca_.Bind(&block1, &tmp12, &tmp13, &tmp14, &tmp15, &tmp16, &tmp17, &tmp18, &tmp19, &tmp20);
    TNode<Number> tmp21;
    USE(tmp21);
    tmp21 = CodeStubAssembler(state_).NumberAdd(TNode<Number>{tmp18}, TNode<Number>{tmp20});
    TNode<Number> tmp22;
    USE(tmp22);
    tmp22 = FromConstexpr_Number_constexpr_int31_0(state_, 0);
    TNode<Number> tmp23;
    USE(tmp23);
    tmp23 = Max_0(state_, TNode<Number>{tmp21}, TNode<Number>{tmp22});
    ca_.Goto(&block3, tmp12, tmp13, tmp14, tmp15, tmp16, tmp17, tmp18, tmp19, tmp20, tmp23);
  }

  if (block2.is_used()) {
    TNode<RawPtrT> tmp24;
    TNode<RawPtrT> tmp25;
    TNode<IntPtrT> tmp26;
    TNode<NativeContext> tmp27;
    TNode<Object> tmp28;
    TNode<JSReceiver> tmp29;
    TNode<Number> tmp30;
    TNode<Object> tmp31;
    TNode<Number> tmp32;
    ca_.Bind(&block2, &tmp24, &tmp25, &tmp26, &tmp27, &tmp28, &tmp29, &tmp30, &tmp31, &tmp32);
    TNode<Number> tmp33;
    USE(tmp33);
    tmp33 = Min_0(state_, TNode<Number>{tmp32}, TNode<Number>{tmp30});
    ca_.Goto(&block3, tmp24, tmp25, tmp26, tmp27, tmp28, tmp29, tmp30, tmp31, tmp32, tmp33);
  }

  if (block3.is_used()) {
    TNode<RawPtrT> tmp34;
    TNode<RawPtrT> tmp35;
    TNode<IntPtrT> tmp36;
    TNode<NativeContext> tmp37;
    TNode<Object> tmp38;
    TNode<JSReceiver> tmp39;
    TNode<Number> tmp40;
    TNode<Object> tmp41;
    TNode<Number> tmp42;
    TNode<Number> tmp43;
    ca_.Bind(&block3, &tmp34, &tmp35, &tmp36, &tmp37, &tmp38, &tmp39, &tmp40, &tmp41, &tmp42, &tmp43);
    TNode<IntPtrT> tmp44;
    USE(tmp44);
    tmp44 = FromConstexpr_intptr_constexpr_int31_0(state_, 0);
    TNode<BoolT> tmp45;
    USE(tmp45);
    tmp45 = CodeStubAssembler(state_).WordEqual(TNode<IntPtrT>{tmp36}, TNode<IntPtrT>{tmp44});
    ca_.Branch(tmp45, &block5, &block6, tmp34, tmp35, tmp36, tmp37, tmp38, tmp39, tmp40, tmp41, tmp42, tmp43, ca_.Uninitialized<Smi>(), ca_.Uninitialized<Number>());
  }

  if (block5.is_used()) {
    TNode<RawPtrT> tmp46;
    TNode<RawPtrT> tmp47;
    TNode<IntPtrT> tmp48;
    TNode<NativeContext> tmp49;
    TNode<Object> tmp50;
    TNode<JSReceiver> tmp51;
    TNode<Number> tmp52;
    TNode<Object> tmp53;
    TNode<Number> tmp54;
    TNode<Number> tmp55;
    TNode<Smi> tmp56;
    TNode<Number> tmp57;
    ca_.Bind(&block5, &tmp46, &tmp47, &tmp48, &tmp49, &tmp50, &tmp51, &tmp52, &tmp53, &tmp54, &tmp55, &tmp56, &tmp57);
    TNode<Smi> tmp58;
    USE(tmp58);
    tmp58 = FromConstexpr_Smi_constexpr_int31_0(state_, 0);
    TNode<Number> tmp59;
    USE(tmp59);
    tmp59 = FromConstexpr_Number_constexpr_int31_0(state_, 0);
    ca_.Goto(&block7, tmp46, tmp47, tmp48, tmp49, tmp50, tmp51, tmp52, tmp53, tmp54, tmp55, tmp58, tmp59);
  }

  if (block6.is_used()) {
    TNode<RawPtrT> tmp60;
    TNode<RawPtrT> tmp61;
    TNode<IntPtrT> tmp62;
    TNode<NativeContext> tmp63;
    TNode<Object> tmp64;
    TNode<JSReceiver> tmp65;
    TNode<Number> tmp66;
    TNode<Object> tmp67;
    TNode<Number> tmp68;
    TNode<Number> tmp69;
    TNode<Smi> tmp70;
    TNode<Number> tmp71;
    ca_.Bind(&block6, &tmp60, &tmp61, &tmp62, &tmp63, &tmp64, &tmp65, &tmp66, &tmp67, &tmp68, &tmp69, &tmp70, &tmp71);
    TNode<IntPtrT> tmp72;
    USE(tmp72);
    tmp72 = FromConstexpr_intptr_constexpr_int31_0(state_, 1);
    TNode<BoolT> tmp73;
    USE(tmp73);
    tmp73 = CodeStubAssembler(state_).WordEqual(TNode<IntPtrT>{tmp62}, TNode<IntPtrT>{tmp72});
    ca_.Branch(tmp73, &block8, &block9, tmp60, tmp61, tmp62, tmp63, tmp64, tmp65, tmp66, tmp67, tmp68, tmp69, tmp70, tmp71);
  }

  if (block8.is_used()) {
    TNode<RawPtrT> tmp74;
    TNode<RawPtrT> tmp75;
    TNode<IntPtrT> tmp76;
    TNode<NativeContext> tmp77;
    TNode<Object> tmp78;
    TNode<JSReceiver> tmp79;
    TNode<Number> tmp80;
    TNode<Object> tmp81;
    TNode<Number> tmp82;
    TNode<Number> tmp83;
    TNode<Smi> tmp84;
    TNode<Number> tmp85;
    ca_.Bind(&block8, &tmp74, &tmp75, &tmp76, &tmp77, &tmp78, &tmp79, &tmp80, &tmp81, &tmp82, &tmp83, &tmp84, &tmp85);
    TNode<Smi> tmp86;
    USE(tmp86);
    tmp86 = FromConstexpr_Smi_constexpr_int31_0(state_, 0);
    TNode<Number> tmp87;
    USE(tmp87);
    tmp87 = CodeStubAssembler(state_).NumberSub(TNode<Number>{tmp80}, TNode<Number>{tmp83});
    ca_.Goto(&block10, tmp74, tmp75, tmp76, tmp77, tmp78, tmp79, tmp80, tmp81, tmp82, tmp83, tmp86, tmp87);
  }

  if (block9.is_used()) {
    TNode<RawPtrT> tmp88;
    TNode<RawPtrT> tmp89;
    TNode<IntPtrT> tmp90;
    TNode<NativeContext> tmp91;
    TNode<Object> tmp92;
    TNode<JSReceiver> tmp93;
    TNode<Number> tmp94;
    TNode<Object> tmp95;
    TNode<Number> tmp96;
    TNode<Number> tmp97;
    TNode<Smi> tmp98;
    TNode<Number> tmp99;
    ca_.Bind(&block9, &tmp88, &tmp89, &tmp90, &tmp91, &tmp92, &tmp93, &tmp94, &tmp95, &tmp96, &tmp97, &tmp98, &tmp99);
    TNode<Smi> tmp100;
    USE(tmp100);
    tmp100 = Convert_Smi_intptr_0(state_, TNode<IntPtrT>{tmp90});
    TNode<Smi> tmp101;
    USE(tmp101);
    tmp101 = FromConstexpr_Smi_constexpr_int31_0(state_, 2);
    TNode<Smi> tmp102;
    USE(tmp102);
    tmp102 = CodeStubAssembler(state_).SmiSub(TNode<Smi>{tmp100}, TNode<Smi>{tmp101});
    TNode<IntPtrT> tmp103;
    USE(tmp103);
    tmp103 = FromConstexpr_intptr_constexpr_int31_0(state_, 1);
    TNode<Object> tmp104;
    USE(tmp104);
    tmp104 = CodeStubAssembler(state_).GetArgumentValue(TorqueStructArguments{TNode<RawPtrT>{tmp88}, TNode<RawPtrT>{tmp89}, TNode<IntPtrT>{tmp90}}, TNode<IntPtrT>{tmp103});
    TNode<Number> tmp105;
    USE(tmp105);
    tmp105 = CodeStubAssembler(state_).ToInteger_Inline(TNode<Context>{tmp91}, TNode<Object>{tmp104});
    TNode<Number> tmp106;
    USE(tmp106);
    tmp106 = FromConstexpr_Number_constexpr_int31_0(state_, 0);
    TNode<Number> tmp107;
    USE(tmp107);
    tmp107 = Max_0(state_, TNode<Number>{tmp105}, TNode<Number>{tmp106});
    TNode<Number> tmp108;
    USE(tmp108);
    tmp108 = CodeStubAssembler(state_).NumberSub(TNode<Number>{tmp94}, TNode<Number>{tmp97});
    TNode<Number> tmp109;
    USE(tmp109);
    tmp109 = Min_0(state_, TNode<Number>{tmp107}, TNode<Number>{tmp108});
    ca_.Goto(&block10, tmp88, tmp89, tmp90, tmp91, tmp92, tmp93, tmp94, tmp95, tmp96, tmp97, tmp102, tmp109);
  }

  if (block10.is_used()) {
    TNode<RawPtrT> tmp110;
    TNode<RawPtrT> tmp111;
    TNode<IntPtrT> tmp112;
    TNode<NativeContext> tmp113;
    TNode<Object> tmp114;
    TNode<JSReceiver> tmp115;
    TNode<Number> tmp116;
    TNode<Object> tmp117;
    TNode<Number> tmp118;
    TNode<Number> tmp119;
    TNode<Smi> tmp120;
    TNode<Number> tmp121;
    ca_.Bind(&block10, &tmp110, &tmp111, &tmp112, &tmp113, &tmp114, &tmp115, &tmp116, &tmp117, &tmp118, &tmp119, &tmp120, &tmp121);
    ca_.Goto(&block7, tmp110, tmp111, tmp112, tmp113, tmp114, tmp115, tmp116, tmp117, tmp118, tmp119, tmp120, tmp121);
  }

  if (block7.is_used()) {
    TNode<RawPtrT> tmp122;
    TNode<RawPtrT> tmp123;
    TNode<IntPtrT> tmp124;
    TNode<NativeContext> tmp125;
    TNode<Object> tmp126;
    TNode<JSReceiver> tmp127;
    TNode<Number> tmp128;
    TNode<Object> tmp129;
    TNode<Number> tmp130;
    TNode<Number> tmp131;
    TNode<Smi> tmp132;
    TNode<Number> tmp133;
    ca_.Bind(&block7, &tmp122, &tmp123, &tmp124, &tmp125, &tmp126, &tmp127, &tmp128, &tmp129, &tmp130, &tmp131, &tmp132, &tmp133);
    TNode<Number> tmp134;
    USE(tmp134);
    tmp134 = CodeStubAssembler(state_).NumberAdd(TNode<Number>{tmp128}, TNode<Number>{tmp132});
    TNode<Number> tmp135;
    USE(tmp135);
    tmp135 = CodeStubAssembler(state_).NumberSub(TNode<Number>{tmp134}, TNode<Number>{tmp133});
    TNode<Number> tmp136;
    USE(tmp136);
    tmp136 = FromConstexpr_Number_constexpr_float64_0(state_, kMaxSafeInteger);
    TNode<BoolT> tmp137;
    USE(tmp137);
    tmp137 = NumberIsGreaterThan_0(state_, TNode<Number>{tmp135}, TNode<Number>{tmp136});
    ca_.Branch(tmp137, &block11, &block12, tmp122, tmp123, tmp124, tmp125, tmp126, tmp127, tmp128, tmp129, tmp130, tmp131, tmp132, tmp133, tmp135);
  }

  if (block11.is_used()) {
    TNode<RawPtrT> tmp138;
    TNode<RawPtrT> tmp139;
    TNode<IntPtrT> tmp140;
    TNode<NativeContext> tmp141;
    TNode<Object> tmp142;
    TNode<JSReceiver> tmp143;
    TNode<Number> tmp144;
    TNode<Object> tmp145;
    TNode<Number> tmp146;
    TNode<Number> tmp147;
    TNode<Smi> tmp148;
    TNode<Number> tmp149;
    TNode<Number> tmp150;
    ca_.Bind(&block11, &tmp138, &tmp139, &tmp140, &tmp141, &tmp142, &tmp143, &tmp144, &tmp145, &tmp146, &tmp147, &tmp148, &tmp149, &tmp150);
    CodeStubAssembler(state_).ThrowTypeError(TNode<Context>{tmp141}, MessageTemplate::kInvalidArrayLength, TNode<Object>{tmp145});
  }

  if (block12.is_used()) {
    TNode<RawPtrT> tmp151;
    TNode<RawPtrT> tmp152;
    TNode<IntPtrT> tmp153;
    TNode<NativeContext> tmp154;
    TNode<Object> tmp155;
    TNode<JSReceiver> tmp156;
    TNode<Number> tmp157;
    TNode<Object> tmp158;
    TNode<Number> tmp159;
    TNode<Number> tmp160;
    TNode<Smi> tmp161;
    TNode<Number> tmp162;
    TNode<Number> tmp163;
    ca_.Bind(&block12, &tmp151, &tmp152, &tmp153, &tmp154, &tmp155, &tmp156, &tmp157, &tmp158, &tmp159, &tmp160, &tmp161, &tmp162, &tmp163);
    TNode<Object> tmp164;
    USE(tmp164);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp164 = FastArraySplice_0(state_, TNode<Context>{tmp154}, TorqueStructArguments{TNode<RawPtrT>{tmp151}, TNode<RawPtrT>{tmp152}, TNode<IntPtrT>{tmp153}}, TNode<JSReceiver>{tmp156}, TNode<Number>{tmp157}, TNode<Number>{tmp160}, TNode<Smi>{tmp161}, TNode<Number>{tmp162}, &label0);
    ca_.Goto(&block15, tmp151, tmp152, tmp153, tmp154, tmp155, tmp156, tmp157, tmp158, tmp159, tmp160, tmp161, tmp162, tmp163, tmp154, tmp151, tmp152, tmp153, tmp156, tmp157, tmp160, tmp161, tmp162, tmp164);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block16, tmp151, tmp152, tmp153, tmp154, tmp155, tmp156, tmp157, tmp158, tmp159, tmp160, tmp161, tmp162, tmp163, tmp154, tmp151, tmp152, tmp153, tmp156, tmp157, tmp160, tmp161, tmp162);
    }
  }

  if (block16.is_used()) {
    TNode<RawPtrT> tmp165;
    TNode<RawPtrT> tmp166;
    TNode<IntPtrT> tmp167;
    TNode<NativeContext> tmp168;
    TNode<Object> tmp169;
    TNode<JSReceiver> tmp170;
    TNode<Number> tmp171;
    TNode<Object> tmp172;
    TNode<Number> tmp173;
    TNode<Number> tmp174;
    TNode<Smi> tmp175;
    TNode<Number> tmp176;
    TNode<Number> tmp177;
    TNode<NativeContext> tmp178;
    TNode<RawPtrT> tmp179;
    TNode<RawPtrT> tmp180;
    TNode<IntPtrT> tmp181;
    TNode<JSReceiver> tmp182;
    TNode<Number> tmp183;
    TNode<Number> tmp184;
    TNode<Smi> tmp185;
    TNode<Number> tmp186;
    ca_.Bind(&block16, &tmp165, &tmp166, &tmp167, &tmp168, &tmp169, &tmp170, &tmp171, &tmp172, &tmp173, &tmp174, &tmp175, &tmp176, &tmp177, &tmp178, &tmp179, &tmp180, &tmp181, &tmp182, &tmp183, &tmp184, &tmp185, &tmp186);
    TNode<Object> tmp187;
    USE(tmp187);
    tmp187 = SlowSplice_0(state_, TNode<Context>{tmp168}, TorqueStructArguments{TNode<RawPtrT>{tmp165}, TNode<RawPtrT>{tmp166}, TNode<IntPtrT>{tmp167}}, TNode<JSReceiver>{tmp170}, TNode<Number>{tmp171}, TNode<Number>{tmp174}, TNode<Smi>{tmp175}, TNode<Number>{tmp176});
    arguments.PopAndReturn(tmp187);
  }

  if (block15.is_used()) {
    TNode<RawPtrT> tmp188;
    TNode<RawPtrT> tmp189;
    TNode<IntPtrT> tmp190;
    TNode<NativeContext> tmp191;
    TNode<Object> tmp192;
    TNode<JSReceiver> tmp193;
    TNode<Number> tmp194;
    TNode<Object> tmp195;
    TNode<Number> tmp196;
    TNode<Number> tmp197;
    TNode<Smi> tmp198;
    TNode<Number> tmp199;
    TNode<Number> tmp200;
    TNode<NativeContext> tmp201;
    TNode<RawPtrT> tmp202;
    TNode<RawPtrT> tmp203;
    TNode<IntPtrT> tmp204;
    TNode<JSReceiver> tmp205;
    TNode<Number> tmp206;
    TNode<Number> tmp207;
    TNode<Smi> tmp208;
    TNode<Number> tmp209;
    TNode<Object> tmp210;
    ca_.Bind(&block15, &tmp188, &tmp189, &tmp190, &tmp191, &tmp192, &tmp193, &tmp194, &tmp195, &tmp196, &tmp197, &tmp198, &tmp199, &tmp200, &tmp201, &tmp202, &tmp203, &tmp204, &tmp205, &tmp206, &tmp207, &tmp208, &tmp209, &tmp210);
    arguments.PopAndReturn(tmp210);
  }
}

void FastSplice_FixedArray_JSAny_0(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TorqueStructArguments p_args, TNode<JSArray> p_a, TNode<Smi> p_length, TNode<Smi> p_newLength, TNode<Smi> p_actualStart, TNode<Smi> p_insertCount, TNode<Smi> p_actualDeleteCount) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, FixedArray, Smi, Smi, Smi> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, FixedArray, Smi, Smi, Smi> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, FixedArray, Smi, Smi, Smi> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, FixedArray, Smi, Smi, Smi> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, FixedArray, Smi, Smi, Smi> block10(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, FixedArray, Smi, Smi, Smi, Smi, FixedArray> block12(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, FixedArray, Smi, Smi, Smi, Smi, FixedArray> block13(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, FixedArray, Smi, Smi, Smi> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, FixedArray, Smi, Smi, Smi> block8(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, FixedArray, Smi, Smi, Smi> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, Smi> block14(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, Smi, FixedArray, IntPtrT> block18(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, Smi, FixedArray, IntPtrT> block16(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, Smi, FixedArray, IntPtrT> block17(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, Smi> block15(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi> block20(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_args.frame, p_args.base, p_args.length, p_a, p_length, p_newLength, p_actualStart, p_insertCount, p_actualDeleteCount);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<RawPtrT> tmp1;
    TNode<RawPtrT> tmp2;
    TNode<IntPtrT> tmp3;
    TNode<JSArray> tmp4;
    TNode<Smi> tmp5;
    TNode<Smi> tmp6;
    TNode<Smi> tmp7;
    TNode<Smi> tmp8;
    TNode<Smi> tmp9;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4, &tmp5, &tmp6, &tmp7, &tmp8, &tmp9);
    EnsureWriteableFastElements_0(state_, TNode<Context>{tmp0}, TNode<JSArray>{tmp4});
    TNode<BoolT> tmp10;
    USE(tmp10);
    tmp10 = CodeStubAssembler(state_).SmiNotEqual(TNode<Smi>{tmp8}, TNode<Smi>{tmp9});
    ca_.Branch(tmp10, &block2, &block3, tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp6, tmp7, tmp8, tmp9);
  }

  if (block2.is_used()) {
    TNode<Context> tmp11;
    TNode<RawPtrT> tmp12;
    TNode<RawPtrT> tmp13;
    TNode<IntPtrT> tmp14;
    TNode<JSArray> tmp15;
    TNode<Smi> tmp16;
    TNode<Smi> tmp17;
    TNode<Smi> tmp18;
    TNode<Smi> tmp19;
    TNode<Smi> tmp20;
    ca_.Bind(&block2, &tmp11, &tmp12, &tmp13, &tmp14, &tmp15, &tmp16, &tmp17, &tmp18, &tmp19, &tmp20);
    TNode<IntPtrT> tmp21;
    USE(tmp21);
    tmp21 = FromConstexpr_intptr_constexpr_int31_0(state_, 16);
    TNode<FixedArrayBase>tmp22 = CodeStubAssembler(state_).LoadReference<FixedArrayBase>(CodeStubAssembler::Reference{tmp15, tmp21});
    TNode<FixedArray> tmp23;
    USE(tmp23);
    tmp23 = UnsafeCast_FixedArray_0(state_, TNode<Context>{tmp11}, TNode<Object>{tmp22});
    TNode<Smi> tmp24;
    USE(tmp24);
    tmp24 = CodeStubAssembler(state_).SmiAdd(TNode<Smi>{tmp18}, TNode<Smi>{tmp19});
    TNode<Smi> tmp25;
    USE(tmp25);
    tmp25 = CodeStubAssembler(state_).SmiAdd(TNode<Smi>{tmp18}, TNode<Smi>{tmp20});
    TNode<Smi> tmp26;
    USE(tmp26);
    tmp26 = CodeStubAssembler(state_).SmiSub(TNode<Smi>{tmp16}, TNode<Smi>{tmp20});
    TNode<Smi> tmp27;
    USE(tmp27);
    tmp27 = CodeStubAssembler(state_).SmiSub(TNode<Smi>{tmp26}, TNode<Smi>{tmp18});
    TNode<BoolT> tmp28;
    USE(tmp28);
    tmp28 = CodeStubAssembler(state_).SmiLessThan(TNode<Smi>{tmp19}, TNode<Smi>{tmp20});
    ca_.Branch(tmp28, &block4, &block5, tmp11, tmp12, tmp13, tmp14, tmp15, tmp16, tmp17, tmp18, tmp19, tmp20, tmp23, tmp24, tmp25, tmp27);
  }

  if (block4.is_used()) {
    TNode<Context> tmp29;
    TNode<RawPtrT> tmp30;
    TNode<RawPtrT> tmp31;
    TNode<IntPtrT> tmp32;
    TNode<JSArray> tmp33;
    TNode<Smi> tmp34;
    TNode<Smi> tmp35;
    TNode<Smi> tmp36;
    TNode<Smi> tmp37;
    TNode<Smi> tmp38;
    TNode<FixedArray> tmp39;
    TNode<Smi> tmp40;
    TNode<Smi> tmp41;
    TNode<Smi> tmp42;
    ca_.Bind(&block4, &tmp29, &tmp30, &tmp31, &tmp32, &tmp33, &tmp34, &tmp35, &tmp36, &tmp37, &tmp38, &tmp39, &tmp40, &tmp41, &tmp42);
    TNode<FixedArray> tmp43;
    USE(tmp43);
    tmp43 = UnsafeCast_FixedArray_0(state_, TNode<Context>{tmp29}, TNode<Object>{tmp39});
    DoMoveElements_FixedArray_0(state_, TNode<FixedArray>{tmp43}, TNode<Smi>{tmp40}, TNode<Smi>{tmp41}, TNode<Smi>{tmp42});
    TNode<FixedArray> tmp44;
    USE(tmp44);
    tmp44 = UnsafeCast_FixedArray_0(state_, TNode<Context>{tmp29}, TNode<Object>{tmp39});
    StoreHoles_FixedArray_0(state_, TNode<FixedArray>{tmp44}, TNode<Smi>{tmp35}, TNode<Smi>{tmp34});
    ca_.Goto(&block6, tmp29, tmp30, tmp31, tmp32, tmp33, tmp34, tmp35, tmp36, tmp37, tmp38, tmp39, tmp40, tmp41, tmp42);
  }

  if (block5.is_used()) {
    TNode<Context> tmp45;
    TNode<RawPtrT> tmp46;
    TNode<RawPtrT> tmp47;
    TNode<IntPtrT> tmp48;
    TNode<JSArray> tmp49;
    TNode<Smi> tmp50;
    TNode<Smi> tmp51;
    TNode<Smi> tmp52;
    TNode<Smi> tmp53;
    TNode<Smi> tmp54;
    TNode<FixedArray> tmp55;
    TNode<Smi> tmp56;
    TNode<Smi> tmp57;
    TNode<Smi> tmp58;
    ca_.Bind(&block5, &tmp45, &tmp46, &tmp47, &tmp48, &tmp49, &tmp50, &tmp51, &tmp52, &tmp53, &tmp54, &tmp55, &tmp56, &tmp57, &tmp58);
    TNode<BoolT> tmp59;
    USE(tmp59);
    tmp59 = CodeStubAssembler(state_).SmiGreaterThan(TNode<Smi>{tmp53}, TNode<Smi>{tmp54});
    ca_.Branch(tmp59, &block7, &block8, tmp45, tmp46, tmp47, tmp48, tmp49, tmp50, tmp51, tmp52, tmp53, tmp54, tmp55, tmp56, tmp57, tmp58);
  }

  if (block7.is_used()) {
    TNode<Context> tmp60;
    TNode<RawPtrT> tmp61;
    TNode<RawPtrT> tmp62;
    TNode<IntPtrT> tmp63;
    TNode<JSArray> tmp64;
    TNode<Smi> tmp65;
    TNode<Smi> tmp66;
    TNode<Smi> tmp67;
    TNode<Smi> tmp68;
    TNode<Smi> tmp69;
    TNode<FixedArray> tmp70;
    TNode<Smi> tmp71;
    TNode<Smi> tmp72;
    TNode<Smi> tmp73;
    ca_.Bind(&block7, &tmp60, &tmp61, &tmp62, &tmp63, &tmp64, &tmp65, &tmp66, &tmp67, &tmp68, &tmp69, &tmp70, &tmp71, &tmp72, &tmp73);
    TNode<IntPtrT> tmp74;
    USE(tmp74);
    tmp74 = FromConstexpr_intptr_constexpr_int31_0(state_, 8);
    TNode<Smi>tmp75 = CodeStubAssembler(state_).LoadReference<Smi>(CodeStubAssembler::Reference{tmp70, tmp74});
    TNode<BoolT> tmp76;
    USE(tmp76);
    tmp76 = CodeStubAssembler(state_).SmiLessThanOrEqual(TNode<Smi>{tmp66}, TNode<Smi>{tmp75});
    ca_.Branch(tmp76, &block9, &block10, tmp60, tmp61, tmp62, tmp63, tmp64, tmp65, tmp66, tmp67, tmp68, tmp69, tmp70, tmp71, tmp72, tmp73);
  }

  if (block9.is_used()) {
    TNode<Context> tmp77;
    TNode<RawPtrT> tmp78;
    TNode<RawPtrT> tmp79;
    TNode<IntPtrT> tmp80;
    TNode<JSArray> tmp81;
    TNode<Smi> tmp82;
    TNode<Smi> tmp83;
    TNode<Smi> tmp84;
    TNode<Smi> tmp85;
    TNode<Smi> tmp86;
    TNode<FixedArray> tmp87;
    TNode<Smi> tmp88;
    TNode<Smi> tmp89;
    TNode<Smi> tmp90;
    ca_.Bind(&block9, &tmp77, &tmp78, &tmp79, &tmp80, &tmp81, &tmp82, &tmp83, &tmp84, &tmp85, &tmp86, &tmp87, &tmp88, &tmp89, &tmp90);
    TNode<FixedArray> tmp91;
    USE(tmp91);
    tmp91 = UnsafeCast_FixedArray_0(state_, TNode<Context>{tmp77}, TNode<Object>{tmp87});
    DoMoveElements_FixedArray_0(state_, TNode<FixedArray>{tmp91}, TNode<Smi>{tmp88}, TNode<Smi>{tmp89}, TNode<Smi>{tmp90});
    ca_.Goto(&block11, tmp77, tmp78, tmp79, tmp80, tmp81, tmp82, tmp83, tmp84, tmp85, tmp86, tmp87, tmp88, tmp89, tmp90);
  }

  if (block10.is_used()) {
    TNode<Context> tmp92;
    TNode<RawPtrT> tmp93;
    TNode<RawPtrT> tmp94;
    TNode<IntPtrT> tmp95;
    TNode<JSArray> tmp96;
    TNode<Smi> tmp97;
    TNode<Smi> tmp98;
    TNode<Smi> tmp99;
    TNode<Smi> tmp100;
    TNode<Smi> tmp101;
    TNode<FixedArray> tmp102;
    TNode<Smi> tmp103;
    TNode<Smi> tmp104;
    TNode<Smi> tmp105;
    ca_.Bind(&block10, &tmp92, &tmp93, &tmp94, &tmp95, &tmp96, &tmp97, &tmp98, &tmp99, &tmp100, &tmp101, &tmp102, &tmp103, &tmp104, &tmp105);
    TNode<Smi> tmp106;
    USE(tmp106);
    tmp106 = CodeStubAssembler(state_).CalculateNewElementsCapacity(TNode<Smi>{tmp98});
    TNode<Smi> tmp107;
    USE(tmp107);
    tmp107 = FromConstexpr_Smi_constexpr_int31_0(state_, 0);
    TNode<FixedArray> tmp108;
    USE(tmp108);
    tmp108 = Extract_0(state_, TNode<Context>{tmp92}, TNode<FixedArray>{tmp102}, TNode<Smi>{tmp107}, TNode<Smi>{tmp99}, TNode<Smi>{tmp106});
    TNode<FixedArray> tmp109;
    USE(tmp109);
    tmp109 = UnsafeCast_FixedArray_0(state_, TNode<Context>{tmp92}, TNode<Object>{tmp108});
    TNode<IntPtrT> tmp110;
    USE(tmp110);
    tmp110 = FromConstexpr_intptr_constexpr_int31_0(state_, 16);
    CodeStubAssembler(state_).StoreReference<FixedArrayBase>(CodeStubAssembler::Reference{tmp96, tmp110}, tmp109);
    TNode<IntPtrT> tmp111;
    USE(tmp111);
    tmp111 = FromConstexpr_intptr_constexpr_int31_0(state_, 8);
    TNode<Smi>tmp112 = CodeStubAssembler(state_).LoadReference<Smi>(CodeStubAssembler::Reference{tmp102, tmp111});
    TNode<Smi> tmp113;
    USE(tmp113);
    tmp113 = FromConstexpr_Smi_constexpr_int31_0(state_, 0);
    TNode<BoolT> tmp114;
    USE(tmp114);
    tmp114 = CodeStubAssembler(state_).SmiGreaterThan(TNode<Smi>{tmp112}, TNode<Smi>{tmp113});
    ca_.Branch(tmp114, &block12, &block13, tmp92, tmp93, tmp94, tmp95, tmp96, tmp97, tmp98, tmp99, tmp100, tmp101, tmp102, tmp103, tmp104, tmp105, tmp106, tmp109);
  }

  if (block12.is_used()) {
    TNode<Context> tmp115;
    TNode<RawPtrT> tmp116;
    TNode<RawPtrT> tmp117;
    TNode<IntPtrT> tmp118;
    TNode<JSArray> tmp119;
    TNode<Smi> tmp120;
    TNode<Smi> tmp121;
    TNode<Smi> tmp122;
    TNode<Smi> tmp123;
    TNode<Smi> tmp124;
    TNode<FixedArray> tmp125;
    TNode<Smi> tmp126;
    TNode<Smi> tmp127;
    TNode<Smi> tmp128;
    TNode<Smi> tmp129;
    TNode<FixedArray> tmp130;
    ca_.Bind(&block12, &tmp115, &tmp116, &tmp117, &tmp118, &tmp119, &tmp120, &tmp121, &tmp122, &tmp123, &tmp124, &tmp125, &tmp126, &tmp127, &tmp128, &tmp129, &tmp130);
    TNode<FixedArray> tmp131;
    USE(tmp131);
    tmp131 = UnsafeCast_FixedArray_0(state_, TNode<Context>{tmp115}, TNode<Object>{tmp125});
    DoCopyElements_FixedArray_0(state_, TNode<FixedArray>{tmp130}, TNode<Smi>{tmp126}, TNode<FixedArray>{tmp131}, TNode<Smi>{tmp127}, TNode<Smi>{tmp128});
    ca_.Goto(&block13, tmp115, tmp116, tmp117, tmp118, tmp119, tmp120, tmp121, tmp122, tmp123, tmp124, tmp125, tmp126, tmp127, tmp128, tmp129, tmp130);
  }

  if (block13.is_used()) {
    TNode<Context> tmp132;
    TNode<RawPtrT> tmp133;
    TNode<RawPtrT> tmp134;
    TNode<IntPtrT> tmp135;
    TNode<JSArray> tmp136;
    TNode<Smi> tmp137;
    TNode<Smi> tmp138;
    TNode<Smi> tmp139;
    TNode<Smi> tmp140;
    TNode<Smi> tmp141;
    TNode<FixedArray> tmp142;
    TNode<Smi> tmp143;
    TNode<Smi> tmp144;
    TNode<Smi> tmp145;
    TNode<Smi> tmp146;
    TNode<FixedArray> tmp147;
    ca_.Bind(&block13, &tmp132, &tmp133, &tmp134, &tmp135, &tmp136, &tmp137, &tmp138, &tmp139, &tmp140, &tmp141, &tmp142, &tmp143, &tmp144, &tmp145, &tmp146, &tmp147);
    ca_.Goto(&block11, tmp132, tmp133, tmp134, tmp135, tmp136, tmp137, tmp138, tmp139, tmp140, tmp141, tmp142, tmp143, tmp144, tmp145);
  }

  if (block11.is_used()) {
    TNode<Context> tmp148;
    TNode<RawPtrT> tmp149;
    TNode<RawPtrT> tmp150;
    TNode<IntPtrT> tmp151;
    TNode<JSArray> tmp152;
    TNode<Smi> tmp153;
    TNode<Smi> tmp154;
    TNode<Smi> tmp155;
    TNode<Smi> tmp156;
    TNode<Smi> tmp157;
    TNode<FixedArray> tmp158;
    TNode<Smi> tmp159;
    TNode<Smi> tmp160;
    TNode<Smi> tmp161;
    ca_.Bind(&block11, &tmp148, &tmp149, &tmp150, &tmp151, &tmp152, &tmp153, &tmp154, &tmp155, &tmp156, &tmp157, &tmp158, &tmp159, &tmp160, &tmp161);
    ca_.Goto(&block8, tmp148, tmp149, tmp150, tmp151, tmp152, tmp153, tmp154, tmp155, tmp156, tmp157, tmp158, tmp159, tmp160, tmp161);
  }

  if (block8.is_used()) {
    TNode<Context> tmp162;
    TNode<RawPtrT> tmp163;
    TNode<RawPtrT> tmp164;
    TNode<IntPtrT> tmp165;
    TNode<JSArray> tmp166;
    TNode<Smi> tmp167;
    TNode<Smi> tmp168;
    TNode<Smi> tmp169;
    TNode<Smi> tmp170;
    TNode<Smi> tmp171;
    TNode<FixedArray> tmp172;
    TNode<Smi> tmp173;
    TNode<Smi> tmp174;
    TNode<Smi> tmp175;
    ca_.Bind(&block8, &tmp162, &tmp163, &tmp164, &tmp165, &tmp166, &tmp167, &tmp168, &tmp169, &tmp170, &tmp171, &tmp172, &tmp173, &tmp174, &tmp175);
    ca_.Goto(&block6, tmp162, tmp163, tmp164, tmp165, tmp166, tmp167, tmp168, tmp169, tmp170, tmp171, tmp172, tmp173, tmp174, tmp175);
  }

  if (block6.is_used()) {
    TNode<Context> tmp176;
    TNode<RawPtrT> tmp177;
    TNode<RawPtrT> tmp178;
    TNode<IntPtrT> tmp179;
    TNode<JSArray> tmp180;
    TNode<Smi> tmp181;
    TNode<Smi> tmp182;
    TNode<Smi> tmp183;
    TNode<Smi> tmp184;
    TNode<Smi> tmp185;
    TNode<FixedArray> tmp186;
    TNode<Smi> tmp187;
    TNode<Smi> tmp188;
    TNode<Smi> tmp189;
    ca_.Bind(&block6, &tmp176, &tmp177, &tmp178, &tmp179, &tmp180, &tmp181, &tmp182, &tmp183, &tmp184, &tmp185, &tmp186, &tmp187, &tmp188, &tmp189);
    ca_.Goto(&block3, tmp176, tmp177, tmp178, tmp179, tmp180, tmp181, tmp182, tmp183, tmp184, tmp185);
  }

  if (block3.is_used()) {
    TNode<Context> tmp190;
    TNode<RawPtrT> tmp191;
    TNode<RawPtrT> tmp192;
    TNode<IntPtrT> tmp193;
    TNode<JSArray> tmp194;
    TNode<Smi> tmp195;
    TNode<Smi> tmp196;
    TNode<Smi> tmp197;
    TNode<Smi> tmp198;
    TNode<Smi> tmp199;
    ca_.Bind(&block3, &tmp190, &tmp191, &tmp192, &tmp193, &tmp194, &tmp195, &tmp196, &tmp197, &tmp198, &tmp199);
    TNode<Smi> tmp200;
    USE(tmp200);
    tmp200 = FromConstexpr_Smi_constexpr_int31_0(state_, 0);
    TNode<BoolT> tmp201;
    USE(tmp201);
    tmp201 = CodeStubAssembler(state_).SmiGreaterThan(TNode<Smi>{tmp198}, TNode<Smi>{tmp200});
    ca_.Branch(tmp201, &block14, &block15, tmp190, tmp191, tmp192, tmp193, tmp194, tmp195, tmp196, tmp197, tmp198, tmp199, tmp197);
  }

  if (block14.is_used()) {
    TNode<Context> tmp202;
    TNode<RawPtrT> tmp203;
    TNode<RawPtrT> tmp204;
    TNode<IntPtrT> tmp205;
    TNode<JSArray> tmp206;
    TNode<Smi> tmp207;
    TNode<Smi> tmp208;
    TNode<Smi> tmp209;
    TNode<Smi> tmp210;
    TNode<Smi> tmp211;
    TNode<Smi> tmp212;
    ca_.Bind(&block14, &tmp202, &tmp203, &tmp204, &tmp205, &tmp206, &tmp207, &tmp208, &tmp209, &tmp210, &tmp211, &tmp212);
    TNode<IntPtrT> tmp213;
    USE(tmp213);
    tmp213 = FromConstexpr_intptr_constexpr_int31_0(state_, 16);
    TNode<FixedArrayBase>tmp214 = CodeStubAssembler(state_).LoadReference<FixedArrayBase>(CodeStubAssembler::Reference{tmp206, tmp213});
    TNode<FixedArray> tmp215;
    USE(tmp215);
    tmp215 = UnsafeCast_FixedArray_0(state_, TNode<Context>{tmp202}, TNode<Object>{tmp214});
    TNode<IntPtrT> tmp216;
    USE(tmp216);
    tmp216 = FromConstexpr_intptr_constexpr_int31_0(state_, 2);
    ca_.Goto(&block18, tmp202, tmp203, tmp204, tmp205, tmp206, tmp207, tmp208, tmp209, tmp210, tmp211, tmp212, tmp215, tmp216);
  }

  if (block18.is_used()) {
    TNode<Context> tmp217;
    TNode<RawPtrT> tmp218;
    TNode<RawPtrT> tmp219;
    TNode<IntPtrT> tmp220;
    TNode<JSArray> tmp221;
    TNode<Smi> tmp222;
    TNode<Smi> tmp223;
    TNode<Smi> tmp224;
    TNode<Smi> tmp225;
    TNode<Smi> tmp226;
    TNode<Smi> tmp227;
    TNode<FixedArray> tmp228;
    TNode<IntPtrT> tmp229;
    ca_.Bind(&block18, &tmp217, &tmp218, &tmp219, &tmp220, &tmp221, &tmp222, &tmp223, &tmp224, &tmp225, &tmp226, &tmp227, &tmp228, &tmp229);
    TNode<BoolT> tmp230;
    USE(tmp230);
    tmp230 = CodeStubAssembler(state_).IntPtrLessThan(TNode<IntPtrT>{tmp229}, TNode<IntPtrT>{tmp220});
    ca_.Branch(tmp230, &block16, &block17, tmp217, tmp218, tmp219, tmp220, tmp221, tmp222, tmp223, tmp224, tmp225, tmp226, tmp227, tmp228, tmp229);
  }

  if (block16.is_used()) {
    TNode<Context> tmp231;
    TNode<RawPtrT> tmp232;
    TNode<RawPtrT> tmp233;
    TNode<IntPtrT> tmp234;
    TNode<JSArray> tmp235;
    TNode<Smi> tmp236;
    TNode<Smi> tmp237;
    TNode<Smi> tmp238;
    TNode<Smi> tmp239;
    TNode<Smi> tmp240;
    TNode<Smi> tmp241;
    TNode<FixedArray> tmp242;
    TNode<IntPtrT> tmp243;
    ca_.Bind(&block16, &tmp231, &tmp232, &tmp233, &tmp234, &tmp235, &tmp236, &tmp237, &tmp238, &tmp239, &tmp240, &tmp241, &tmp242, &tmp243);
    TNode<Object> tmp244;
    USE(tmp244);
    tmp244 = CodeStubAssembler(state_).GetArgumentValue(TorqueStructArguments{TNode<RawPtrT>{tmp232}, TNode<RawPtrT>{tmp233}, TNode<IntPtrT>{tmp234}}, TNode<IntPtrT>{tmp243});
    TNode<Smi> tmp245;
    USE(tmp245);
    tmp245 = FromConstexpr_Smi_constexpr_int31_0(state_, 1);
    TNode<Smi> tmp246;
    USE(tmp246);
    tmp246 = CodeStubAssembler(state_).SmiAdd(TNode<Smi>{tmp241}, TNode<Smi>{tmp245});
    TNode<Object> tmp247;
    USE(tmp247);
    tmp247 = UnsafeCast_JSAny_0(state_, TNode<Context>{tmp231}, TNode<Object>{tmp244});
    StoreFixedArrayDirect_0(state_, TNode<FixedArray>{tmp242}, TNode<Smi>{tmp241}, TNode<Object>{tmp247});
    TNode<IntPtrT> tmp248;
    USE(tmp248);
    tmp248 = FromConstexpr_intptr_constexpr_int31_0(state_, 1);
    TNode<IntPtrT> tmp249;
    USE(tmp249);
    tmp249 = CodeStubAssembler(state_).IntPtrAdd(TNode<IntPtrT>{tmp243}, TNode<IntPtrT>{tmp248});
    ca_.Goto(&block18, tmp231, tmp232, tmp233, tmp234, tmp235, tmp236, tmp237, tmp238, tmp239, tmp240, tmp246, tmp242, tmp249);
  }

  if (block17.is_used()) {
    TNode<Context> tmp250;
    TNode<RawPtrT> tmp251;
    TNode<RawPtrT> tmp252;
    TNode<IntPtrT> tmp253;
    TNode<JSArray> tmp254;
    TNode<Smi> tmp255;
    TNode<Smi> tmp256;
    TNode<Smi> tmp257;
    TNode<Smi> tmp258;
    TNode<Smi> tmp259;
    TNode<Smi> tmp260;
    TNode<FixedArray> tmp261;
    TNode<IntPtrT> tmp262;
    ca_.Bind(&block17, &tmp250, &tmp251, &tmp252, &tmp253, &tmp254, &tmp255, &tmp256, &tmp257, &tmp258, &tmp259, &tmp260, &tmp261, &tmp262);
    ca_.Goto(&block15, tmp250, tmp251, tmp252, tmp253, tmp254, tmp255, tmp256, tmp257, tmp258, tmp259, tmp260);
  }

  if (block15.is_used()) {
    TNode<Context> tmp263;
    TNode<RawPtrT> tmp264;
    TNode<RawPtrT> tmp265;
    TNode<IntPtrT> tmp266;
    TNode<JSArray> tmp267;
    TNode<Smi> tmp268;
    TNode<Smi> tmp269;
    TNode<Smi> tmp270;
    TNode<Smi> tmp271;
    TNode<Smi> tmp272;
    TNode<Smi> tmp273;
    ca_.Bind(&block15, &tmp263, &tmp264, &tmp265, &tmp266, &tmp267, &tmp268, &tmp269, &tmp270, &tmp271, &tmp272, &tmp273);
    TNode<IntPtrT> tmp274;
    USE(tmp274);
    tmp274 = FromConstexpr_intptr_constexpr_int31_0(state_, 24);
    CodeStubAssembler(state_).StoreReference<Number>(CodeStubAssembler::Reference{tmp267, tmp274}, tmp269);
    ca_.Goto(&block20, tmp263, tmp264, tmp265, tmp266, tmp267, tmp268, tmp269, tmp270, tmp271, tmp272);
  }

    TNode<Context> tmp275;
    TNode<RawPtrT> tmp276;
    TNode<RawPtrT> tmp277;
    TNode<IntPtrT> tmp278;
    TNode<JSArray> tmp279;
    TNode<Smi> tmp280;
    TNode<Smi> tmp281;
    TNode<Smi> tmp282;
    TNode<Smi> tmp283;
    TNode<Smi> tmp284;
    ca_.Bind(&block20, &tmp275, &tmp276, &tmp277, &tmp278, &tmp279, &tmp280, &tmp281, &tmp282, &tmp283, &tmp284);
}

void FastSplice_FixedDoubleArray_Number_0(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TorqueStructArguments p_args, TNode<JSArray> p_a, TNode<Smi> p_length, TNode<Smi> p_newLength, TNode<Smi> p_actualStart, TNode<Smi> p_insertCount, TNode<Smi> p_actualDeleteCount) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, FixedArrayBase, Smi, Smi, Smi> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, FixedArrayBase, Smi, Smi, Smi> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, FixedArrayBase, Smi, Smi, Smi> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, FixedArrayBase, Smi, Smi, Smi> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, FixedArrayBase, Smi, Smi, Smi> block10(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, FixedArrayBase, Smi, Smi, Smi, Smi, FixedDoubleArray> block12(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, FixedArrayBase, Smi, Smi, Smi, Smi, FixedDoubleArray> block13(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, FixedArrayBase, Smi, Smi, Smi> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, FixedArrayBase, Smi, Smi, Smi> block8(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, FixedArrayBase, Smi, Smi, Smi> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, Smi> block14(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, Smi, FixedDoubleArray, IntPtrT> block18(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, Smi, FixedDoubleArray, IntPtrT> block16(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, Smi, FixedDoubleArray, IntPtrT> block17(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi, Smi> block15(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, RawPtrT, RawPtrT, IntPtrT, JSArray, Smi, Smi, Smi, Smi, Smi> block20(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_args.frame, p_args.base, p_args.length, p_a, p_length, p_newLength, p_actualStart, p_insertCount, p_actualDeleteCount);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<RawPtrT> tmp1;
    TNode<RawPtrT> tmp2;
    TNode<IntPtrT> tmp3;
    TNode<JSArray> tmp4;
    TNode<Smi> tmp5;
    TNode<Smi> tmp6;
    TNode<Smi> tmp7;
    TNode<Smi> tmp8;
    TNode<Smi> tmp9;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4, &tmp5, &tmp6, &tmp7, &tmp8, &tmp9);
    EnsureWriteableFastElements_0(state_, TNode<Context>{tmp0}, TNode<JSArray>{tmp4});
    TNode<BoolT> tmp10;
    USE(tmp10);
    tmp10 = CodeStubAssembler(state_).SmiNotEqual(TNode<Smi>{tmp8}, TNode<Smi>{tmp9});
    ca_.Branch(tmp10, &block2, &block3, tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp6, tmp7, tmp8, tmp9);
  }

  if (block2.is_used()) {
    TNode<Context> tmp11;
    TNode<RawPtrT> tmp12;
    TNode<RawPtrT> tmp13;
    TNode<IntPtrT> tmp14;
    TNode<JSArray> tmp15;
    TNode<Smi> tmp16;
    TNode<Smi> tmp17;
    TNode<Smi> tmp18;
    TNode<Smi> tmp19;
    TNode<Smi> tmp20;
    ca_.Bind(&block2, &tmp11, &tmp12, &tmp13, &tmp14, &tmp15, &tmp16, &tmp17, &tmp18, &tmp19, &tmp20);
    TNode<IntPtrT> tmp21;
    USE(tmp21);
    tmp21 = FromConstexpr_intptr_constexpr_int31_0(state_, 16);
    TNode<FixedArrayBase>tmp22 = CodeStubAssembler(state_).LoadReference<FixedArrayBase>(CodeStubAssembler::Reference{tmp15, tmp21});
    TNode<FixedArrayBase> tmp23;
    USE(tmp23);
    tmp23 = UnsafeCast_EmptyFixedArray_OR_FixedDoubleArray_0(state_, TNode<Context>{tmp11}, TNode<Object>{tmp22});
    TNode<Smi> tmp24;
    USE(tmp24);
    tmp24 = CodeStubAssembler(state_).SmiAdd(TNode<Smi>{tmp18}, TNode<Smi>{tmp19});
    TNode<Smi> tmp25;
    USE(tmp25);
    tmp25 = CodeStubAssembler(state_).SmiAdd(TNode<Smi>{tmp18}, TNode<Smi>{tmp20});
    TNode<Smi> tmp26;
    USE(tmp26);
    tmp26 = CodeStubAssembler(state_).SmiSub(TNode<Smi>{tmp16}, TNode<Smi>{tmp20});
    TNode<Smi> tmp27;
    USE(tmp27);
    tmp27 = CodeStubAssembler(state_).SmiSub(TNode<Smi>{tmp26}, TNode<Smi>{tmp18});
    TNode<BoolT> tmp28;
    USE(tmp28);
    tmp28 = CodeStubAssembler(state_).SmiLessThan(TNode<Smi>{tmp19}, TNode<Smi>{tmp20});
    ca_.Branch(tmp28, &block4, &block5, tmp11, tmp12, tmp13, tmp14, tmp15, tmp16, tmp17, tmp18, tmp19, tmp20, tmp23, tmp24, tmp25, tmp27);
  }

  if (block4.is_used()) {
    TNode<Context> tmp29;
    TNode<RawPtrT> tmp30;
    TNode<RawPtrT> tmp31;
    TNode<IntPtrT> tmp32;
    TNode<JSArray> tmp33;
    TNode<Smi> tmp34;
    TNode<Smi> tmp35;
    TNode<Smi> tmp36;
    TNode<Smi> tmp37;
    TNode<Smi> tmp38;
    TNode<FixedArrayBase> tmp39;
    TNode<Smi> tmp40;
    TNode<Smi> tmp41;
    TNode<Smi> tmp42;
    ca_.Bind(&block4, &tmp29, &tmp30, &tmp31, &tmp32, &tmp33, &tmp34, &tmp35, &tmp36, &tmp37, &tmp38, &tmp39, &tmp40, &tmp41, &tmp42);
    TNode<FixedDoubleArray> tmp43;
    USE(tmp43);
    tmp43 = UnsafeCast_FixedDoubleArray_0(state_, TNode<Context>{tmp29}, TNode<Object>{tmp39});
    DoMoveElements_FixedDoubleArray_0(state_, TNode<FixedDoubleArray>{tmp43}, TNode<Smi>{tmp40}, TNode<Smi>{tmp41}, TNode<Smi>{tmp42});
    TNode<FixedDoubleArray> tmp44;
    USE(tmp44);
    tmp44 = UnsafeCast_FixedDoubleArray_0(state_, TNode<Context>{tmp29}, TNode<Object>{tmp39});
    StoreHoles_FixedDoubleArray_0(state_, TNode<FixedDoubleArray>{tmp44}, TNode<Smi>{tmp35}, TNode<Smi>{tmp34});
    ca_.Goto(&block6, tmp29, tmp30, tmp31, tmp32, tmp33, tmp34, tmp35, tmp36, tmp37, tmp38, tmp39, tmp40, tmp41, tmp42);
  }

  if (block5.is_used()) {
    TNode<Context> tmp45;
    TNode<RawPtrT> tmp46;
    TNode<RawPtrT> tmp47;
    TNode<IntPtrT> tmp48;
    TNode<JSArray> tmp49;
    TNode<Smi> tmp50;
    TNode<Smi> tmp51;
    TNode<Smi> tmp52;
    TNode<Smi> tmp53;
    TNode<Smi> tmp54;
    TNode<FixedArrayBase> tmp55;
    TNode<Smi> tmp56;
    TNode<Smi> tmp57;
    TNode<Smi> tmp58;
    ca_.Bind(&block5, &tmp45, &tmp46, &tmp47, &tmp48, &tmp49, &tmp50, &tmp51, &tmp52, &tmp53, &tmp54, &tmp55, &tmp56, &tmp57, &tmp58);
    TNode<BoolT> tmp59;
    USE(tmp59);
    tmp59 = CodeStubAssembler(state_).SmiGreaterThan(TNode<Smi>{tmp53}, TNode<Smi>{tmp54});
    ca_.Branch(tmp59, &block7, &block8, tmp45, tmp46, tmp47, tmp48, tmp49, tmp50, tmp51, tmp52, tmp53, tmp54, tmp55, tmp56, tmp57, tmp58);
  }

  if (block7.is_used()) {
    TNode<Context> tmp60;
    TNode<RawPtrT> tmp61;
    TNode<RawPtrT> tmp62;
    TNode<IntPtrT> tmp63;
    TNode<JSArray> tmp64;
    TNode<Smi> tmp65;
    TNode<Smi> tmp66;
    TNode<Smi> tmp67;
    TNode<Smi> tmp68;
    TNode<Smi> tmp69;
    TNode<FixedArrayBase> tmp70;
    TNode<Smi> tmp71;
    TNode<Smi> tmp72;
    TNode<Smi> tmp73;
    ca_.Bind(&block7, &tmp60, &tmp61, &tmp62, &tmp63, &tmp64, &tmp65, &tmp66, &tmp67, &tmp68, &tmp69, &tmp70, &tmp71, &tmp72, &tmp73);
    TNode<IntPtrT> tmp74;
    USE(tmp74);
    tmp74 = FromConstexpr_intptr_constexpr_int31_0(state_, 8);
    TNode<Smi>tmp75 = CodeStubAssembler(state_).LoadReference<Smi>(CodeStubAssembler::Reference{tmp70, tmp74});
    TNode<BoolT> tmp76;
    USE(tmp76);
    tmp76 = CodeStubAssembler(state_).SmiLessThanOrEqual(TNode<Smi>{tmp66}, TNode<Smi>{tmp75});
    ca_.Branch(tmp76, &block9, &block10, tmp60, tmp61, tmp62, tmp63, tmp64, tmp65, tmp66, tmp67, tmp68, tmp69, tmp70, tmp71, tmp72, tmp73);
  }

  if (block9.is_used()) {
    TNode<Context> tmp77;
    TNode<RawPtrT> tmp78;
    TNode<RawPtrT> tmp79;
    TNode<IntPtrT> tmp80;
    TNode<JSArray> tmp81;
    TNode<Smi> tmp82;
    TNode<Smi> tmp83;
    TNode<Smi> tmp84;
    TNode<Smi> tmp85;
    TNode<Smi> tmp86;
    TNode<FixedArrayBase> tmp87;
    TNode<Smi> tmp88;
    TNode<Smi> tmp89;
    TNode<Smi> tmp90;
    ca_.Bind(&block9, &tmp77, &tmp78, &tmp79, &tmp80, &tmp81, &tmp82, &tmp83, &tmp84, &tmp85, &tmp86, &tmp87, &tmp88, &tmp89, &tmp90);
    TNode<FixedDoubleArray> tmp91;
    USE(tmp91);
    tmp91 = UnsafeCast_FixedDoubleArray_0(state_, TNode<Context>{tmp77}, TNode<Object>{tmp87});
    DoMoveElements_FixedDoubleArray_0(state_, TNode<FixedDoubleArray>{tmp91}, TNode<Smi>{tmp88}, TNode<Smi>{tmp89}, TNode<Smi>{tmp90});
    ca_.Goto(&block11, tmp77, tmp78, tmp79, tmp80, tmp81, tmp82, tmp83, tmp84, tmp85, tmp86, tmp87, tmp88, tmp89, tmp90);
  }

  if (block10.is_used()) {
    TNode<Context> tmp92;
    TNode<RawPtrT> tmp93;
    TNode<RawPtrT> tmp94;
    TNode<IntPtrT> tmp95;
    TNode<JSArray> tmp96;
    TNode<Smi> tmp97;
    TNode<Smi> tmp98;
    TNode<Smi> tmp99;
    TNode<Smi> tmp100;
    TNode<Smi> tmp101;
    TNode<FixedArrayBase> tmp102;
    TNode<Smi> tmp103;
    TNode<Smi> tmp104;
    TNode<Smi> tmp105;
    ca_.Bind(&block10, &tmp92, &tmp93, &tmp94, &tmp95, &tmp96, &tmp97, &tmp98, &tmp99, &tmp100, &tmp101, &tmp102, &tmp103, &tmp104, &tmp105);
    TNode<Smi> tmp106;
    USE(tmp106);
    tmp106 = CodeStubAssembler(state_).CalculateNewElementsCapacity(TNode<Smi>{tmp98});
    TNode<Smi> tmp107;
    USE(tmp107);
    tmp107 = FromConstexpr_Smi_constexpr_int31_0(state_, 0);
    TNode<FixedArrayBase> tmp108;
    USE(tmp108);
    tmp108 = Extract_1(state_, TNode<Context>{tmp92}, TNode<FixedArrayBase>{tmp102}, TNode<Smi>{tmp107}, TNode<Smi>{tmp99}, TNode<Smi>{tmp106});
    TNode<FixedDoubleArray> tmp109;
    USE(tmp109);
    tmp109 = UnsafeCast_FixedDoubleArray_0(state_, TNode<Context>{tmp92}, TNode<Object>{tmp108});
    TNode<IntPtrT> tmp110;
    USE(tmp110);
    tmp110 = FromConstexpr_intptr_constexpr_int31_0(state_, 16);
    CodeStubAssembler(state_).StoreReference<FixedArrayBase>(CodeStubAssembler::Reference{tmp96, tmp110}, tmp109);
    TNode<IntPtrT> tmp111;
    USE(tmp111);
    tmp111 = FromConstexpr_intptr_constexpr_int31_0(state_, 8);
    TNode<Smi>tmp112 = CodeStubAssembler(state_).LoadReference<Smi>(CodeStubAssembler::Reference{tmp102, tmp111});
    TNode<Smi> tmp113;
    USE(tmp113);
    tmp113 = FromConstexpr_Smi_constexpr_int31_0(state_, 0);
    TNode<BoolT> tmp114;
    USE(tmp114);
    tmp114 = CodeStubAssembler(state_).SmiGreaterThan(TNode<Smi>{tmp112}, TNode<Smi>{tmp113});
    ca_.Branch(tmp114, &block12, &block13, tmp92, tmp93, tmp94, tmp95, tmp96, tmp97, tmp98, tmp99, tmp100, tmp101, tmp102, tmp103, tmp104, tmp105, tmp106, tmp109);
  }

  if (block12.is_used()) {
    TNode<Context> tmp115;
    TNode<RawPtrT> tmp116;
    TNode<RawPtrT> tmp117;
    TNode<IntPtrT> tmp118;
    TNode<JSArray> tmp119;
    TNode<Smi> tmp120;
    TNode<Smi> tmp121;
    TNode<Smi> tmp122;
    TNode<Smi> tmp123;
    TNode<Smi> tmp124;
    TNode<FixedArrayBase> tmp125;
    TNode<Smi> tmp126;
    TNode<Smi> tmp127;
    TNode<Smi> tmp128;
    TNode<Smi> tmp129;
    TNode<FixedDoubleArray> tmp130;
    ca_.Bind(&block12, &tmp115, &tmp116, &tmp117, &tmp118, &tmp119, &tmp120, &tmp121, &tmp122, &tmp123, &tmp124, &tmp125, &tmp126, &tmp127, &tmp128, &tmp129, &tmp130);
    TNode<FixedDoubleArray> tmp131;
    USE(tmp131);
    tmp131 = UnsafeCast_FixedDoubleArray_0(state_, TNode<Context>{tmp115}, TNode<Object>{tmp125});
    DoCopyElements_FixedDoubleArray_0(state_, TNode<FixedDoubleArray>{tmp130}, TNode<Smi>{tmp126}, TNode<FixedDoubleArray>{tmp131}, TNode<Smi>{tmp127}, TNode<Smi>{tmp128});
    ca_.Goto(&block13, tmp115, tmp116, tmp117, tmp118, tmp119, tmp120, tmp121, tmp122, tmp123, tmp124, tmp125, tmp126, tmp127, tmp128, tmp129, tmp130);
  }

  if (block13.is_used()) {
    TNode<Context> tmp132;
    TNode<RawPtrT> tmp133;
    TNode<RawPtrT> tmp134;
    TNode<IntPtrT> tmp135;
    TNode<JSArray> tmp136;
    TNode<Smi> tmp137;
    TNode<Smi> tmp138;
    TNode<Smi> tmp139;
    TNode<Smi> tmp140;
    TNode<Smi> tmp141;
    TNode<FixedArrayBase> tmp142;
    TNode<Smi> tmp143;
    TNode<Smi> tmp144;
    TNode<Smi> tmp145;
    TNode<Smi> tmp146;
    TNode<FixedDoubleArray> tmp147;
    ca_.Bind(&block13, &tmp132, &tmp133, &tmp134, &tmp135, &tmp136, &tmp137, &tmp138, &tmp139, &tmp140, &tmp141, &tmp142, &tmp143, &tmp144, &tmp145, &tmp146, &tmp147);
    ca_.Goto(&block11, tmp132, tmp133, tmp134, tmp135, tmp136, tmp137, tmp138, tmp139, tmp140, tmp141, tmp142, tmp143, tmp144, tmp145);
  }

  if (block11.is_used()) {
    TNode<Context> tmp148;
    TNode<RawPtrT> tmp149;
    TNode<RawPtrT> tmp150;
    TNode<IntPtrT> tmp151;
    TNode<JSArray> tmp152;
    TNode<Smi> tmp153;
    TNode<Smi> tmp154;
    TNode<Smi> tmp155;
    TNode<Smi> tmp156;
    TNode<Smi> tmp157;
    TNode<FixedArrayBase> tmp158;
    TNode<Smi> tmp159;
    TNode<Smi> tmp160;
    TNode<Smi> tmp161;
    ca_.Bind(&block11, &tmp148, &tmp149, &tmp150, &tmp151, &tmp152, &tmp153, &tmp154, &tmp155, &tmp156, &tmp157, &tmp158, &tmp159, &tmp160, &tmp161);
    ca_.Goto(&block8, tmp148, tmp149, tmp150, tmp151, tmp152, tmp153, tmp154, tmp155, tmp156, tmp157, tmp158, tmp159, tmp160, tmp161);
  }

  if (block8.is_used()) {
    TNode<Context> tmp162;
    TNode<RawPtrT> tmp163;
    TNode<RawPtrT> tmp164;
    TNode<IntPtrT> tmp165;
    TNode<JSArray> tmp166;
    TNode<Smi> tmp167;
    TNode<Smi> tmp168;
    TNode<Smi> tmp169;
    TNode<Smi> tmp170;
    TNode<Smi> tmp171;
    TNode<FixedArrayBase> tmp172;
    TNode<Smi> tmp173;
    TNode<Smi> tmp174;
    TNode<Smi> tmp175;
    ca_.Bind(&block8, &tmp162, &tmp163, &tmp164, &tmp165, &tmp166, &tmp167, &tmp168, &tmp169, &tmp170, &tmp171, &tmp172, &tmp173, &tmp174, &tmp175);
    ca_.Goto(&block6, tmp162, tmp163, tmp164, tmp165, tmp166, tmp167, tmp168, tmp169, tmp170, tmp171, tmp172, tmp173, tmp174, tmp175);
  }

  if (block6.is_used()) {
    TNode<Context> tmp176;
    TNode<RawPtrT> tmp177;
    TNode<RawPtrT> tmp178;
    TNode<IntPtrT> tmp179;
    TNode<JSArray> tmp180;
    TNode<Smi> tmp181;
    TNode<Smi> tmp182;
    TNode<Smi> tmp183;
    TNode<Smi> tmp184;
    TNode<Smi> tmp185;
    TNode<FixedArrayBase> tmp186;
    TNode<Smi> tmp187;
    TNode<Smi> tmp188;
    TNode<Smi> tmp189;
    ca_.Bind(&block6, &tmp176, &tmp177, &tmp178, &tmp179, &tmp180, &tmp181, &tmp182, &tmp183, &tmp184, &tmp185, &tmp186, &tmp187, &tmp188, &tmp189);
    ca_.Goto(&block3, tmp176, tmp177, tmp178, tmp179, tmp180, tmp181, tmp182, tmp183, tmp184, tmp185);
  }

  if (block3.is_used()) {
    TNode<Context> tmp190;
    TNode<RawPtrT> tmp191;
    TNode<RawPtrT> tmp192;
    TNode<IntPtrT> tmp193;
    TNode<JSArray> tmp194;
    TNode<Smi> tmp195;
    TNode<Smi> tmp196;
    TNode<Smi> tmp197;
    TNode<Smi> tmp198;
    TNode<Smi> tmp199;
    ca_.Bind(&block3, &tmp190, &tmp191, &tmp192, &tmp193, &tmp194, &tmp195, &tmp196, &tmp197, &tmp198, &tmp199);
    TNode<Smi> tmp200;
    USE(tmp200);
    tmp200 = FromConstexpr_Smi_constexpr_int31_0(state_, 0);
    TNode<BoolT> tmp201;
    USE(tmp201);
    tmp201 = CodeStubAssembler(state_).SmiGreaterThan(TNode<Smi>{tmp198}, TNode<Smi>{tmp200});
    ca_.Branch(tmp201, &block14, &block15, tmp190, tmp191, tmp192, tmp193, tmp194, tmp195, tmp196, tmp197, tmp198, tmp199, tmp197);
  }

  if (block14.is_used()) {
    TNode<Context> tmp202;
    TNode<RawPtrT> tmp203;
    TNode<RawPtrT> tmp204;
    TNode<IntPtrT> tmp205;
    TNode<JSArray> tmp206;
    TNode<Smi> tmp207;
    TNode<Smi> tmp208;
    TNode<Smi> tmp209;
    TNode<Smi> tmp210;
    TNode<Smi> tmp211;
    TNode<Smi> tmp212;
    ca_.Bind(&block14, &tmp202, &tmp203, &tmp204, &tmp205, &tmp206, &tmp207, &tmp208, &tmp209, &tmp210, &tmp211, &tmp212);
    TNode<IntPtrT> tmp213;
    USE(tmp213);
    tmp213 = FromConstexpr_intptr_constexpr_int31_0(state_, 16);
    TNode<FixedArrayBase>tmp214 = CodeStubAssembler(state_).LoadReference<FixedArrayBase>(CodeStubAssembler::Reference{tmp206, tmp213});
    TNode<FixedDoubleArray> tmp215;
    USE(tmp215);
    tmp215 = UnsafeCast_FixedDoubleArray_0(state_, TNode<Context>{tmp202}, TNode<Object>{tmp214});
    TNode<IntPtrT> tmp216;
    USE(tmp216);
    tmp216 = FromConstexpr_intptr_constexpr_int31_0(state_, 2);
    ca_.Goto(&block18, tmp202, tmp203, tmp204, tmp205, tmp206, tmp207, tmp208, tmp209, tmp210, tmp211, tmp212, tmp215, tmp216);
  }

  if (block18.is_used()) {
    TNode<Context> tmp217;
    TNode<RawPtrT> tmp218;
    TNode<RawPtrT> tmp219;
    TNode<IntPtrT> tmp220;
    TNode<JSArray> tmp221;
    TNode<Smi> tmp222;
    TNode<Smi> tmp223;
    TNode<Smi> tmp224;
    TNode<Smi> tmp225;
    TNode<Smi> tmp226;
    TNode<Smi> tmp227;
    TNode<FixedDoubleArray> tmp228;
    TNode<IntPtrT> tmp229;
    ca_.Bind(&block18, &tmp217, &tmp218, &tmp219, &tmp220, &tmp221, &tmp222, &tmp223, &tmp224, &tmp225, &tmp226, &tmp227, &tmp228, &tmp229);
    TNode<BoolT> tmp230;
    USE(tmp230);
    tmp230 = CodeStubAssembler(state_).IntPtrLessThan(TNode<IntPtrT>{tmp229}, TNode<IntPtrT>{tmp220});
    ca_.Branch(tmp230, &block16, &block17, tmp217, tmp218, tmp219, tmp220, tmp221, tmp222, tmp223, tmp224, tmp225, tmp226, tmp227, tmp228, tmp229);
  }

  if (block16.is_used()) {
    TNode<Context> tmp231;
    TNode<RawPtrT> tmp232;
    TNode<RawPtrT> tmp233;
    TNode<IntPtrT> tmp234;
    TNode<JSArray> tmp235;
    TNode<Smi> tmp236;
    TNode<Smi> tmp237;
    TNode<Smi> tmp238;
    TNode<Smi> tmp239;
    TNode<Smi> tmp240;
    TNode<Smi> tmp241;
    TNode<FixedDoubleArray> tmp242;
    TNode<IntPtrT> tmp243;
    ca_.Bind(&block16, &tmp231, &tmp232, &tmp233, &tmp234, &tmp235, &tmp236, &tmp237, &tmp238, &tmp239, &tmp240, &tmp241, &tmp242, &tmp243);
    TNode<Object> tmp244;
    USE(tmp244);
    tmp244 = CodeStubAssembler(state_).GetArgumentValue(TorqueStructArguments{TNode<RawPtrT>{tmp232}, TNode<RawPtrT>{tmp233}, TNode<IntPtrT>{tmp234}}, TNode<IntPtrT>{tmp243});
    TNode<Smi> tmp245;
    USE(tmp245);
    tmp245 = FromConstexpr_Smi_constexpr_int31_0(state_, 1);
    TNode<Smi> tmp246;
    USE(tmp246);
    tmp246 = CodeStubAssembler(state_).SmiAdd(TNode<Smi>{tmp241}, TNode<Smi>{tmp245});
    TNode<Number> tmp247;
    USE(tmp247);
    tmp247 = UnsafeCast_Number_0(state_, TNode<Context>{tmp231}, TNode<Object>{tmp244});
    StoreFixedDoubleArrayDirect_0(state_, TNode<FixedDoubleArray>{tmp242}, TNode<Smi>{tmp241}, TNode<Number>{tmp247});
    TNode<IntPtrT> tmp248;
    USE(tmp248);
    tmp248 = FromConstexpr_intptr_constexpr_int31_0(state_, 1);
    TNode<IntPtrT> tmp249;
    USE(tmp249);
    tmp249 = CodeStubAssembler(state_).IntPtrAdd(TNode<IntPtrT>{tmp243}, TNode<IntPtrT>{tmp248});
    ca_.Goto(&block18, tmp231, tmp232, tmp233, tmp234, tmp235, tmp236, tmp237, tmp238, tmp239, tmp240, tmp246, tmp242, tmp249);
  }

  if (block17.is_used()) {
    TNode<Context> tmp250;
    TNode<RawPtrT> tmp251;
    TNode<RawPtrT> tmp252;
    TNode<IntPtrT> tmp253;
    TNode<JSArray> tmp254;
    TNode<Smi> tmp255;
    TNode<Smi> tmp256;
    TNode<Smi> tmp257;
    TNode<Smi> tmp258;
    TNode<Smi> tmp259;
    TNode<Smi> tmp260;
    TNode<FixedDoubleArray> tmp261;
    TNode<IntPtrT> tmp262;
    ca_.Bind(&block17, &tmp250, &tmp251, &tmp252, &tmp253, &tmp254, &tmp255, &tmp256, &tmp257, &tmp258, &tmp259, &tmp260, &tmp261, &tmp262);
    ca_.Goto(&block15, tmp250, tmp251, tmp252, tmp253, tmp254, tmp255, tmp256, tmp257, tmp258, tmp259, tmp260);
  }

  if (block15.is_used()) {
    TNode<Context> tmp263;
    TNode<RawPtrT> tmp264;
    TNode<RawPtrT> tmp265;
    TNode<IntPtrT> tmp266;
    TNode<JSArray> tmp267;
    TNode<Smi> tmp268;
    TNode<Smi> tmp269;
    TNode<Smi> tmp270;
    TNode<Smi> tmp271;
    TNode<Smi> tmp272;
    TNode<Smi> tmp273;
    ca_.Bind(&block15, &tmp263, &tmp264, &tmp265, &tmp266, &tmp267, &tmp268, &tmp269, &tmp270, &tmp271, &tmp272, &tmp273);
    TNode<IntPtrT> tmp274;
    USE(tmp274);
    tmp274 = FromConstexpr_intptr_constexpr_int31_0(state_, 24);
    CodeStubAssembler(state_).StoreReference<Number>(CodeStubAssembler::Reference{tmp267, tmp274}, tmp269);
    ca_.Goto(&block20, tmp263, tmp264, tmp265, tmp266, tmp267, tmp268, tmp269, tmp270, tmp271, tmp272);
  }

    TNode<Context> tmp275;
    TNode<RawPtrT> tmp276;
    TNode<RawPtrT> tmp277;
    TNode<IntPtrT> tmp278;
    TNode<JSArray> tmp279;
    TNode<Smi> tmp280;
    TNode<Smi> tmp281;
    TNode<Smi> tmp282;
    TNode<Smi> tmp283;
    TNode<Smi> tmp284;
    ca_.Bind(&block20, &tmp275, &tmp276, &tmp277, &tmp278, &tmp279, &tmp280, &tmp281, &tmp282, &tmp283, &tmp284);
}

void DoMoveElements_FixedArray_0(compiler::CodeAssemblerState* state_, TNode<FixedArray> p_elements, TNode<Smi> p_dstIndex, TNode<Smi> p_srcIndex, TNode<Smi> p_count) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<FixedArray, Smi, Smi, Smi> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<FixedArray, Smi, Smi, Smi> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_elements, p_dstIndex, p_srcIndex, p_count);

  if (block0.is_used()) {
    TNode<FixedArray> tmp0;
    TNode<Smi> tmp1;
    TNode<Smi> tmp2;
    TNode<Smi> tmp3;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3);
    TNode<IntPtrT> tmp4;
    USE(tmp4);
    tmp4 = Convert_intptr_Smi_0(state_, TNode<Smi>{tmp1});
    TNode<IntPtrT> tmp5;
    USE(tmp5);
    tmp5 = Convert_intptr_Smi_0(state_, TNode<Smi>{tmp2});
    TNode<IntPtrT> tmp6;
    USE(tmp6);
    tmp6 = Convert_intptr_Smi_0(state_, TNode<Smi>{tmp3});
    TorqueMoveElements_0(state_, TNode<FixedArray>{tmp0}, TNode<IntPtrT>{tmp4}, TNode<IntPtrT>{tmp5}, TNode<IntPtrT>{tmp6});
    ca_.Goto(&block2, tmp0, tmp1, tmp2, tmp3);
  }

    TNode<FixedArray> tmp7;
    TNode<Smi> tmp8;
    TNode<Smi> tmp9;
    TNode<Smi> tmp10;
    ca_.Bind(&block2, &tmp7, &tmp8, &tmp9, &tmp10);
}

void StoreHoles_FixedArray_0(compiler::CodeAssemblerState* state_, TNode<FixedArray> p_elements, TNode<Smi> p_holeStartIndex, TNode<Smi> p_holeEndIndex) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<FixedArray, Smi, Smi> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<FixedArray, Smi, Smi, Smi> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<FixedArray, Smi, Smi, Smi> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<FixedArray, Smi, Smi, Smi> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<FixedArray, Smi, Smi> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_elements, p_holeStartIndex, p_holeEndIndex);

  if (block0.is_used()) {
    TNode<FixedArray> tmp0;
    TNode<Smi> tmp1;
    TNode<Smi> tmp2;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2);
    ca_.Goto(&block4, tmp0, tmp1, tmp2, tmp1);
  }

  if (block4.is_used()) {
    TNode<FixedArray> tmp3;
    TNode<Smi> tmp4;
    TNode<Smi> tmp5;
    TNode<Smi> tmp6;
    ca_.Bind(&block4, &tmp3, &tmp4, &tmp5, &tmp6);
    TNode<BoolT> tmp7;
    USE(tmp7);
    tmp7 = CodeStubAssembler(state_).SmiLessThan(TNode<Smi>{tmp6}, TNode<Smi>{tmp5});
    ca_.Branch(tmp7, &block2, &block3, tmp3, tmp4, tmp5, tmp6);
  }

  if (block2.is_used()) {
    TNode<FixedArray> tmp8;
    TNode<Smi> tmp9;
    TNode<Smi> tmp10;
    TNode<Smi> tmp11;
    ca_.Bind(&block2, &tmp8, &tmp9, &tmp10, &tmp11);
    StoreArrayHole_1(state_, TNode<FixedArray>{tmp8}, TNode<Smi>{tmp11});
    TNode<Smi> tmp12;
    USE(tmp12);
    tmp12 = FromConstexpr_Smi_constexpr_int31_0(state_, 1);
    TNode<Smi> tmp13;
    USE(tmp13);
    tmp13 = CodeStubAssembler(state_).SmiAdd(TNode<Smi>{tmp11}, TNode<Smi>{tmp12});
    ca_.Goto(&block4, tmp8, tmp9, tmp10, tmp13);
  }

  if (block3.is_used()) {
    TNode<FixedArray> tmp14;
    TNode<Smi> tmp15;
    TNode<Smi> tmp16;
    TNode<Smi> tmp17;
    ca_.Bind(&block3, &tmp14, &tmp15, &tmp16, &tmp17);
    ca_.Goto(&block6, tmp14, tmp15, tmp16);
  }

    TNode<FixedArray> tmp18;
    TNode<Smi> tmp19;
    TNode<Smi> tmp20;
    ca_.Bind(&block6, &tmp18, &tmp19, &tmp20);
}

void DoCopyElements_FixedArray_0(compiler::CodeAssemblerState* state_, TNode<FixedArray> p_dstElements, TNode<Smi> p_dstIndex, TNode<FixedArray> p_srcElements, TNode<Smi> p_srcIndex, TNode<Smi> p_count) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<FixedArray, Smi, FixedArray, Smi, Smi> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<FixedArray, Smi, FixedArray, Smi, Smi> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_dstElements, p_dstIndex, p_srcElements, p_srcIndex, p_count);

  if (block0.is_used()) {
    TNode<FixedArray> tmp0;
    TNode<Smi> tmp1;
    TNode<FixedArray> tmp2;
    TNode<Smi> tmp3;
    TNode<Smi> tmp4;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4);
    TNode<IntPtrT> tmp5;
    USE(tmp5);
    tmp5 = Convert_intptr_Smi_0(state_, TNode<Smi>{tmp1});
    TNode<IntPtrT> tmp6;
    USE(tmp6);
    tmp6 = Convert_intptr_Smi_0(state_, TNode<Smi>{tmp3});
    TNode<IntPtrT> tmp7;
    USE(tmp7);
    tmp7 = Convert_intptr_Smi_0(state_, TNode<Smi>{tmp4});
    TorqueCopyElements_0(state_, TNode<FixedArray>{tmp0}, TNode<IntPtrT>{tmp5}, TNode<FixedArray>{tmp2}, TNode<IntPtrT>{tmp6}, TNode<IntPtrT>{tmp7});
    ca_.Goto(&block2, tmp0, tmp1, tmp2, tmp3, tmp4);
  }

    TNode<FixedArray> tmp8;
    TNode<Smi> tmp9;
    TNode<FixedArray> tmp10;
    TNode<Smi> tmp11;
    TNode<Smi> tmp12;
    ca_.Bind(&block2, &tmp8, &tmp9, &tmp10, &tmp11, &tmp12);
}

TNode<FixedArrayBase> UnsafeCast_EmptyFixedArray_OR_FixedDoubleArray_0(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TNode<Object> p_o) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, Object> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object> block5(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, FixedArrayBase> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_o);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<Object> tmp1;
    ca_.Bind(&block0, &tmp0, &tmp1);
    TNode<FixedArrayBase> tmp2;
    USE(tmp2);
    tmp2 = TORQUE_CAST(TNode<Object>{tmp1});
    ca_.Goto(&block6, tmp0, tmp1, tmp2);
  }

  if (block5.is_used()) {
    TNode<Context> tmp3;
    TNode<Object> tmp4;
    ca_.Bind(&block5, &tmp3, &tmp4);
    CodeStubAssembler(state_).FailAssert("Torque assert 'Is<A>(o)' failed", "../../deps/v8/src/builtins/base.tq", 887);
  }

  if (block4.is_used()) {
    TNode<Context> tmp5;
    TNode<Object> tmp6;
    ca_.Bind(&block4, &tmp5, &tmp6);
  }

    TNode<Context> tmp7;
    TNode<Object> tmp8;
    TNode<FixedArrayBase> tmp9;
    ca_.Bind(&block6, &tmp7, &tmp8, &tmp9);
  return TNode<FixedArrayBase>{tmp9};
}

void DoMoveElements_FixedDoubleArray_0(compiler::CodeAssemblerState* state_, TNode<FixedDoubleArray> p_elements, TNode<Smi> p_dstIndex, TNode<Smi> p_srcIndex, TNode<Smi> p_count) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<FixedDoubleArray, Smi, Smi, Smi> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<FixedDoubleArray, Smi, Smi, Smi> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_elements, p_dstIndex, p_srcIndex, p_count);

  if (block0.is_used()) {
    TNode<FixedDoubleArray> tmp0;
    TNode<Smi> tmp1;
    TNode<Smi> tmp2;
    TNode<Smi> tmp3;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3);
    TNode<IntPtrT> tmp4;
    USE(tmp4);
    tmp4 = Convert_intptr_Smi_0(state_, TNode<Smi>{tmp1});
    TNode<IntPtrT> tmp5;
    USE(tmp5);
    tmp5 = Convert_intptr_Smi_0(state_, TNode<Smi>{tmp2});
    TNode<IntPtrT> tmp6;
    USE(tmp6);
    tmp6 = Convert_intptr_Smi_0(state_, TNode<Smi>{tmp3});
    TorqueMoveElements_1(state_, TNode<FixedDoubleArray>{tmp0}, TNode<IntPtrT>{tmp4}, TNode<IntPtrT>{tmp5}, TNode<IntPtrT>{tmp6});
    ca_.Goto(&block2, tmp0, tmp1, tmp2, tmp3);
  }

    TNode<FixedDoubleArray> tmp7;
    TNode<Smi> tmp8;
    TNode<Smi> tmp9;
    TNode<Smi> tmp10;
    ca_.Bind(&block2, &tmp7, &tmp8, &tmp9, &tmp10);
}

void StoreHoles_FixedDoubleArray_0(compiler::CodeAssemblerState* state_, TNode<FixedDoubleArray> p_elements, TNode<Smi> p_holeStartIndex, TNode<Smi> p_holeEndIndex) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<FixedDoubleArray, Smi, Smi> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<FixedDoubleArray, Smi, Smi, Smi> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<FixedDoubleArray, Smi, Smi, Smi> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<FixedDoubleArray, Smi, Smi, Smi> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<FixedDoubleArray, Smi, Smi> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_elements, p_holeStartIndex, p_holeEndIndex);

  if (block0.is_used()) {
    TNode<FixedDoubleArray> tmp0;
    TNode<Smi> tmp1;
    TNode<Smi> tmp2;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2);
    ca_.Goto(&block4, tmp0, tmp1, tmp2, tmp1);
  }

  if (block4.is_used()) {
    TNode<FixedDoubleArray> tmp3;
    TNode<Smi> tmp4;
    TNode<Smi> tmp5;
    TNode<Smi> tmp6;
    ca_.Bind(&block4, &tmp3, &tmp4, &tmp5, &tmp6);
    TNode<BoolT> tmp7;
    USE(tmp7);
    tmp7 = CodeStubAssembler(state_).SmiLessThan(TNode<Smi>{tmp6}, TNode<Smi>{tmp5});
    ca_.Branch(tmp7, &block2, &block3, tmp3, tmp4, tmp5, tmp6);
  }

  if (block2.is_used()) {
    TNode<FixedDoubleArray> tmp8;
    TNode<Smi> tmp9;
    TNode<Smi> tmp10;
    TNode<Smi> tmp11;
    ca_.Bind(&block2, &tmp8, &tmp9, &tmp10, &tmp11);
    StoreArrayHole_0(state_, TNode<FixedDoubleArray>{tmp8}, TNode<Smi>{tmp11});
    TNode<Smi> tmp12;
    USE(tmp12);
    tmp12 = FromConstexpr_Smi_constexpr_int31_0(state_, 1);
    TNode<Smi> tmp13;
    USE(tmp13);
    tmp13 = CodeStubAssembler(state_).SmiAdd(TNode<Smi>{tmp11}, TNode<Smi>{tmp12});
    ca_.Goto(&block4, tmp8, tmp9, tmp10, tmp13);
  }

  if (block3.is_used()) {
    TNode<FixedDoubleArray> tmp14;
    TNode<Smi> tmp15;
    TNode<Smi> tmp16;
    TNode<Smi> tmp17;
    ca_.Bind(&block3, &tmp14, &tmp15, &tmp16, &tmp17);
    ca_.Goto(&block6, tmp14, tmp15, tmp16);
  }

    TNode<FixedDoubleArray> tmp18;
    TNode<Smi> tmp19;
    TNode<Smi> tmp20;
    ca_.Bind(&block6, &tmp18, &tmp19, &tmp20);
}

void DoCopyElements_FixedDoubleArray_0(compiler::CodeAssemblerState* state_, TNode<FixedDoubleArray> p_dstElements, TNode<Smi> p_dstIndex, TNode<FixedDoubleArray> p_srcElements, TNode<Smi> p_srcIndex, TNode<Smi> p_count) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<FixedDoubleArray, Smi, FixedDoubleArray, Smi, Smi> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<FixedDoubleArray, Smi, FixedDoubleArray, Smi, Smi> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_dstElements, p_dstIndex, p_srcElements, p_srcIndex, p_count);

  if (block0.is_used()) {
    TNode<FixedDoubleArray> tmp0;
    TNode<Smi> tmp1;
    TNode<FixedDoubleArray> tmp2;
    TNode<Smi> tmp3;
    TNode<Smi> tmp4;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4);
    TNode<IntPtrT> tmp5;
    USE(tmp5);
    tmp5 = Convert_intptr_Smi_0(state_, TNode<Smi>{tmp1});
    TNode<IntPtrT> tmp6;
    USE(tmp6);
    tmp6 = Convert_intptr_Smi_0(state_, TNode<Smi>{tmp3});
    TNode<IntPtrT> tmp7;
    USE(tmp7);
    tmp7 = Convert_intptr_Smi_0(state_, TNode<Smi>{tmp4});
    TorqueCopyElements_1(state_, TNode<FixedDoubleArray>{tmp0}, TNode<IntPtrT>{tmp5}, TNode<FixedDoubleArray>{tmp2}, TNode<IntPtrT>{tmp6}, TNode<IntPtrT>{tmp7});
    ca_.Goto(&block2, tmp0, tmp1, tmp2, tmp3, tmp4);
  }

    TNode<FixedDoubleArray> tmp8;
    TNode<Smi> tmp9;
    TNode<FixedDoubleArray> tmp10;
    TNode<Smi> tmp11;
    TNode<Smi> tmp12;
    ca_.Bind(&block2, &tmp8, &tmp9, &tmp10, &tmp11, &tmp12);
}

}  // namespace internal
}  // namespace v8

